
unit HP12Cinicializa;

interface

uses  dvWin,
      dvCrt,
      HP12Cedarch,
      HP12Cvariables;

procedure inicializaConSom;
procedure inicializaSinSon;
procedure inicializaExemplos;
procedure FinHP12C;
Procedure LimpiaMenu;
procedure SinArchivo;

implementation

{------------------------Inicio de la Calculador-------------------------------}
procedure inicializaConSom;
begin
    clrscr;

    textColor (WHITE);    textBackground (BLUE);
    writeln (' ***** *****  *   *   ***   *   *  *   *   ***   *     *');
    writeln (' *       *    **  *  *   *  **  *  *   *  *   *   *   * ');
    writeln (' *       *    * * *  *   *  * * *  *   *  *   *    ***  ');
    writeln (' ****    *    *  **  *   *  *  **  *   *  *   *     *   ');
    writeln (' *       *    *   *  *****  *   *  *   *  *   *    ***  ');
    writeln (' *       *    *   *  *   *  *   *   * *   *   *   *   * ');
    writeln (' *     *****  *   *  *   *  *   *    *     **    *     *');

    textBackground (NCOLOR);   textColor (WHITE);
    gotoxy(60,3);
    writeln('FINANVOX - v.1.0');
    gotoxy(60,4);
    writeln('Autor: Paul Mejia C.');
    textBackground (BLACK);   textColor (WHITE);
    gotoxy(1,9);
    sintInic (0, dirSonidos);
    sintSom ('HPSALUDOINI');
end;

{-------------------Inicio de la Calculador Sin Sonido-------------------------}
procedure inicializaSinSon;
begin
    clrscr;
    NCOLOR:=4;
    textColor (WHITE);    textBackground (BLUE);
    writeln (' ***** *****  *   *   ***   *   *  *   *   ***   *     *');
    writeln (' *       *    **  *  *   *  **  *  *   *  *   *   *   * ');
    writeln (' *       *    * * *  *   *  * * *  *   *  *   *    ***  ');
    writeln (' ****    *    *  **  *   *  *  **  *   *  *   *     *   ');
    writeln (' *       *    *   *  *****  *   *  *   *  *   *    ***  ');
    writeln (' *       *    *   *  *   *  *   *   * *   *   *   *   * ');
    writeln (' *     *****  *   *  *   *  *   *    *     **    *     *');

    textBackground (NCOLOR);   textColor (WHITE);
    gotoxy(60,3);
    writeln('FINANVOX - v.1.0');
    gotoxy(60,4);
    writeln('Autor: Paul Mejia C.');
    textBackground (BLACK);   textColor (WHITE);
    gotoxy(1,9);
    textBackground (NCOLOR);   textColor (WHITE);
    gotoxy(30,9);
    writeln('  CALCULOS FEITOS  ');
    textBackground (BLACK);   textColor (WHITE);
    writeln('--------------------------------------------------------------------------------');
    gotoxy(1,11);
    sintInic (0,dirSonidos);
end;

{-------------------Inicio de la Calculador Sin Sonido-------------------------}
procedure inicializaExemplos;
begin

    textmode (co40);
    clrscr;

    textColor (WHITE);    textBackground (5);
    writeln (' ****** *****  *    *   ****   *    *  *    *   ****  *     *');
    writeln (' *        *    **   *  *    *  **   *  *    *  *    *  *   * ');
    writeln (' *        *    * *  *  *    *  * *  *  *    *  *    *   * *  ');
    writeln (' *****    *    *  * *  *    *  *  * *  *    *  *    *    *   ');
    writeln (' *        *    *   **  ******  *   **  *    *  *    *   * *  ');
    writeln (' *        *    *    *  *    *  *    *   *  *   *    *  *   * ');
    writeln (' *      *****  *    *  *    *  *    *    **     ****  *     *');

    textBackground (WHITE);   textColor (5);
    gotoxy(60,3);
    writeln('FINANVOX - v.1.0');
    gotoxy(60,4);
    writeln('Autor: Paul Mejia C.');

    gotoxy(65,6);
    textBackground (WHITE);   textColor (5);
    if TestTeclado then writeln(' T. TECLADO ')
                   else writeln(' EXEMPLOS ');

    gotoxy(1,9);
    textBackground (GREEN);   textColor (WHITE);
    gotoxy(30,9);

    if TestTeclado then begin
        writeln(' TESTE TECLADO ');
        gotoxy(1,11);
        write('     TECLA     ');
        gotoxy(26,11);
        write('     FUNO        ');
        gotoxy(60,11);
        writeln('   TIPO     ');
    end
    else
    begin
        if TEXEMPLO then writeln('  EXEMPLOS INTERATIVOS  ')
        else             writeln('  EXEMPLOS ILUSTRATIVOS  ');
    end;
    textBackground (BLACK);
    textColor (WHITE);
    sintInic (0,dirSonidos);
end;

{------------------------------Fin da Calculadora------------------------------}
procedure FinHP12C;
var
    c: char;
    i: integer;
begin


    for i := 9 to 50  do begin
        gotoxy (1, i);
        clreol;
    end;
    inicializaSinSon;
    textColor (WHITE);    textBackground (BLUE);
    write('CONFIRMA SAIDA (s/n)? ');
    sintSom('HPSALIDA');
    textColor (WHITE);    textBackground (BLACK);

    repeat
    c:= readkey;
    case c  of
          's':  begin
                  writeln(c);
                  sintCarac (c);
                  gotoxy (1, 12);
                  clreol;
                  textColor (WHITE);    textBackground (BLUE);
                  write('QUER SALVAR O ARQUIVO (s/n)? ');
                  sintsom('HParchsalva');
                  textColor (WHITE);    textBackground (BLACK);
                      repeat
                          c:= readkey;
                            case c of
                                's':  begin
                                        writeln(c);
                                        sintCarac (c);
                                        CopiaArchivoGrava;
                                        inicializaSinSon;
                                        if NoSaleESC=TRUE then begin
                                            NoSaleESC:=False;
                                            exit;
                                        end;
                                        gotoxy(28,11);
                                        textColor (WHITE);    textBackground (NCOLOR);
                                        writeln('!! ARQUIVO GRAVADO !! ');
                                        textColor (WHITE);    textBackground (Black);
                                        sintSom('HParchGrava');
                                      end;
                                'n':  begin
                                        writeln(c);
                                        sintCarac (c);
                                        erase(ArqCalculadora);
                                      end;
                                #$1b: begin
                                                delay(300);
                                                sintSom('HPRegresoCalc');
                                                inicializaSinSon;
                                                exit;
                                      end;
                            else
                                sintSom ('HPTECLAINV');
                           end;
                      until (c = 's') or (c = 'n');
                  delay(300);
                  gotoxy (1, 11);
                  clreol;
                  gotoxy (1, 12);
                  clreol;
                  gotoxy(26,11);
                  textColor (WHITE);    textBackground (BLUE);
                  Write('FIM DA CALCULADORA FINANVOX');
                  sintSom('HPSALUDOFIN');
                  halt;
                end;
          'n':  begin
                    write(c);
                    sintCarac (c);
                    delay(300);
                    sintSom('HPRegresoCalc');
                    inicializaSinSon;
                    exit;
                end;
          #$1b: begin
                    delay(300);
                    sintSom('HPRegresoCalc');
                    inicializaSinSon;
                    exit;
                end;
    else
              sintSom ('HPTECLAINV');
    end;

    until c = 's';
end;
{------------------------------------------------------------------------------}
Procedure LimpiaMenu;
Var
    i, posy: integer;

Begin
    posy:=10;
    For i := posy-4 To posy+9  Do
        begin
            gotoxy ( 40, 15 + (i-posy));
            textBackground (BLACK);
            clreol;
        end;
end;
{------------------------------------------------------------------------------}
procedure SinArchivo;
begin
     sintInic (0,dirSonidos);
     delay(300);
     gotoxy(1,9);
     clreol;
     gotoxy(26,9);
     textColor (WHITE);    textBackground (BLUE);
     Write('FIM DA CALCULADORA FINANVOX');
     SintSom('HPSALUDOFIN');
     doneWinCrt;
end;
{------------------------------------------------------------------------------}
end.
