unit HP12Cmemorias;

interface

uses
    dvWin,
    dvCrt,
    sysUtils,
    math,
    HP12Cedarch,
    HP12Creproduce,
    HP12Cvariables,
    HP12Cinicializa;

{------------------------------------------------------------------------------}

function almacenaesta(var veces: integer; var v1, v2: double; var memoria: Tarray; op: string): real;
function almacenafin(var veces: integer; var v1: double; var memoriafi: Tarray; op: string): real;
function recuperadatos: real;
function Almacenadatos(valor: real): boolean;
procedure almacenaFecha( op: string; var fecha: RFecha);
procedure poneCero(exp:string);

{------------------------------------------------------------------------------}



implementation
{------------------------------------------------------------------------------}
function almacenafin(var veces: integer; var v1: double{real}; var memoriafi: Tarray; op: string): real;

begin
                if( op='n' ) then begin    //n
                    memoriafi[1]:=v1;
                end;
                if( op=#14 ) then begin    //12X
                    memoriafi[1]:=v1*12;
                end;
                if( op='i' ) then begin    //i
                    memoriafi[2]:=v1/100;
                end;
                if( op=#9 ) then begin    //12X
                    memoriafi[2]:=v1/1200;
                end;
                if( op='p' ) then begin    //PV
                    memoriafi[3]:=v1;
                end;
                if( op='m' ) then begin    //PMT
                    memoriafi[4]:=v1;
                end;
                if( op='v' ) then begin    //FV
                   memoriafi[5]:=v1;
                end;
                if( op='o' ) then begin    //S
                   memoriafi[6]:=v1;
                end;

end;

{------------------------------------------------------------------------------}
function almacenaesta(var veces: integer; var v1, v2: double{real}; var memoria: Tarray; op: string): real;

begin
    if( op='z' ) then begin
        memoria[1]:= veces;
        memoria[2]:= memoria[2]+v1;      //x
        memoria[3]:=(memoria[3]+Sqr(v1));
        memoria[4]:= memoria[4]+v2;       //y
        memoria[5]:=(memoria[5]+Sqr(v2));
        memoria[6]:=(memoria[6]+(v2*v1));
    end;
    if( op='Z' ) then begin
        memoria[1]:= veces;
        memoria[2]:= memoria[2]-v1;      //x
        memoria[3]:=(memoria[3]-Sqr(v1));
        memoria[4]:= memoria[4]-v2;       //y
        memoria[5]:=(memoria[5]-Sqr(v2));
        memoria[6]:=(memoria[6]-(v2*v1));
    end;
    if( op=#26 ) then begin
        memoria[1]:= veces;
        memoria[2]:= memoria[2]-v1;      //x
        memoria[3]:=(memoria[3]-Sqr(v1));
        memoria[4]:= memoria[4]-v2;       //y
        memoria[5]:=(memoria[5]-Sqr(v2));
        memoria[6]:=(memoria[6]-(v2*v1));
    end;
    almacenaesta:=memoria[1];
end;

{------------------------------------------------------------------------------}
function recuperadatos: real;
var c: char;
    numero: integer;
begin
    c:=readkey;
    if (c in ['0'..'9','.','a','b','c','d','e','f','g','h']) or (c='n') or (c='i')
    or (c='p') or (c='m') or ( c='v' ) or ( c='k' ) then begin
        if( c='n' ) then begin
            mensajes(c);
            recuperadatos:=memoriafi[1];
        end;
        if( c='i' ) then begin
            mensajes(c);
            recuperadatos:=memoriafi[2]*100;
        end;
        if( c='p' ) then begin
            mensajes(c);
            recuperadatos:=memoriafi[3];
        end;
        if( c='m' ) then begin
            mensajes(c);
            recuperadatos:=memoriafi[4];
        end;
        if( c='v' ) then begin
            mensajes(c);
            recuperadatos:=memoriafi[5];
        end;
        if( c='k' ) then begin
            mensajes(c);
            recuperadatos:=memoriaNPV[vecesCFo-1];
        end;
        if c='.' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                write(c);
                sintSom('HPregistro');
                sintCarac ('.');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin recuperadatos:=memoriaTOTAL[20];
                end else recuperadatos:=memoriaTOTAL[10+numero];
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                NoRecupera:=true;
                exit;
            end else begin
            writeln;
            errores(6);
            NoRecupera:=true;
            exit;
            end;
        end else
        if c='a' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                write(c);
                sintSom('HPregistro');
                sintCarac ('a');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin recuperadatos:=memoriaTOTAL[30];
                end else recuperadatos:=memoriaTOTAL[20+numero];
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                NoRecupera:=true;
                exit;
            end else begin
            writeln;
            errores(6);
            NoRecupera:=true;
            exit;
            end;
        end else
        if c='b' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                write(c);
                sintSom('HPregistro');
                sintCarac ('b');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin recuperadatos:=memoriaTOTAL[40];
                end else recuperadatos:=memoriaTOTAL[30+numero];
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                NoRecupera:=true;
                exit;
            end else begin
            writeln;
            errores(6);
            NoRecupera:=true;
            exit;
            end;
        end else
        if c='c' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                write(c);
                sintSom('HPregistro');
                sintCarac ('c');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin recuperadatos:=memoriaTOTAL[50];
                end else recuperadatos:=memoriaTOTAL[40+numero];
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                NoRecupera:=true;
                exit;
            end else begin
            writeln;
            errores(6);
            NoRecupera:=true;
            exit;
            end;
        end else
        if c='d' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                write(c);
                sintSom('HPregistro');
                sintCarac ('d');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin recuperadatos:=memoriaTOTAL[60];
                end else recuperadatos:=memoriaTOTAL[50+numero];
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                NoRecupera:=true;
                exit;
            end else begin
            writeln;
            errores(6);
            NoRecupera:=true;
            exit;
            end;
        end else
        if c='e' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                write(c);
                sintSom('HPregistro');
                sintCarac ('e');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin recuperadatos:=memoriaTOTAL[70];
                end else recuperadatos:=memoriaTOTAL[60+numero];
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                NoRecupera:=true;
                exit;
            end else begin
            writeln;
            errores(6);
            NoRecupera:=true;
            exit;
            end;
        end else
        if c='f' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                write(c);
                sintSom('HPregistro');
                sintCarac ('f');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin recuperadatos:=memoriaTOTAL[80];
                end else recuperadatos:=memoriaTOTAL[70+numero];
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                NoRecupera:=true;
                exit;
            end else begin
            writeln;
            errores(6);
            NoRecupera:=true;
            exit;
            end;
        end else
        if c='g' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                write(c);
                sintSom('HPregistro');
                sintCarac ('g');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin recuperadatos:=memoriaTOTAL[90];
                end else recuperadatos:=memoriaTOTAL[80+numero];
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                NoRecupera:=true;
                exit;
            end else begin
            writeln;
            errores(6);
            NoRecupera:=true;
            exit;
            end;
        end else
        if c='h' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                write(c);
                sintSom('HPregistro');
                sintCarac ('h');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin recuperadatos:=memoriaTOTAL[100];
                end else recuperadatos:=memoriaTOTAL[90+numero];
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                NoRecupera:=true;
                exit;
            end else begin
            writeln;
            errores(6);
            NoRecupera:=true;
            exit;
            end;
        end else begin
            if( c in ['0'..'9']) then begin
                write(c);
                sintSom('HPregistro');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin recuperadatos:=memoriaTOTAL[10];
                end else recuperadatos:=memoriaTOTAL[numero];
            end;
        end;
        NoRecupera:=False;
    end else
    if (c=#$1b) then begin // cuando presiona ESC
        NoRecupera:=TRUE;
        finHP12c;
        inicializaSinSon;
        c:=ENTER;
    end else begin
        writeln;
        errores(6);
        NoRecupera:=true;
    end;
end;
{------------------------------------------------------------------------------}
function AlmacenaDatos(valor: real): boolean;
var c, punto: char;
    numero: integer;
begin
    c:=readkey;
    if (c in ['0'..'9','.','a','b','c','d','e','f','g','h']) then begin
        if c='.' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                pilaReal (valor);
                sintsom('HPregistro');
                write(c);
                sintCarac ('.');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin memoriaTotal[20]:=Valor;
                end else memoriaTotal[10+numero]:=Valor;
                alcenaSalto:=FALSE;
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                alcenaSalto:=TRUE;
            end else begin
            writeln;
            errores(6);
            alcenaSalto:=TRUE;
            exit;
            end;
        end else
        if c='a' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                pilaReal (valor);
                sintsom('HPregistro');
                write(c);
                sintCarac ('a');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin memoriaTotal[30]:=Valor;
                end else memoriaTotal[20+numero]:=Valor;
                alcenaSalto:=FALSE;
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                alcenaSalto:=TRUE;
            end else begin
            writeln;
            errores(6);
            alcenaSalto:=TRUE;
            exit;
            end;
        end else
        if c='b' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                pilaReal (valor);
                sintsom('HPregistro');
                write(c);
                sintCarac ('b');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin memoriaTotal[40]:=Valor;
                end else memoriaTotal[30+numero]:=Valor;
                alcenaSalto:=FALSE;
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                alcenaSalto:=TRUE;
            end else begin
            writeln;
            errores(6);
            alcenaSalto:=TRUE;
            exit;
            end;
        end else
        if c='c' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                pilaReal (valor);
                sintsom('HPregistro');
                write(c);
                sintCarac ('c');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin memoriaTotal[50]:=Valor;
                end else memoriaTotal[40+numero]:=Valor;
                alcenaSalto:=FALSE;
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                alcenaSalto:=TRUE;
            end else begin
            writeln;
            errores(6);
            alcenaSalto:=TRUE;
            exit;
            end;
        end else
        if c='d' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                pilaReal (valor);
                sintsom('HPregistro');
                write(c);
                sintCarac ('d');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin memoriaTotal[60]:=Valor;
                end else memoriaTotal[50+numero]:=Valor;
                alcenaSalto:=FALSE;
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                alcenaSalto:=TRUE;
            end else begin
            writeln;
            errores(6);
            alcenaSalto:=TRUE;
            exit;
            end;
        end else
        if c='e' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                pilaReal (valor);
                sintsom('HPregistro');
                write(c);
                sintCarac ('e');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin memoriaTotal[70]:=Valor;
                end else memoriaTotal[60+numero]:=Valor;
                alcenaSalto:=FALSE;
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                alcenaSalto:=TRUE;
            end else begin
            writeln;
            errores(6);
            alcenaSalto:=TRUE;
            exit;
            end;
        end else
        if c='f' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                pilaReal (valor);
                sintsom('HPregistro');
                write(c);
                sintCarac ('f');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin memoriaTotal[80]:=Valor;
                end else memoriaTotal[70+numero]:=Valor;
                alcenaSalto:=FALSE;
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                alcenaSalto:=TRUE;
            end else begin
            writeln;
            errores(6);
            alcenaSalto:=TRUE;
            exit;
            end;
        end else
        if c='g' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                pilaReal (valor);
                sintsom('HPregistro');
                write(c);
                sintCarac ('g');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin memoriaTotal[90]:=Valor;
                end else memoriaTotal[80+numero]:=Valor;
                alcenaSalto:=FALSE;
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                alcenaSalto:=TRUE;
            end else begin
            writeln;
            errores(6);
            alcenaSalto:=TRUE;
            exit;
            end;
        end else
        if c='h' then begin
            write(c);
            c:=readkey;
            if( c in ['0'..'9']) then begin
                pilaReal (valor);
                sintsom('HPregistro');
                write(c);
                sintCarac ('h');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin memoriaTotal[100]:=Valor;
                end else memoriaTotal[90+numero]:=Valor;
                alcenaSalto:=FALSE;
            end else
            if (c=#$1b) then begin // cuando presiona ESC
                finHP12c;
                inicializaSinSon;
                c:=ENTER;
                alcenaSalto:=TRUE;
            end else begin
            writeln;
            errores(6);
            alcenaSalto:=TRUE;
            exit;
            end;
        end else begin
            if( c in ['0'..'9']) then begin
                write(c);
                pilaReal (valor);
                sintsom('HPregistro');
                sintCarac (c);
                numero:=StrToINT(c);
                if numero=0 then begin memoriaTotal[10]:=Valor;
                end else memoriaTotal[numero]:=Valor;
                alcenaSalto:=FALSE;
            end;
        end;
    end else
    if (c=#$1b) then begin // cuando presiona ESC
        alcenaSalto:=TRUE;
        finHP12c;
        inicializaSinSon;
        c:=ENTER;
    end else begin
        writeln;
        errores(6);
        almacenadatos:=true;
    end;
end;
{------------------------------------------------------------------------------}
procedure almacenaFecha(op: string; var fecha: RFecha);

var
    cfecha: char;
    Dia: string;
    y: integer;

label
  InicioDia;
label
  InicioMes;
label
  InicioAno;
label
  InicioDia1;
label
  InicioMes1;
label
  InicioAno1;
label
  BorraDia;
label
  BorraMes;
label
  BorraAnio;
label
  BorraDia1;
label
  BorraMes1;
label
  BorraAnio1;

begin
{--------------------------Formato D.MA----------------------------------------}
    if( op='D' ) then begin
        {-----Dia-------------}
        textBackground (BLUE);   textColor (WHITE);
        write('Da: ');
        textBackground (BLACK);   textColor (WHITE);
        InicioDia:
        sintSom ('HPFechaDia');
        repeat
        cfecha:=readkey;
            if (cFecha<> ENTER) then
            begin
                BorraDia:
                if (cFecha = #$08) then
                begin
                    if (length (dia) > 0) then
                        begin
                          Dia:='';
                          y:=wherey;
                          gotoxy (6,y);
                          textBackground (BLACK);
                          clreol;
                          sintsom ('HPBORRADO');
                        end else begin
                        sintSom ('HPnada');
                        end;
                end
          else
          if cFecha in ['0'..'9'] then
                 begin
                    write(cFecha);
                    sintCarac(cFecha);
                    Dia:=dia+cfecha;
                 end
          else
          if (cFECHA=#$1b) then // cuando presiona ESC
                begin
                      //EscribeArchivo('ESC');
                      //writeln(cin);
                      finHP12c;
                      inicializaSinSon;
                      exit;
                      //tecla:=cin;
                      //cin:=ENTER;
                end
          else begin
              sintSom ('HPTECLAINV');
          end;

          if (length(Dia)=2) then begin
              repeat
                  sintSom ('HPnada');
                  cfecha:= readkey;
              until (cfecha = #$08) or (cfecha = ENTER);
              if cfecha = #$08 then goto BorraDia;
          end;

     end else  begin
     end;
     until cFecha=ENTER;
     val(Dia,fecha.dia,cod);
     if (fecha.dia<=0) or (fecha.dia>31) or (FRAC(fecha.dia)<>0) then begin
        Dia:='';
        y:=wherey;
        gotoxy (6,y);
        textBackground (BLACK);
        clreol;
        goto InicioDia;
     end;
     EscribeArchivo('dia: '+ dia);
     pilaReal(fecha.dia);
     writeln;
     Dia:='';
     {-----Mes-------------}
        textBackground (BLUE);   textColor (WHITE);
        write('Mes: ');
        textBackground (BLACK);   textColor (WHITE);
        InicioMes:
        sintSom ('HPFechaMes');
        repeat
        cfecha:=readkey;
            if (cFecha<> ENTER) then
            begin
                BorraMes:
                if (cFecha = #$08) then
                begin
                    if (length (dia) > 0) then
                        begin
                          Dia:='';
                          y:=wherey;
                          gotoxy (6,y);
                          textBackground (BLACK);
                          clreol;
                          sintsom ('HPBORRADO');
                        end else begin
                        sintSom ('HPnada');
                        end;
                end
          else
          if cFecha in ['0'..'9'] then
                 begin
                    write(cFecha);
                    sintCarac(cFecha);
                    Dia:=dia+cfecha;
                 end
          else
          if (cFECHA=#$1b) then // cuando presiona ESC
                begin
                      //EscribeArchivo('ESC');
                      //writeln(cin);
                      finHP12c;
                      inicializaSinSon;
                      exit;
                      //tecla:=cin;
                      //cin:=ENTER;
                end
          else begin
              sintSom ('HPTECLAINV');
          end;

          if (length(Dia)=2) then begin
              repeat
                  sintSom ('HPnada');
                  cfecha:= readkey;
              until (cfecha = #$08) or (cfecha = ENTER);
              if cfecha = #$08 then goto BorraMes;
          end;

     end else  begin
     end;
     until cFecha=ENTER;
     val(Dia,fecha.Mes,cod);
     if (fecha.Mes<=0) or (fecha.Mes>12) or (FRAC(fecha.mes)<>0)then begin
        Dia:='';
        y:=wherey;
        gotoxy (6,y);
        textBackground (BLACK);
        clreol;
        goto InicioMes;
     end;
     EscribeArchivo('Mes: '+ Dia);
     pilaReal(fecha.Mes);
     writeln;
     Dia:='';
     {-----Ano-------------}
        textBackground (BLUE);   textColor (WHITE);
        write('Ano: ');
        textBackground (BLACK);   textColor (WHITE);
        InicioAno:
        sintSom ('HPFechaAno');
        repeat
        cfecha:=readkey;
            if (cFecha<> ENTER) then
            begin
                BorraAnio:
                if (cFecha = #$08) then
                begin
                    if (length (dia) > 0) then
                        begin
                          Dia:='';
                          y:=wherey;
                          gotoxy (6,y);
                          textBackground (BLACK);
                          clreol;
                          sintsom ('HPBORRADO');
                        end else begin
                        sintSom ('HPnada');
                        end;
                end
          else
          if cFecha in ['0'..'9'] then
                 begin
                    write(cFecha);
                    sintCarac(cFecha);
                    Dia:=dia+cfecha;
                 end
          else
          if (cFECHA=#$1b) then // cuando presiona ESC
                begin
                      //EscribeArchivo('ESC');
                      //writeln(cin);
                      finHP12c;
                      inicializaSinSon;
                      exit;
                      //tecla:=cin;
                      //cin:=ENTER;
                end
          else begin
              sintSom ('HPTECLAINV');
          end;

          if (length(Dia)=4) then begin
              repeat
                  sintSom ('HPnada');
                  cfecha:= readkey;
              until (cfecha = #$08) or (cfecha = ENTER);
              if cfecha = #$08 then goto BorraAnio;
          end;

     end else  begin
     end;
     until cFecha=ENTER;
     val(Dia,fecha.Anio,cod);
     if (fecha.Anio<1582) or (fecha.Anio>4046) or (FRAC(fecha.anio)<>0)then begin
        Dia:='';
        y:=wherey;
        gotoxy (6,y);
        textBackground (BLACK);
        clreol;
        goto InicioAno;
     end;
     EscribeArchivo('Ano: '+ Dia);
     pilaReal(fecha.Anio);
     writeln;
     dia:='';
     end;
{---------------------Formato M.DA---------------------------------------------}
    if( op=#4) then begin
        {-----MES-------------}
        textBackground (BLUE);   textColor (WHITE);
        write('Mes: ');
        textBackground (BLACK);   textColor (WHITE);
        InicioMes1:
        sintSom ('HPFechaMes');
        repeat
        cfecha:=readkey;
            if (cFecha<> ENTER) then
            begin
                BorraMes1:
                if (cFecha = #$08) then
                begin
                    if (length (dia) > 0) then
                        begin
                          Dia:='';
                          y:=wherey;
                          gotoxy (6,y);
                          textBackground (BLACK);
                          clreol;
                          sintsom ('HPBORRADO');
                        end else begin
                        sintSom ('HPnada');
                        end;
                end
          else
          if cFecha in ['0'..'9'] then
                 begin
                    write(cFecha);
                    sintCarac(cFecha);
                    Dia:=dia+cfecha;
                 end
          else
          if (cFECHA=#$1b) then // cuando presiona ESC
                begin
                      //EscribeArchivo('ESC');
                      //writeln(cin);
                      finHP12c;
                      inicializaSinSon;
                      exit;
                      //tecla:=cin;
                      //cin:=ENTER;
                end
          else begin
              sintSom ('HPTECLAINV');
          end;

          if (length(Dia)=2) then begin
              repeat
                  sintSom ('HPnada');
                  cfecha:= readkey;
              until (cfecha = #$08) or (cfecha = ENTER);
              if cfecha = #$08 then goto BorraMes1;
          end;

     end else  begin
     end;
     until cFecha=ENTER;
     val(Dia,fecha.mes,cod);
     if (fecha.Mes<=0) or (fecha.Mes>12) or (FRAC(fecha.mes)<>0)then begin
        Dia:='';
        y:=wherey;
        gotoxy (6,y);
        textBackground (BLACK);
        clreol;
        goto InicioMes1;
     end;
     EscribeArchivo('Mes: '+ Dia);
     pilaReal(fecha.mes);
     writeln;
     Dia:='';
     {-----dia-------------}
        textBackground (BLUE);   textColor (WHITE);
        write('dia: ');
        textBackground (BLACK);   textColor (WHITE);
        InicioDia1:
        sintSom ('HPFechaDia');
        repeat
        cfecha:=readkey;
            if (cFecha<> ENTER) then
            begin
                BorraDia1:
                if (cFecha = #$08) then
                begin
                    if (length (dia) > 0) then
                        begin
                          Dia:='';
                          y:=wherey;
                          gotoxy (6,y);
                          textBackground (BLACK);
                          clreol;
                          sintsom ('HPBORRADO');
                        end else begin
                        sintSom ('HPnada');
                        end;
                end
          else
          if cFecha in ['0'..'9'] then
                 begin
                    write(cFecha);
                    sintCarac(cFecha);
                    Dia:=dia+cfecha;
                 end
          else
          if (cFECHA=#$1b) then // cuando presiona ESC
                begin
                      //EscribeArchivo('ESC');
                      //writeln(cin);
                      finHP12c;
                      inicializaSinSon;
                      exit;
                      //tecla:=cin;
                      //cin:=ENTER;
                end
          else begin
              sintSom ('HPTECLAINV');
          end;

          if (length(Dia)=2) then begin
              repeat
                  sintSom ('HPnada');
                  cfecha:= readkey;
              until (cfecha = #$08) or (cfecha = ENTER);
              if cfecha = #$08 then goto BorraDia1;
          end;

     end else  begin
     end;
     until cFecha=ENTER;
     val(Dia,fecha.Dia,cod);
     if (fecha.dia<=0) or (fecha.dia>31) or (FRAC(fecha.dia)<>0) then begin
        Dia:='';
        y:=wherey;
        gotoxy (6,y);
        textBackground (BLACK);
        clreol;
        goto InicioDia1;
     end;
     EscribeArchivo('dia: '+ Dia);
     pilaReal(fecha.Dia);
     writeln;
     Dia:='';
     {-----Ano-------------}
        textBackground (BLUE);   textColor (WHITE);
        write('Ano: ');
        textBackground (BLACK);   textColor (WHITE);
        InicioAno1:
        sintSom ('HPFechaAno');
        repeat
        cfecha:=readkey;
            if (cFecha<> ENTER) then
            begin
                BorraAnio1:
                if (cFecha = #$08) then
                begin
                    if (length (dia) > 0) then
                        begin
                          Dia:='';
                          y:=wherey;
                          gotoxy (6,y);
                          textBackground (BLACK);
                          clreol;
                          sintsom ('HPBORRADO');
                        end else begin
                        sintSom ('HPnada');
                        end;
                end
          else
          if cFecha in ['0'..'9'] then
                 begin
                    write(cFecha);
                    sintCarac(cFecha);
                    Dia:=dia+cfecha;
                 end
          else
          if (cFECHA=#$1b) then // cuando presiona ESC
                begin
                      //EscribeArchivo('ESC');
                      //writeln(cin);
                      finHP12c;
                      inicializaSinSon;
                      exit;
                      //tecla:=cin;
                      //cin:=ENTER;
                end
          else begin
              sintSom ('HPTECLAINV');
          end;

          if (length(Dia)=4) then begin
              repeat
                  sintSom ('HPnada');
                  cfecha:= readkey;
              until (cfecha = #$08) or (cfecha = ENTER);
              if cfecha = #$08 then goto BorraAnio1;
          end;

     end else  begin
     end;
     until cFecha=ENTER;
     val(Dia,fecha.Anio,cod);
     if (fecha.anio<1582) or (fecha.anio>4046) or (FRAC(fecha.anio)<>0) then begin
        Dia:='';
        y:=wherey;
        gotoxy (6,y);
        textBackground (BLACK);
        clreol;
        goto InicioAno1;
     end;
     EscribeArchivo('Ano: '+ Dia);
     pilaReal(fecha.Anio);
     writeln;
     dia:='';
    end;
    writeln('! Data Inserida !');
    sintSom('HpFechaConfig');

end;


{------------------------------------------------------------------------------}
procedure poneCero(exp:string);

var i: integer;

begin
  LSTx:=False;
  veces:=0;
  v1:=0;
  v2:=0;
  v3:=0;
  p:=nil;
      if (exp = 'A') then begin
        for i:=1 to LTarray do begin
            memoriagen[i]:=0;
        end;
      inicializaSinSon;
      exit;
      end;
      if (exp = #1) then begin
        for i:=1 to LTarray do begin
            memoriafi[i]:=0;
        end;
      inicializaSinSon;
      exit;
      end;
    for i:=1 to LTarray do begin
        memoriaTOTAL[i]:=0;
        memoriagen[i]:=0;
        memoriafi[i]:=0;
        memoriaNPV[i]:=0;
    end;
    nNPV:=1;
    vecesCfo:=1;
    fecha1.dia:=0;
    fecha1.mes:=0;
    fecha1.anio:=0;
    fecha2.dia:=0;
    fecha2.mes:=0;
    fecha2.anio:=0;
    v4:=0;
    periodo:=0;
    inicializaSinSon;
end;
{------------------------------------------------------------------------------}

end.
