unit HP12Cvariables;

interface
uses
  Math,
  DVcrt,
  DVWin,
  sysUtils,
  Windows,
  StrUtils;

  type

      PRPila = ^RPila;
      RPila = record
        valor: double;//real;
        sig: PRPila;
      end;

      RFecha = record
        dia: real;
        mes: real;
        anio: real;
      end;

   const
   LTArray = 100;

   type
   TArray = array [1..LTArray] of real;


var
    nomeArq: string;
    memoriafi, memoriagen, memoriaNPV, memoriaFecha, MemoriaTotal: Tarray; // array para variables financieras
    p: PRPila;         // pila de la calculadora
    v1,v2,v3, v4, A, B, periodo, ValorLSTX, Valor28, Valor28Exp: double;//real;    // valores para apilar
    cod, veces, vecesCFo, vecesNj, nNPV, nDecimais, NumeroExemplo, NColor: integer;
    respuesta, condicionCarga, limpiaData1, limpiaData2, ValidaData1, ValidaData2, NoRecupera, LSTx,
    TEXEMPLO, DecimalEX, RetornoMenu, TestTeclado, NoSaleESC, numeroGeneral, alcenaSalto  :boolean;
    HojaCalc: string;
    ArqCalculadora, ArqSalidaCalcu, ArqCalendario, ArqCalendarioMeses: text;   //Arquivos de armazenamento
    fecha1, fecha2, Fechar: RFecha;

  posicionCOMANDOS_Y: array[0..3000] of integer; // cambiar por posSentence_Y
  // tabelaErrores:array[0..100] of string;
  tabelaErrores: array of string; //ErrorTable
  palavras: array of string; // VarTable
  validacion, numeroError, punteroRESULTADOS, lineaError: integer;
  propiedadError: string;
  GOTOetiquetaLabel: array[0..100] of string; //gotoLabel
  GOTOposicionLabel: array[0..100] of integer; //gotoPosLabel
  comandosCompilador: array[0..30] of string; //commandTable
  funcionesCompilador: array[0..120] of string; //functionTable
  drectorioSON: string;
  region: string;
  versaoMatvox: string;
  posELSE: array of integer;
  cursorxG: integer;
  lineaG: string;
  somG: string;
  dirSonidos: string;

procedure globalVariables;
//procedure escribirResultados(escritura: string);
//procedure limpiaArquivoResultados;
//procedure limpiaArquivoCodigo;
//procedure escribirCodigo(escritura: string);
//procedure escribirConstantesUsuario(escritura: string);
//procedure limpiaArquivoConstantesUsuario;
//procedure escribirExpressoes(escritura: string);
//procedure limpiaArquivoExpressoes;
//procedure limpiaArquivoGeral(arquivo: string);
//procedure escribirArquivoGeral(arquivo, escritura: string);
  {RUTINA QUE ESCRIBE EN EL ARCHIVO TEXTO2}
//procedure limpiaArquivoGeralMemory(arquivo: string);
//procedure escribirArquivoGeralMemory(arquivo, escritura: string);

//procedure menuPreguntaG;
//procedure escribeG(texto: string);
//procedure apagaG;
//procedure limpaLinhaG;
//procedure preguntaG(texto: string);
//procedure limpaParametrosG;

implementation

//var
  {ArquivoTexto, ArquivoTexto2, ArquivoTexto3, ArquivoTexto4, ArquivoTexto5,
    ArquivoTexto6, ArquivoTexto7, ArquivoTexto8, ArquivoTexto9: TextFile;

  {------------------------------------------------------------------------------------------------------}
  {------------------------------------------------------------------------------------------------------}

procedure globalVariables;
var
  i: integer;
begin
  dirSonidos := sintAmbiente ('HP12CVOX', 'DIRHP12CVOX');
  if dirSonidos = '' then
      dirSonidos := 'c:\winvox\som\HP12Cvox';
  versaoMatvox := '1.0';
  for i := 0 to 3000 do
    posicionCOMANDOS_Y[i] := 0;
  validacion := 1;
  region := '';
  punteroRESULTADOS := 0;
{--------------------Definicion Funciones Generales----------------------------}
  funcionesCompilador[0] := 'POTENCIA';
  funcionesCompilador[1] := 'SQRT';
  funcionesCompilador[2] := '1/x';
  funcionesCompilador[3] := 'EXP';
  funcionesCompilador[4] := 'LN';
  funcionesCompilador[5] := 'n!';
  funcionesCompilador[6] := 'FRAC';
  funcionesCompilador[7] := 'INTG';
{--------------------Definicion Funciones Estatisticas-------------------------}
  funcionesCompilador[10] := 'ACUMULACAO';
  funcionesCompilador[11] := 'CORRECAO';
  funcionesCompilador[12] := 'MEDIA';
  funcionesCompilador[13] := 'DESVIO PADRAO';
  funcionesCompilador[14] := 'MEDIA PONDERADA';
  funcionesCompilador[15] := 'ESTIMACAO LINEAR X';
  funcionesCompilador[16] := 'ESTIMACAO LINEAR Y';
  funcionesCompilador[17] := 'COEFICIENTE DE CORRELACAO';
{--------------------Definicion Funciones Financeiras--------------------------}
  funcionesCompilador[21] := 'n';
  funcionesCompilador[22] := 'i';
  funcionesCompilador[23] := 'PV';
  funcionesCompilador[24] := 'PMT';
  funcionesCompilador[25] := 'FV';
  funcionesCompilador[26] := '12X';
  funcionesCompilador[27] := '12/';
  funcionesCompilador[28] := 'CFo';
  funcionesCompilador[29] := 'CFj';
  funcionesCompilador[30] := 'Nj';
  funcionesCompilador[31] := 'BEG';
  funcionesCompilador[32] := 'END';
  funcionesCompilador[33] := 'S/N PERIODO FRACC.';
{---------------Definicion Funciones Financieras Adicionales-------------------}
  funcionesCompilador[36] := 'Calculo n';
  funcionesCompilador[37] := 'Calculo i';
  funcionesCompilador[38] := 'Calculo PV';
  funcionesCompilador[39] := 'Calculo PMT';
  funcionesCompilador[40] := 'Calculo FV';
  funcionesCompilador[41] := 'AMORT';
  funcionesCompilador[42] := 'INT';
  funcionesCompilador[43] := 'NPV';
  funcionesCompilador[44] := 'DB';
  funcionesCompilador[45] := 'SL';
  funcionesCompilador[46] := 'SOYD';
{---------------Definicion Funciones de Porcentaje y Calendario----------------}
  funcionesCompilador[50] := '%';
  funcionesCompilador[51] := '%T';
  funcionesCompilador[52] := 'D%';
  funcionesCompilador[53] := 'D.MY';
  funcionesCompilador[54] := 'M.DY';
  funcionesCompilador[55] := 'DATE';
  funcionesCompilador[56] := 'DDYS';
{-----------------------Comandos FINANVOX--------------------------------------}
  comandosCompilador[0] := 'CHS';
  comandosCompilador[1] := 'EEX';
  comandosCompilador[2] := 'STO';
  comandosCompilador[3] := 'RCL';
  comandosCompilador[4] := 'X<>Y';
  comandosCompilador[5] := 'RP';
  comandosCompilador[6] := 'REG. PILHA';
  comandosCompilador[7] := 'PRIMER REG. PILHA ';
  comandosCompilador[8] := '#DECIMAIS';
  comandosCompilador[9] := 'BS';
  comandosCompilador[10] := 'A.REG';
  comandosCompilador[11] := 'A.ESTA';
  comandosCompilador[12] := 'A.FIN';
  comandosCompilador[13] := 'LSTx';
  comandosCompilador[14] := 'TESTAR TECLADO';
  {comandosCompilador[17] := 'DELETEEXPRESSION';
  comandosCompilador[18] := 'ELSE';
  comandosCompilador[19] := 'PRINTER';
  comandosCompilador[20] := 'IMPORTPLANIVOX';
  comandosCompilador[21] := 'EXPORTPLANIVOX';
  comandosCompilador[22] := 'IMPORTTEXT';
  comandosCompilador[23] := 'EXPORTTEXT';
  comandosCompilador[24] := 'LABEL';
  comandosCompilador[25] := 'SAVEMEMORY';
  comandosCompilador[26] := 'READFUNCTION';
  comandosCompilador[27] := 'N';
  comandosCompilador[28] := 'READMEMORY';
  comandosCompilador[29] := 'IN'; }

end;

{------------------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------------------}

{procedure escribirResultados(escritura: string);

begin
  //AssignFile(ArquivoTexto,'C:\winvox\resultados.txt');
  AssignFile(ArquivoTexto, dirSomEdivox + '\COMANDOS\CONFIG\resultados.txt');
  Reset(ArquivoTexto);
  Append(ArquivoTexto);
  Writeln(ArquivoTexto, escritura);
  CloseFile(ArquivoTexto);
end;
{------------------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------------------}
{procedure escribirCodigo(escritura: string);

begin
  AssignFile(arquivoTexto4, dirSomEdivox + '\COMANDOS\CONFIG\codigo.txt');
  Reset(arquivoTexto4);
  Append(arquivoTexto4);
  Writeln(arquivoTexto4, escritura);
  CloseFile(arquivoTexto4);
end;
{------------------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------------------}

{procedure escribirConstantesUsuario(escritura: string);

begin
  // AssignFile(arquivoTexto5,'C:\winvox\ConstantesUsuario.txt');
  AssignFile(arquivoTexto5, dirSomEdivox +
    '\COMANDOS\CONFIG\ConstantesUsuario.txt');
  Reset(arquivoTexto5);
  Append(arquivoTexto5);
  Writeln(arquivoTexto5, escritura);
  CloseFile(arquivoTexto5);
end;
{------------------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------------------}
{procedure limpiaArquivoConstantesUsuario;

begin
  // AssignFile(arquivoTexto6,'C:\winvox\ConstantesUsuario.txt');
  AssignFile(arquivoTexto6, dirSomEdivox +
    '\COMANDOS\CONFIG\ConstantesUsuario.txt');
  Reset(arquivoTexto6);
  Append(arquivoTexto6);
  Rewrite(arquivoTexto6);
  Writeln(arquivoTexto6, '');
  CloseFile(arquivoTexto6);
end;
{------------------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------------------}
{procedure escribirExpressoes(escritura: string);

begin
  //AssignFile(arquivoTexto7,'C:\winvox\ExpressoesUsuario.txt');
  AssignFile(arquivoTexto7, dirSomEdivox +
    '\COMANDOS\CONFIG\ExpressoesUsuario.txt');
  Reset(arquivoTexto7);
  Append(arquivoTexto7);
  Writeln(arquivoTexto7, escritura);
  CloseFile(arquivoTexto7);
end;
{------------------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------------------}
{procedure limpiaArquivoExpressoes;
begin
  //AssignFile(arquivoTexto8,'C:\winvox\ExpressoesUsuario.txt');
  AssignFile(arquivoTexto8, dirSomEdivox +
    '\COMANDOS\CONFIG\ExpressoesUsuario.txt');
  Reset(arquivoTexto8);
  Append(arquivoTexto8);
  Rewrite(arquivoTexto8);
  Writeln(arquivoTexto8, '');
  CloseFile(arquivoTexto8);
end;
{------------------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------------------}
{procedure limpiaArquivoResultados;
begin
  //AssignFile(arquivoTexto2,'C:\winvox\resultados.txt');
  AssignFile(arquivoTexto2, dirSomEdivox + '\COMANDOS\CONFIG\resultados.txt');
  Reset(arquivoTexto2);
  Append(arquivoTexto2);
  Rewrite(arquivoTexto2);
  Writeln(arquivoTexto2, '');
  CloseFile(arquivoTexto2);
end;
{------------------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------------------}
{procedure limpiaArquivoCodigo;
begin
  //AssignFile(arquivoTexto3,'C:\winvox\codigo.txt');
  AssignFile(arquivoTexto3, dirSomEdivox + '\COMANDOS\CONFIG\codigo.txt');
  Reset(arquivoTexto3);
  Append(arquivoTexto3);
  Rewrite(arquivoTexto3);
  Writeln(arquivoTexto3, '');
  CloseFile(arquivoTexto3);
end;

procedure limpiaArquivoGeral(arquivo: string);
begin
  AssignFile(arquivoTexto9, arquivo + '.txt');
  reset(arquivoTexto9);
  Append(arquivoTexto9);
  Rewrite(arquivoTexto9);
  CloseFile(arquivoTexto9);
end;

procedure limpiaArquivoGeralMemory(arquivo: string);
begin
  AssignFile(arquivoTexto9, arquivo + '.csv');
{$I-}
 { reset(arquivoTexto9);
{$I+}
  {if ioresult <> 0 then //CRIA ARQUIVO QUANDO ELE NAO EXISTE
    rewrite(arquivoTexto9)
  else
  begin
    reset(arquivoTexto9);
    Append(arquivoTexto9);
    Rewrite(arquivoTexto9);
  end;
  CloseFile(arquivoTexto9);
end;

procedure escribirArquivoGeralMemory(arquivo, escritura: string);
  {RUTINA QUE ESCRIBE EN EL ARCHIVO TEXTO2}
{begin
  AssignFile(arquivoTexto9, arquivo + '.csv');
  Reset(arquivoTexto9);
  Append(arquivoTexto9);
  Writeln(arquivoTexto9, escritura);
  CloseFile(arquivoTexto9);
end;

procedure escribirArquivoGeral(arquivo, escritura: string);
  {RUTINA QUE ESCRIBE EN EL ARCHIVO TEXTO2}
{begin
  AssignFile(arquivoTexto9, arquivo + '.txt');
  Reset(arquivoTexto9);
  Append(arquivoTexto9);
  Writeln(arquivoTexto9, escritura);
  CloseFile(arquivoTexto9);
end;

procedure menuPreguntaG;
var
  caracter: char;
var
  salida: integer;

begin
  salida := 0;
  cursorXG := 2;
  repeat
    begin
      caracter := readKey;

      if caracter = #8 then
        apagaG
      else if caracter = #0 then
      begin
        caracter := readkey;

        if (caracter = #75) and (cursorXG > 2) then
        begin
          sintCarac(lineaG[cursorXG - 2]);
          dec(cursorXG);
          GotoXY(cursorXG, 23);
        end

        else if (caracter = #77) and (cursorXG <= length(lineaG) + 1) then
        begin
          sintCarac(lineaG[cursorXG - 1]);
          inc(cursorXG);
          GotoXY(cursorXG, 23);
        end

        else if (caracter = #59) then
          sintSom('\COMANDOS\PARAMETROS\P110');
          sintSoletra(somG);

      end

      else if caracter = #27 then
      begin
        salida := 1;
        lineaG := '';
      end
      else if caracter = #13 then
      begin
        salida := 1;
      end

      else if (length(lineaG) <= 70) then
      begin
        sintCarac(caracter);
        escribeG(caracter);
      end;

    end;
    //until (caracter = #13) or (caracter = #27);
  until salida = 1;

end;

procedure escribeG(texto: string);
begin
  TextColor(white);
  TextBackground(red);
  GotoXY(2, 23);
  if cursorXG >= 67 then
    exit;
  insert(texto, lineaG, cursorXG - 1);
  GotoXY(cursorXG, 23);
  inc(cursorXG);
  limpaLinhaG;
  Write(lineaG);
  GotoXY(cursorXG, 23);
end;

procedure apagaG;
begin
  TextColor(white);
  TextBackground(red);
  GotoXY(2, 23);
  if cursorXG <= 2 then
    exit;
  dec(cursorXG);

  delete(lineaG, cursorXG - 1, 1);
  sintSom('\COMANDOS\PALABRAS\P13');
  limpaLinhaG;
  Write(lineaG);
  GotoXY(cursorXG, 23);
end;

procedure limpaLinhaG;
begin
  TextBackground(red);
  GotoXY(2, 23);
  Write('                                                                 ');
  GotoXY(2, 23);
end;

procedure preguntaG(texto: string);
begin
  TextColor(white);
  TextBackground(red);
  GotoXY(2, 22);
  Write(texto);
end;

procedure limpaParametrosG;
begin
  TextBackground(black);
  GotoXY(1, 22);
  Write('                                                                                                    ');
  GotoXY(1, 23);
  Write('                                                                                                    ');

  TextBackground(red);
end;

type
  persona = class
    Nombre: string;
    procedure jeje;
    procedure doss;
    procedure clase;
  end;

var
  uno: persona;

procedure persona.jeje;
begin

end;

procedure persona.doss;
begin

end;

procedure persona.clase;
begin
  doss;
  uno.jeje;
end;

procedure tres;
begin
  uno.doss;
end;    }

end.

