program HP12Cvox;

{------------------------------------------------------------------------------}
{                              Librerias                                       }
{------------------------------------------------------------------------------}

uses
  Windows,
  SysUtils,
  dvCrt,
  dvWin,
  dvWav,
  dvHora,
  dvexec,
  MMSystem,
  math,
  HP12CfunRPN,
  HP12Cinicializa,
  HP12Cedarch,
  HP12Cmanejopila,
  HP12Creproduce,
  HP12Cmenu,
  HP12Cvariables,
  HP12Cmemorias,
  HP12Cvalida,
  HP12CExemplos;

{------------------------------------------------------------------------------}
{                        Definicion de Variables                               }
{------------------------------------------------------------------------------}

var

    exp: String[15];    // string para leer por teclado
    tecla, tecla2: char;
    progAcabou, desicion: boolean;
    ultimoTitulo: array [0..80] of char;

label ingreso;
label Inicio1;

{------------------------------------------------------------------------------}
{             Inicio Programa Principal                                        }
{------------------------------------------------------------------------------}

begin

  globalvariables;    // Define todas las variables
  p:=NIL;             // Inicializo la pila
  vecesCFo:=1;
  nNPV:=1;
  nDecimais:=2;       // Numero de decimales
  Ncolor:=4;
  clrscr;

  setWindowText (crtWindow, 'FINANVOX');
  inicializaconSom;

{------------------------------------------------------------------------------}
Inicio1:
  poneCero(exp);
  AbreArchivo;
  exp:=InOperandos(p);
  v3:=0;

  while( exp<>'F' ) AND (exp<> #$1b) do begin   // mientras sea distinto de F
          if( esOperando(exp) ) then begin      // ingreso un valor numerico
                EscribeArchivo(exp);
                val(exp,v1,cod);               // lo convierto a real
                poner(p,v1);                    // lo apilo
                mostrarPila(p);
                pilaReal (v1);                  // reproduce
          end else begin
                if (exp = '+') or
                (exp = '-') or
                (exp = '*') then
                begin
                EscribeArchivo(exp);
                sacar(p,v1);   //saca el primer valor de la pila
                sacar(p,v2);   //saca el segundo valor de la pila
                v3:=operarbasicas(v2,v1,exp);
                end;

{---------------------------Cambio de Signo -----------------------------------}
          if (exp = 't') then
          begin
                EscribeArchivo(exp);
                v2:=0;
                sacar(p,v1);
                v3:=-1*v1;
                writeln;
          end;

{--------------------Operaciones y Funciones Basicas---------------------------}
          if (exp = '/') or (exp = 'x') or (exp = 'X') or (exp = #24) or
          (exp = 'E') or (exp = #5) or (exp = 'f')then
          begin
                EscribeArchivo(exp);
                Respuesta:=Validatodo(exp);
                if (respuesta=false) then
                goto ingreso;
          end;

{---------------------Operaciones de Porcentaje--------------------------------}
          if (exp = '%') or (exp = 'y') or (exp = 'Y') then
          begin
                EscribeArchivo(exp);
                Respuesta:=Validatodo(exp);
                if (respuesta=false) then
                goto ingreso;
          end;

{---------------------Ingreso de Fechas----------------------------------------}
          if (exp = 'D') then begin
              ValidaData1:=true;
              ValidaData2:=false;
              if limpiaData2=true then v4:=0;
              EscribeArchivo(exp);
              if (v4=0) then begin
                  limpiaData1:=true;
                  almacenaFecha(exp, fecha1);
                  v4:=1;
              end else
                  if (v4=1) then begin
                  almacenaFecha(exp, fecha2);
                  v4:=0;
              end;
              goto ingreso;
          end;
          if (exp =#4) then begin
              ValidaData2:=true;
              ValidaData1:=false;
              if limpiaData1=true then v4:=0;
              EscribeArchivo(exp);
              if (v4=0) then begin
                  limpiaData2:=true;
                  almacenaFecha(exp, fecha1);
                  v4:=1;
              end else
              if (v4=1) then begin
                  almacenaFecha(exp, fecha2);
                  v4:=0;
              end;
              goto ingreso;
          end;

{---------------------Operaciones de Calendario--------------------------------}
          if (exp = 'h') then
          begin
                EscribeArchivo(exp);
                v3:=Calendario30;
                poner(p,v3);
                v3:=Calendario;
          end;
          if (exp ='H') then
          begin
                sacar(p, v1);
                EscribeArchivo(exp);
                if (FRAC(v1)<>0) or (v1<-500000) then begin
                    errores(8);
                    goto ingreso;
                end;
                if v1>0 then sintSom ('HPDateFutura');
                if v1<0 then sintSom ('HPDatePassada');
                v3:=CalculoFechas;
                if ValidaData1=true then begin
                    pilareal(fecha2.dia);
                    mensajesMeses(fecha2.mes);
                    pilareal(fecha2.anio);
                end;
                if ValidaData2=true then begin
                    mensajesMeses(fecha2.mes);
                    pilareal(fecha2.dia);
                    pilareal(fecha2.anio);
                end;
                goto ingreso;
          end;

{------------------------------------------------------------------------------}
          if (exp = 'g') or (exp = 'G') then
          begin
                EscribeArchivo(exp);
                sacar(p,v1);   // saca el primer valor de la pila
                v3:=operarSimples(v1, exp);
          end;

{----------------------Funciones Financieras-----------------------------------}
          if (exp = 'n') or (exp = #14) or (exp = 'i') or (exp = #9 ) or
          (exp = 'p') or (exp = 'm') or (exp = 'v') or (exp = 'j') or
          (exp = 'N') or (exp = 'I') or (exp = 'P') or (exp = 'M') or
          (exp = 'V') or (exp = 'J') or (exp = 'k') or (exp = 'K') or
          (exp = #11) or (exp = 'l') or (exp = 'L') or (exp =#12) then
          begin
                EscribeArchivo(exp);
                Respuesta:=Validatodo(exp);
                if (respuesta=false) then
                goto ingreso;
          end;

{------------------------Funciones Estadisticas--------------------------------}
{--Sumatoria, Media, Coefi Corre, Media Pond, Desvio Padron, Estimaciones L.---}
          if (exp ='z') or (exp ='Z') or (exp = #26) or
          (exp ='q') or (exp ='Q') or (exp =#17) or
          (exp ='w') or (exp ='W') or (exp =#23) then begin
                EscribeArchivo(exp);
                Respuesta:=Validatodo(exp);
                if (respuesta=false) then
                goto ingreso;
          end;

{---------------------------Recuperacion de Datos------------------------------}
          if (exp = 'r') then
          begin
                 EscribeArchivo(exp);
                 v3:=recuperadatos;
                 if NoRecupera then goto ingreso;
                 writeln;
          end;
          if (exp = 'R') then
          begin
                 EscribeArchivo(exp);
                 if LSTx then v3:=ValorLSTX;
                 writeln;
          end;

{---------------------------Almacenamiento de Datos------------------------------}
          if (exp = 's') then
          begin
                 sacar(p,v1);
                 EscribeArchivo(exp);
                 desicion:=AlmacenaDatos(v1);
                 poner(p,v1);
                 if desicion then goto ingreso;
                 if not alcenaSalto then writeln;
                 goto ingreso;
          end;

{---------------------------Borrado de datos-----------------------------------}
          if (exp = 'a') or (exp = 'A') or (exp = #1) then
          begin
                  EscribeArchivo(exp);
                  ponecero(exp);
                  goto ingreso;
          end;

{------------------------------------------------------------------------------}

                // apilo el resultado
                poner(p,v3);
                // muestro el contenido de la pila
                mostrarPila(p);
                //fala o resultado
                falaNumeroReal(v3);

          end;
          ingreso:   //Inicio de operaciones
          exp:=InOperandos(p);
    end;

    poneCero(exp);   //Comienza todo de nuevo
    goto ingreso;
end.

