unit HP12Cmanejopila;

interface

uses
    dvWin,
    dvCrt,
    sysUtils,
    dvlenum,
    math,
    HP12Cedarch,
    HP12Cinicializa,
    HP12Creproduce,
    HP12CfunRPN,
    HP12Cmenu,
    HP12Cvariables,
    HP12Cmemorias,
    HP12CExemplos;
    
{------------------------------------------------------------------------------}

procedure poner(var p: PRPila; v: double{real});
function sacar(var p: PRPila; var v: double{real}):boolean;
procedure mostrarPila(p:PRPila);
procedure cambiaPila(var p:PRPila);
procedure rotarPila(var p:PRPila);
function InOperandos(p: PRpila):String;


implementation
{------------------------------------------------------------------------------}

procedure poner(var p: PRPila; v: double{real});
var
    nuevo: PRPila;
begin
  new(nuevo);
  nuevo^.valor:=v;
  nuevo^.sig:=p;
  p:=nuevo;
end;

{----------------------------------------------------------------------------}

function sacar(var p: PRPila; var v: double{real}):boolean;
var
    aux:PRPila;
begin
    if( p=NIL ) then begin
        sacar:=false;
        exit;
    end;

    v:=p^.valor;
    aux:=p;
    p:=p^.sig;
    dispose(aux);
    sacar:=true;
end;

{----------------------------------------------------------------------------}

procedure mostrarPila(p:PRPila);
var
    aux,x,nuevo:PRPila;
    imprime, CadenaValor, exponente, exponente1: string;
    RegistroXYZT: Char;
    posy, i, contador, contadorXYZT, tamano, coordx, y, NumeroExp: integer;
    negativo: boolean;

label NumGrande;

begin
  aux:=NIL;
  contador:=0;
  contadorXYZT:=0;

    // recorremos la pila (como lista) utilziando p
    // NOTEMOS que p se recibe por valor (sin var)
    // por lo tanto aunque aqui la modifiquemos no
    // quedara modificada en el programa principal
    // es decir: en el programa principal la variable
    // p no quedara en NIL
    writeln('---------------------------------------');
    while( p<>NIL ) do begin
        // por cada nodo de p creo un nuevo nodo
        // para la pila auxiliar
        new(nuevo);
        nuevo^.valor:=p^.valor;
        nuevo^.sig:=aux;
        aux:=nuevo;
        contador:=contador+1;
        if (contador=4) then begin
            p^.sig:=nil;
        end;
        // avanzo p
        p:=p^.sig;
    end;

    // saco nodos de la pila auxiliar, los muestro
    // y los libero

        posy:=wherey;
        if (posy>23) then begin
        inicializaSinSon;
        end;
    while( aux<>NIL ) do begin
        contadorXYZT:=contadorXYZT+1;
        if (aux^.valor>9.999999999e14) or (aux^.valor<0.0001) AND (aux^.valor>0) or
        (aux^.valor<-9.999999999e14) or (aux^.valor>-0.0001) AND (aux^.valor<0)then begin

            if contador=4 then begin
            if contadorXYZT=1 then RegistroXYZT:='T';
            if contadorXYZT=2 then RegistroXYZT:='Z';
            if contadorXYZT=3 then RegistroXYZT:='Y';
            if contadorXYZT=4 then RegistroXYZT:='X';
            end;
            if contador=3 then begin
            if contadorXYZT=1 then RegistroXYZT:='Z';
            if contadorXYZT=2 then RegistroXYZT:='Y';
            if contadorXYZT=3 then RegistroXYZT:='X';
            end;
            if contador=2 then begin
            if contadorXYZT=1 then RegistroXYZT:='Y';
            if contadorXYZT=2 then RegistroXYZT:='X';
            end;
            if contador=1 then begin
            if contadorXYZT=1 then RegistroXYZT:='X';
            end;

                CadenaValor:= FloatToStr(aux^.valor);
                tamano:=Length(CadenaValor);
                for i:=1 to tamano do begin
                    if CadenaValor[i]=',' then CadenaValor[i]:='.';
                    if CadenaValor[i]='E' then break;
                    exponente:=exponente+CadenaValor[i];
                end;
                   for i:=i+1 to tamano do begin
                exponente1:=exponente1+CadenaValor[i];
                end;
                y:=wherey;
                gotoxy(7,y);
                write(RegistroXYZT,' = ',exponente[1],exponente[2],exponente[3],exponente[4],exponente[5]);
                textColor (Red);
                write('E');
                textColor (White);
                write(exponente1);
                coordx:=wherex;
                writeln;
                imprime:=FloatToStr(aux^.valor);
                CadenaValor:='';
                exponente:='';
                exponente1:='';
        end else begin
            if contador=4 then begin
            if contadorXYZT=1 then RegistroXYZT:='T';
            if contadorXYZT=2 then RegistroXYZT:='Z';
            if contadorXYZT=3 then RegistroXYZT:='Y';
            if contadorXYZT=4 then RegistroXYZT:='X';
            end;
            if contador=3 then begin
            if contadorXYZT=1 then RegistroXYZT:='Z';
            if contadorXYZT=2 then RegistroXYZT:='Y';
            if contadorXYZT=3 then RegistroXYZT:='X';
            end;
            if contador=2 then begin
            if contadorXYZT=1 then RegistroXYZT:='Y';
            if contadorXYZT=2 then RegistroXYZT:='X';
            end;
            if contador=1 then begin
            if contadorXYZT=1 then RegistroXYZT:='X';
            end;

            if (aux^.valor>1111111111) and (aux^.valor<9.999999999e14) then begin
                y:=wherey;
                gotoxy(7,y);
                CadenaValor:= FloatToStr(aux^.valor);
                NumeroExp:=length(Cadenavalor);
                Valor28Exp:=NumeroExp-1;
                exponente1:= FloatToStr(NumeroExp-1);
                write(RegistroXYZT,' = ',CadenaValor[1],'.',CadenaValor[2],CadenaValor[3]);
                CadenaValor:= CadenaValor[1]+','+CadenaValor[2]+CadenaValor[3];
                aux^.valor:= STRToFloat(CadenaValor);
                Valor28:=aux^.valor;
                textColor (Red);
                write('E');
                textColor (White);
                write(exponente1);
                coordx:=wherex+2;
            end;
            if (aux^.valor<-1111111111) and (aux^.valor>-9.999999999e14) then begin
                y:=wherey;
                gotoxy(7,y);
                CadenaValor:= FloatToStr(aux^.valor);
                NumeroExp:=length(Cadenavalor);
                Valor28Exp:=NumeroExp-2;
                exponente1:= FloatToStr(NumeroExp-2);
                write(RegistroXYZT,' = ',CadenaValor[1],CadenaValor[2],'.',CadenaValor[3]);
                CadenaValor:= CadenaValor[1]+ CadenaValor[2]+ ',' + CadenaValor[3];
                aux^.valor:= STRToFloat(CadenaValor);
                Valor28:=aux^.valor;
                textColor (Red);
                write('E');
                textColor (White);
                write(exponente1);
                coordx:=wherex;
                negativo:=true;
            end;
            y:=wherey;
            gotoxy(7,y);
            if negativo=true then begin
                write(RegistroXYZT,' = ',aux^.valor:0:1);
                negativo:=False;
            end else write(RegistroXYZT,' = ',aux^.valor:0:ndecimais);
            coordx:=wherex;
            writeln;
            imprime:=FloatToStr(aux^.valor);
        end;
        append (arqCalculadora);
        writeln(ArqCalculadora,' = ',aux^.valor:0:2);
        close (arqCalculadora);
        x:=aux;
        aux:=aux^.sig;
        dispose(x);
    end;
    NumGrande:
    gotoxy(coordx + 4, y);
    textBackground (BLUE);   textColor (WHITE);
    writeln(' RESULTADO ');
    textBackground (BLACK);   textColor (WHITE);
    writeln('---------------------------------------                                         ');
    //writeln;
    contadorXYZT:=0;

end;

{------------------------------------------------------------------------------}

procedure cambiaPila(var p: PRpila);
var
  cambia: integer;
  aux : real;
  q, r: PRpila;

begin
      cambia:=1;
      r:=p;
      while( r^.sig<>NIL ) do begin
      r:=r^.sig;
      cambia:=cambia+1
      end;

      if (cambia <> 1) then
          begin
            aux:=p^.valor;
            q:=p^.sig;
            p^.valor:=q^.valor;
            q^.valor:=aux;

            end
      else begin
      end;

      mostrarPila(p);
      falaNumeroReal(p^.valor);
end;

{------------------------------------------------------------------------------}

procedure rotarPila(var p: PRpila);
var
  cambia: integer;
  aux, aux1, aux2, aux3 : real;
  q,r,s,t: PRpila;
begin
      cambia:=1;
      t:=p;
      while( t^.sig<>NIL ) do begin
      t:=t^.sig;
      cambia:=cambia+1
      end;

      case cambia of
        1 : ;
        2 :
            begin
                aux:=p^.valor;
                q:=p^.sig;
                p^.valor:=q^.valor;
                q^.valor:=aux;
            end;
        3 :
        begin
            aux:=p^.valor;
            q:=p^.sig;
            aux1:=q^.valor;
            r:=q^.sig;
            aux2:=r^.valor;
            r^.valor:=aux1;
            p^.valor:=aux1;
            q^.valor:=aux2;
            r^.valor:=aux;
        end;
        4 :
        begin
            aux:=p^.valor;
            q:=p^.sig;
            aux1:=q^.valor;
            r:=q^.sig;
            aux2:=r^.valor;
            r^.valor:=aux1;
            s:=r^.sig;
            aux3:=s^.valor;
            p^.valor:=aux1;
            q^.valor:=aux2;
            r^.valor:=aux3;
            s^.valor:=aux;
        end;
      else
          begin
              aux:=p^.valor;
              q:=p^.sig;
              aux1:=q^.valor;
              r:=q^.sig;
              aux2:=r^.valor;
              r^.valor:=aux1;
              s:=r^.sig;
              aux3:=s^.valor;
              p^.valor:=aux1;
              q^.valor:=aux2;
              r^.valor:=aux3;
              s^.valor:=aux;
          end;
      end;
     mostrarpila(p);
     falaNumeroReal(p^.valor);
end;
{------------------------------------------------------------------------------}

function InOperandos(p: PRpila):String;

var
    Numero, Punto, Funcion: boolean;
    x,y, posy, cod, i, contador, Nregistro, ComparaEx: integer;
    valor: double;
    cin, borrado:char;
    tecla, tecla2, tecla3: string[15];
    auxiliar: PRpila;

label cambio;
label Fecha;
label IngresoDatos;
label IngresoDatos1;
label BorraTodo;
label BEGEND;
label ExponenteIN;
label Cientifica;
label Cientifica1;
label decimales;
label Inmediato;
label PruebaTECLADO;
label CasiFinal;

begin


    IngresoDatos1:
    textBackground (NCOLOR);   textColor (WHITE);
    delay(100);
    append (arqCalculadora);
    write(arqCalculadora,'Operando: ');
    close (arqCalculadora);
    write('Operando: ');
    textBackground (BLACK);   textColor (WHITE);
    write('0');
    sintSom('HPOPERANDO');
    posy:=wherey;
    gotoxy (11,posy);

    repeat
        textBackground (BLACK);   textColor (WHITE);
        IngresoDatos:
        cin:=readkey;
{-------------------------Validacion de datos----------------------------------}
        if (punto=TRUE) then begin
            if (cin=ENTER) or (cin=#$08) or (cin=#$1b) then begin
                punto:=FALSE;
            end else
            if (cin in ['0'..'9']) or (cin='e') or (cin='t') or (cin='n') or
            (cin='i') or (cin='p') or (cin='m') or (cin='v') or (cin='k') or
            (cin=#9) or (cin=#10) or (cin=#11) or (cin=#14) or (cin=#20) or (cin=#32)
            then begin
                punto:=TRUE;
            end else begin
                sintSom ('HPnada');
                goto IngresoDatos;
            end;
        end;
        if (Numero=TRUE) then begin
            if (cin in ['0'..'9']) or (cin=ENTER) or (cin=#$08) or (cin='.') or
            (cin='e') or (cin='t') or (cin='n') or (cin='i') or (cin='p') or
            (cin='m') or (cin='v') or (cin='k') or (cin=#9) or (cin=#10) or
            (cin=#11) or (cin=#14) or (cin=#$1b) or (cin=#20) then begin
                Numero:=FALSE
            end else
            if (cin=#32) then begin
            end else begin
                sintSom ('HPnada');
                goto IngresoDatos;
            end;
        end;
        if (Funcion=TRUE) then begin
            if(cin=ENTER) or (cin=#$08) or (cin=#$1b)or (cin=#20) then begin
                Funcion:=FALSE;
            end else
            if (cin=#32) then begin
            end else
            if(cin in ['0'..'9','.']) and (tecla[1]='-') then begin
                NUmero:=TRUE;
                punto:=FALSE;
                Funcion:=FALSE;
            end else begin
                sintSom ('HPnada');
                goto IngresoDatos;
            end;
        end;
{------------------------------------------------------------------------------}
        if (cin<> ENTER) then begin
            Borratodo:
            if (cin = #$08) then begin
                if (length (tecla) > 0) then begin
                    NumeroGeneral:=False;
                    tecla:='';
                    y:=wherey;
                    gotoxy (11,y);
                    textBackground (BLACK);
                    clreol;
                    sintsom ('HPBORRADO');
                    write('0');
                    sintSom('HPOPERANDO');
                    posy:=wherey;
                    gotoxy (11,posy);
                end else begin
                    sintSom ('HPnada');
                end;
            end else
{------------------------Ingreso de Nmeros------------------------------------}
            if cin in ['0'..'9', '.'] then begin
                if (cin='.')then punto:=TRUE;
                if cin in ['0'..'9'] then Numero:=TRUE;
                NumeroGeneral:=TRUE;
                write(cin);
                sintCarac (cin);
                tecla:=tecla+cin;
            end else
{----------------Ingreso de Nmeros Grandes Exponete---------------------------}
          Cientifica:
          if (cin='e') then begin
                    mensajes(cin);
                    val(tecla,v1,cod);
                    tecla:='E';
                    ExponenteIN:
                    sintSom('HPEEX');
                    ComparaEx:=2;
                    repeat
                        Cientifica1:
                        cin:=readkey;
                        if cin='-' then ComparaEx:=3;
                        if (cin<> ENTER) then begin
                            if (cin = #$08) then begin
                                if (length (tecla) > 0) then begin
                                    tecla:='';
                                    tecla2:='';
                                    y:=wherey;
                                    gotoxy (11,y);
                                    textBackground (BLACK);
                                    clreol;
                                    sintsom ('HPBORRADO');
                                    write('0');
                                    sintSom('HPOPERANDO');
                                    posy:=wherey;
                                    gotoxy (11,posy);
                                    goto ingresodatos;
                                end else begin
                                    sintSom ('HPnada');
                                end;
                            end else
                            if ( cin ='t')then begin
                                mensajes(cin);
                                if (tecla2[1]='-') then begin
                                    for i:=1 to length(tecla2)-1 do begin
                                        tecla3:=tecla3+tecla2[i+1];
                                    end;
                                    tecla2[1]:=' ';
                                    tecla2:=tecla3;
                                    tecla3:='';
                                    y:=wherey;
                                    x:=wherex;
                                    gotoxy (x-length(tecla2)-1,y);
                                    ClrEol;
                                    write(tecla2);
                                end else begin
                                    tecla2:='-' + tecla2;
                                    y:=wherey;
                                    x:=wherex;
                                    gotoxy (x-length(tecla2)+1,y);
                                    ClrEol;
                                    write(tecla2);
                                end;
                            end
                            else
                            if cin in ['0'..'9', '-'] then begin
                                if (length (tecla2) > 0) and (cin='-') then begin
                                    sintSom ('HPnada');
                                    goto Cientifica1;
                                end;
                                write(cin);
                                if cin='-' then begin sintSom('HPmenos');
                                end else sintCarac(cin);
                                tecla2:=tecla2+cin;
                            end
                            else begin
                                sintSom ('HPTECLAINV');
                            end;
                        end else  begin
                        end;
                        if (length(tecla2)=ComparaEx) then begin
                            repeat
                                sintSom ('HPnada');
                                cin:= readkey;
                            until (cin = #$08) or (cin = ENTER);
                            if cin = #$08 then begin
                                tecla2:='';
                                goto BorraTodo;
                            end;
                        end;
                    until cin=ENTER;
                    val(tecla2,v2,cod);
                    if (v2<-100) or (v2>99) or (FRAC(v2)<>0) then begin
                        y:=wherey;
                        x:=wherex;
                        gotoxy (x-length (tecla2),y);
                        textBackground (BLACK);
                        clreol;
                        tecla2:='';
                        goto ExponenteIn;
                    end;
                    EscribeArchivo(tecla+'E'+tecla2);
                    v2:=Power(10,v2);
                    v1:=v1*v2;
                    writeln;
                    tecla:=FLOATTOSTR(v1);
                    for i:=1 to Length(tecla) do begin
                        if tecla[i]=',' then tecla[i]:='.';
                    end;
                    if Length(tecla) = 10 then goto CasiFinal;
                    cin:=ENTER;
          end
          else

{--------------------------Cambio de Signo-------------------------------------}
          cambio:
          if ( cin ='t')then begin
              if (length (tecla) > 0) then begin
                  mensajes(cin);
                  if (tecla[1]='-') then begin
                      for i:=1 to length(tecla)-1 do begin
                      tecla2:=tecla2+tecla[i+1];
                      end;
                      tecla:=tecla2;
                      tecla2:='';
                  end else
                  tecla:='-' + tecla;
                  delline;
                  y:=wherey;
                  gotoxy (1,y);
                  textBackground (NCOLOR);   textColor (WHITE);
                  write('Operando: ');
                  textBackground (Black);   textColor (WHITE);
                  write(tecla);
                  Numero:=TRUE;
              end else begin
                  mensajes(cin);
                  delline;
                  y:=wherey;
                  gotoxy (1,y);
                  textBackground (NCOLOR);   textColor (WHITE);
                  write('Operando: ');
                  textBackground (Black);   textColor (WHITE);
                  tecla:=cin;
                  cin:=ENTER;
              end;
          end else
          PruebaTECLADO:
          if cin=#20 then begin             //Control + T
                  TestTeclado:=TRUE;
                  FuncionesTeclado;
                  tecla:='';
                  TestTeclado:=FALSE;
                  inicializaSinSon;
                  sintSom('HPRegresoCalc');
                  goto IngresoDatos1;
          end else
{--------------------------Operaciones Bsicas---------------------------------}
          if cin in ['+', '*', '/', '-'] then
                begin
                    if (length (tecla) > 0) and (cin='-') then begin
                        sintSom ('HPnada');
                        goto IngresoDatos;
                    end;
                    Funcion:=TRUE;
                    mensajes(cin);
                    tecla:=cin;
                end
          else
          if (cin = '%') or (cin = 'y') or (cin = 'Y') or //Porcentaje
          {(cin = 'z') or }(cin = 'Z') or (cin = #26) or
          (cin = 'q') or (cin = 'Q') or (cin = #17) or
          (cin = 'w') or (cin = 'W') or (cin = #23) then
                begin
                    Funcion:=TRUE;
                    mensajes(cin);
                    tecla:=cin;
                end
          else
          if (cin = 'z') then
                begin
                    Funcion:=TRUE;
                    mensajes(cin);
                    tecla:=cin;
                    cin:=ENTER;
                end
          else
          if (cin = 'x') or (cin = 'X') or (cin = #24) or
          (cin = 'E') or (cin = #5) or (cin = 'f') or
          (cin = 'g') or (cin = 'G') then
                begin
                    Funcion:=TRUE;
                    mensajes(cin);
                    tecla:=cin;
                end
          else
{-------------------Teclas de Interes Simple y Compuesto-----------------------}
          if (cin = 'N') or //n
          (cin = 'I') or
          (cin = 'l') or (cin = 'L') or (cin =#12) or
          (cin = 'P') or    //PV
          (cin = 'M') or    //PMT
          (cin = 'V') or    //V
          (cin = 'j') or (cin = 'J') or
          (cin = 'K') then
                begin
                    Funcion:=TRUE;
                    mensajes(cin);
                    tecla:=cin;
                end
          else
          Inmediato:
          if (cin = 'n') or (cin = #14) or
          (cin = 'i') or (cin = #9 ) or
          (cin = 'p') or
          (cin = 'm') or
          (cin = 'v') or
          (cin = 'k') or (cin = #11) then begin
              sintSom('HPArmazena');
              mensajes(cin);
              if (length (tecla) > 0) then begin
                  val(tecla,v1,cod);               // lo convierto a real
                  poner(p,v1);
                  if(cin = #14) then pilaReal (v1*12);
                  if(cin = #9) then pilaReal (v1/12);
                  if(cin = 'n') or
                  (cin = 'i') or
                  (cin = 'p') or
                  (cin = 'm') or
                  (cin = 'v') or
                  (cin = 'k') or (cin = #11) then pilaReal (v1);
                  writeln;
                  tecla:=cin;
                  cin:=ENTER;
              end;
              if (length (tecla) = 0) then begin
                  if p=nil then begin
                      writeln;
                      errores(6);
                      goto ingresoDatos1;
                  end;
                  v1:=p.valor;
                  if(cin = #14) then pilaReal (v1*12);
                  if(cin = #9) then pilaReal (v1/12);
                  if(cin = 'n') or
                  (cin = 'i') or
                  (cin = 'p') or
                  (cin = 'm') or
                  (cin = 'v') or
                  (cin = 'k') or (cin = #11) then pilaReal (v1);
                  writeln;
                  tecla:=cin;
                  cin:=ENTER;
              end;
          end
          else
          BEGEND:
          if ( cin = #10)then       // BEG, END
                begin
                    if (memoriafi[6]=0) then
                    begin
                    writeln('BEG');
                    sintSom ('HPBEG');
                    memoriafi[6]:=1;
                    end else
                    if (memoriafi[6]=1) then
                    begin
                    writeln('END');
                    sintSom ('HPEND');
                    memoriafi[6]:=0;
                    end;
                goto IngresoDatos1;
                end
          else
{----------------------Teclas de Borrado de Datos------------------------------}
          if ( cin ='a') or ( cin ='A')or ( cin = #1) then begin
              mensajes(cin);
              writeln;
              tecla:=cin;
              cin:=enter;
          end else
{----------------------------Recuperacion de datos-----------------------------}
          if ( cin ='r')then begin
              mensajes(cin);
              tecla:=cin;
              cin:=enter;
          end else
          if ( cin ='R')then begin
              mensajes(cin);
              tecla:=cin;
              cin:=enter;
          end else
{----------------------------Almacenamiento de datos-----------------------------}
          if ( cin ='s')then begin
              mensajes(cin);
              tecla:=cin;
              cin:=enter;
          end else
{-------------------Tecla de configuraciones Generales-------------------------}
{------------------------------Define Decimales--------------------------------}
          decimales:
          if ( cin ='d')then
                 begin
                    mensajes(cin);
                    cin:=NumeroDecimales;
                    tecla:='';
                    if DecimalEX then exit;
                    goto IngresoDatos1;
                 end
          else
          Fecha:
          if ( cin ='D')or ( cin =#4)then //Fechas
                 begin
                    Funcion:=TRUE;
                    mensajes(cin);
                    tecla:=cin;
                 end
          else
          if ( cin ='h')or ( cin = 'H')then //Fechas
                 begin
                    mensajes(cin);
                    tecla:=cin;
                 end
          else
{------------------------------Menu de funciones-------------------------------}
          if ( cin =#6)then
                 begin
                          //sintSom('HPfungen');
                          x:=wherex;
                          y:=wherey;
                          cin:=ayudacomandos;
                          if (retornomenu=TRUE) and (cin=#0) then begin
                              inicializaSinSon;
                              retornomenu:=FALSE;
                              goto IngresoDatos1;
                          end;
                          gotoxy(x,y);
                          if retornomenu=TRUE then begin
                              gotoxy(1,y);
                              textBackground (NCOLOR);   textColor (WHITE);
                              write('Operando: ');
                              textBackground (BLACK);   textColor (WHITE);
                              gotoxy(x,y);
                          end;
                          if (cin = 'n') or (cin = #14) or
                             (cin = 'i') or (cin = #9 ) or
                             (cin = 'p') or
                             (cin = 'm') or
                             (cin = 'v') or
                             (cin = 'k') or (cin = #11) then goto Inmediato;
                          if (cin='e') then goto Cientifica;
                          if (cin=#0) or  (cin=#6)then goto IngresoDatos;
                          if (cin='t') then goto cambio;
                          if (cin=#10) then goto BEGEND;
                          if (cin=#20) then goto PruebaTECLADO;
                          if (cin='d') then goto decimales;
                          if (cin='D') or (cin=#1)then goto Fecha;
                          if (cin='u') or (cin='U')then begin
                              gotoxy(1,11);
                              goto IngresoDatos1;
                          end;
                          mensajes(cin);
                          Funcion:=TRUE;
                          tecla:=cin;
                 end
          else
{----------------------------Teclas Especiales---------------------------------}
          if ( cin = #0 )then begin
              cin:=readkey;
              if ( cin in [#59..#67] )then begin        //F1,F3-F9
                  sintSom ('HPF1');
              end;
              if ( cin = #77 )then begin       // Flecha derecha
                  if (p <> NIL) then begin
                      sintSom('HPPilaPrimero');
                      sintCarac ('X');
                      delay(200);
                      pilaReal (p^.valor);
                  end else begin
                      sintSom ('HPnada');
                  end;
              end;
              if ( cin = #75 )then begin       // Flecha izquierda
                  auxiliar:=p;
                  Nregistro:=0;
                  if (auxiliar <> NIL) then begin
                      sintSom('HPXYZT');
                      while( auxiliar<>NIL ) do begin
                          if Nregistro=0 then  sintCarac ('X');
                          if Nregistro=1 then  sintCarac ('Y');
                          if Nregistro=2 then  sintCarac ('Z');
                          if Nregistro=3 then  sintCarac ('T');
                          delay(200);
                          if (contador=2) then break;
                          if (Nregistro=4) then break;
                          pilaReal(auxiliar^.valor);
                          delay(200);
                          auxiliar:=auxiliar^.sig;
                          Nregistro:=Nregistro+1;
                      end;
                      delay(100);
                      sintSom('HPOPERANDO');
                  end else begin
                      sintSom ('HPnada');
                  end;
              end;
              if ( cin = #80 )then begin       // Flecha para abajo
                  if (p <> NIL) then begin
                      EscribeArchivo('Rolagem da Pila');
                      writeln('Rolagem da Pila');
                      sintSom('HPROTAPILA');
                      delay(300);
                      rotarpila(p);
                      textBackground (NCOLOR);   textColor (WHITE);
                      write('Operando: ');
                      sintSom('HPOPERANDO');
                  end else begin
                      sintSom ('HPnada');
                  end;
              end;
              if ( cin =#72)then begin        //Flecha para arriba
                  if (p <> NIL) then begin
                      EscribeArchivo('Troca X por Y');
                      writeln('Troca X por Y');
                      sintSom('HPCAMBIAXY');
                      delay(300);
                      cambiapila(p);
                      textBackground (NCOLOR);   textColor (WHITE);
                      write('Operando: ');
                      sintSom('HPOPERANDO');
                  end else begin
                      sintSom ('HPnada');
                  end;
              end;
              if ( cin = #73 )then begin       // PGUP
                  if (periodo=0) then begin
                      writeln('Juros Compostos Periodo Frac.');
                      sintSom ('HPPeIrregular');
                      periodo:=1;
                  end else
                  if (periodo=1) then begin
                      writeln('Juros Simples Periodo Frac.');
                      sintSom ('HPPeIrregularSimple');
                      periodo:=2;
                  end else
                  if (periodo=2) then begin
                      writeln('Juros Compostos S/Periodo Frac.');
                      sintSom ('HPPeRegular');
                      periodo:=0;
                  end;
                  goto IngresoDatos1;
              end;
          end
          else
{-------------------------Barra Espaciadora------------------------------------}
          if (cin=#32) then //Barra espaciadora
                begin
                      if tecla<>'' then sintSom('HPdigitado');
                      Reproducedigitado(tecla);
                end
          else
{-------------------------------Salida-----------------------------------------}
          if (cin=#$1b) then // cuando presiona ESC
                begin
                      EscribeArchivo('ESC');
                      writeln(cin);
                      finHP12c;
                      inicializaSinSon;
                      tecla:=cin;
                      cin:=ENTER;
                end
          else begin
              sintSom ('HPTECLAINV');
      end;
     if (length(tecla)=10) then begin
     repeat
        sintSom ('HPnada');
        cin:= readkey;
        if cin='e' then goto Cientifica;
     until (cin = #$08) or (cin = ENTER);
        if cin = #$08 then begin
            Numero:=FALSE;
            goto BorraTodo;
        end;
        if cin = ENTER then writeln;
     end;

     CasiFinal:


     end else  begin

                    writeln;
     end;


     until cin=ENTER;
     NumeroGeneral:=False;
     posy:=wherey;
        if (posy>24) then begin
        inicializaSinSon;
     end;
     Inoperandos:=tecla;
end;
{------------------------------------------------------------------------------}

end.

