{------------------------------------------------------------------------------}
{
{    Menu iterativo
{
{    Autor: Julian Prada Sanmiguel
{
{    Em 27/05/09
{
{------------------------------------------------------------------------------}

unit HP12Cmenu;

interface

uses
  Math,
  DVcrt,
  DVWin,
  sysUtils,
  Windows,
  StrUtils,
  HP12Cvariables,
  HP12Cinicializa,
  HP12Cexemplos;


function ayudaComandos: char;
function imprimemenu: char;
procedure setasMenuIterativo(posicionX: integer; posicionY: integer;
  colorBackground: byte; colorText: byte; texto: string);
procedure setaABAJO;
procedure setaARRIBA;
procedure setaDERECHA;
procedure setaIZQUIERDA;
procedure iniciaVariables;
procedure fondoMENU;
//procedure creaTablaCONSTANTES;
//procedure creaTablaCONSTANTES_USUARIO;
//procedure separaConstantesMENU;
//procedure separaConstantesMENU_USUARIO;
//procedure menuCONSTANTES;
//procedure menuCONSTANTES_USUARIO;
procedure caseMENU;
procedure caseMENU2;
procedure limpiaVariablesMenu;
procedure leeCOMANDO;
//procedure insertarFuncion(exp: string);
procedure setaAYUDA;
procedure setaF2;
procedure setaF3;
procedure setaF4;
procedure setaF5;
procedure setaF6;
procedure setaF7;
procedure setaF8;
procedure setaF9;
procedure setaF11;
//procedure menuCONVERSOES;
//procedure creaTablaEXPRESSOES;
//procedure separaExpressoes;
//procedure menuEXPRESSOES;
//procedure menuVARIAVEIS;
//procedure insertaPARAMETROS;
function insertaPARAMETROS: char;
//procedure menuPregunta;
//procedure escribe(texto: string);
//procedure pregunta(texto: string);
//procedure apaga;
//procedure limpaLinha;
//procedure limpaParametros;
//procedure inserirParametros(a: integer);
//procedure inserirParametrosConvesion(a, b: string; c: integer);
//function menuPreguntaDecide(a, b, c, d: string): integer;
//function menuPreguntaDecide2(a, b, c, d, e, f: string): integer;
function menuACTIVOF(menu: integer): integer;
//function menuARQUIVOX(a: string): string;
//function menuARQUIVOY(a: string): string;
//function menuARQUIVOZ(a: string): string;
//function menuARQUIVOXP(a: string): string;
//function menuARQUIVOYP(a: string): string;
//function menuARQUIVOZP(a: string): string;
function comandoACTIVO(menu: integer): integer;
//procedure menuAYUDA;
//procedure inserirExemplo(numero:integer);

implementation


var
  tablaCONSTANTES: TextFile;
  tablaCONSTANTES_USUARIO: TextFile;
  tablaEXPRESSOES: TextFile;

  SY: integer;
  punteroMENU: integer;
  limS: integer;
  limIC: integer;
  limIV: integer;
  limIFB: integer;
  limIEsta: integer;
  limIPorcen: integer;
  limiFinAdi: integer;
  limIExemplos: integer;
  limIManuais: integer;
  limIManuaisFINESTA: integer;
  limIFTB: integer;
  limD: integer;
  limICONS: integer;
  limICONS_U: integer;
  limICONVESOES: integer;
  limIEXPRESSSOES: integer;
  limIAYUDA: integer;
  SM: integer;
  bordeSuperior: integer;
  bordeInferior: integer;
  seleccionMenu: integer;
  numeroConstantes: integer;
  numeroConstantesUsuario: integer;
  numeroExpressoes: integer;
  numeroMENUS: integer;
  menuACTIVO: integer;


  cursorX: integer;
  SXA: integer;
  SYA: integer;
  SND: integer; //numero dados
  AC: integer; //arquivo carregado

  insertarLINEA: string;
  arquivoCom: string;
  linea: string;
  som: string;

  comandosMENU: array of string;
  funcionesMENU_GERAIS: array of string;
  funcionesMENU_TB: array of string;
  funcionesMENU_TBI: array of string;
  funcionesMENU_TH: array of string;
  funcionesMENU_THI: array of string;
  constantesMENU: array of string;
  constantesMENU_USUARIO: array of string;
  constantesNombreMENU: array of string;
  constantesNombreMENU_USUARIO: array of string;
  expressoesMENU: array of string;
  expressoesNombreMENU: array of string;
  conversoes: array of string;
  variaveisMENU: array of string;
  exemplosMENU: array of string;
  ManuaisMENU: array of string;
  ManuaisMENUFINESTA: array of string;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CLAREA VARIAVEIS DA UNIDADE
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure limpiaVariablesMenu;
var
  i: integer;
begin
  SetLength(constantesMENU_USUARIO, 0);
  SetLength(constantesMENU_USUARIO, 15);
  SetLength(constantesNombreMENU_USUARIO, 0);
  SetLength(constantesNombreMENU_USUARIO, 15);
  SetLength(expressoesMENU, 0);
  SetLength(expressoesMENU, 15);
  SetLength(expressoesNombreMENU, 0);
  SetLength(expressoesNombreMENU, 15);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// IMPORTA CONSTANTES FISICAS DA CALCULADORA
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
{procedure creaTablaCONSTANTES;
var
  i: integer;
begin
  i := 0;
  AssignFile(tablaCONSTANTES, dirSomEdivox + '\COMANDOS\CONFIG\constantes.txt');
  Reset(tablaCONSTANTES);
  while not Eof(tablaCONSTANTES) do
  begin
    SetLength(constantesMENU, high(constantesMENU) + 2);
    ReadLn(tablaCONSTANTES, constantesMENU[i]);
    inc(i);
  end;
  CloseFile(tablaCONSTANTES);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// IMPORTA CONSTANTES DO USUARIO
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}

{procedure creaTablaCONSTANTES_USUARIO;
var
  i: integer;
begin
  i := 0;
  AssignFile(tablaCONSTANTES_USUARIO, dirSomEdivox +
    '\COMANDOS\CONFIG\constantesUsuario.txt');
  Reset(tablaCONSTANTES_USUARIO);
  while not Eof(tablaCONSTANTES_USUARIO) do
  begin
    SetLength(constantesMENU_USUARIO, high(constantesMENU_USUARIO) + 2);
    ReadLn(tablaCONSTANTES_USUARIO, constantesMENU_USUARIO[i]);
    if constantesMENU_USUARIO[i] <> '' then
      inc(i);
  end;
  CloseFile(tablaCONSTANTES_USUARIO);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// IMPORTA AS EXPRESSOES DO USUARIO
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}

{procedure creaTablaEXPRESSOES;
var
  i: integer;
begin
  i := 0;
  AssignFile(tablaEXPRESSOES, dirSomEdivox +
    '\COMANDOS\CONFIG\ExpressoesUsuario.txt');
  Reset(tablaEXPRESSOES);
  while not Eof(tablaEXPRESSOES) do
  begin
    SetLength(expressoesMENU, high(expressoesMENU) + 2);
    ReadLn(tablaEXPRESSOES, expressoesMENU[i]);
    if expressoesMENU[i] <> '' then
      inc(i);
  end;
  CloseFile(tablaEXPRESSOES);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// PROCEDIMENTO PRINCIPAL DA UNIDADE
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
function ayudacomandos;
var
    op: char;
begin
  iniciaVariables;
  op:=imprimeMenu;
  ayudacomandos:=op;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// SEPARA O NOME E O VALOR DAS CONSTANTES DO SISTEMA
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
{procedure separaConstantesMENU;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := 2;
  while constantesMENU[i] <> '' do
  begin
    SetLength(constantesNombreMENU, high(constantesNombreMENU) + 2);
    constantesNombreMENU[j] := constantesMENU[i];
    i := i + 3;
    inc(j);
  end;
  numeroConstantes := j - 1;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// SEPARA O NOME E O VALOR DAS CONSTANTES DO USUARIO
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
{procedure separaConstantesMENU_USUARIO;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := 2;
  while constantesMENU_USUARIO[i] <> '' do
  begin
    SetLength(constantesNombreMENU_USUARIO, high(constantesNombreMENU_USUARIO) +
      2);
    constantesNombreMENU_USUARIO[j] := constantesMENU_USUARIO[i] + '=' +
      constantesMENU_USUARIO[i + 1];
    i := i + 2;
    inc(j);
  end;
  numeroConstantesUsuario := j - 1;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// SEPARA O NOME E O VALOR DAS EXPRESSOES DO USUARIO
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
{procedure separaExpressoes;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := 2;
  while expressoesMENU[i] <> '' do
  begin
    SetLength(expressoesNombreMENU, high(expressoesNombreMENU) + 2);
    expressoesNombreMENU[j] := expressoesMENU[i];
    i := i + 2;
    inc(j);
  end;
  numeroExpressoes := j - 1;
end;
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// INICIALIZA AS VARIAVEIS DA UNIDADE
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure iniciaVariables;
var
  numeroFunG: integer;
  numeroFunTB: integer;
  numeroEsta: integer;
  numeroPorcen: integer;
  numeroFinAdi: integer;
  numeroExemplos : integer;
  numeroManuais : integer;
  numeroManuaisFINESTA : integer;
  numeroCom: integer;
  numeroConversoes: integer;
  numeroVAR: integer;
  numeroAYUDA: integer;
  i: integer;
begin
  SetLength(constantesMENU, 0);
  SetLength(constantesMENU, 15);
  SetLength(constantesMENU_USUARIO, 0);
  SetLength(constantesMENU_USUARIO, 15);
  SetLength(expressoesMENU, 0);
  SetLength(expressoesMENU, 15);
  SetLength(constantesNombreMENU, 0);
  SetLength(constantesNombreMENU, 15);
  SetLength(constantesNombreMENU_USUARIO, 0);
  SetLength(constantesNombreMENU_USUARIO, 15);
  SetLength(expressoesNombreMENU, 0);
  SetLength(expressoesNombreMENU, 15);
  SetLength(comandosMENU, 0);
  SetLength(comandosMENU, 5);
  SetLength(funcionesMENU_GERAIS, 0);
  SetLength(funcionesMENU_GERAIS, 5);
  SetLength(funcionesMENU_TB, 0);
  SetLength(funcionesMENU_TB, 5);
  SetLength(funcionesMENU_TBI, 0);
  SetLength(funcionesMENU_TBI, 5);
  SetLength(funcionesMENU_TH, 0);
  SetLength(funcionesMENU_TH, 5);
  SetLength(funcionesMENU_THI, 0);
  SetLength(funcionesMENU_THI, 5);
  SetLength(exemplosMENU, 0);
  SetLength(exemplosMENU, 5);
  SetLength(manuaisMENU, 0);
  SetLength(manuaisMENU, 5);
  SetLength(manuaisMENUFINESTA, 0);
  SetLength(manuaisMENUFINESTA, 5);
  SetLength(conversoes, 0);
  SetLength(conversoes, 5);
  SetLength(variaveisMENU, 0);
  SetLength(variaveisMENU, 5);
  //SetLength(exemplosMENU, 0);
  //SetLength(exemplosMENU, 5);
  //creaTablaCONSTANTES;
 // creaTablaCONSTANTES_USUARIO;
  //creaTablaEXPRESSOES;
  //separaConstantesMENU;
  //separaConstantesMENU_USUARIO;
  //separaEXPRESSOES;
  numeroMENUS := 9;       ///valor para saber el numero de menus
  numeroFunG := 9;
  numeroEsta := 9;
  numeroPorcen := 8;
  numeroFinAdi := 12;
  numeroExemplos := 13;
  numeroManuais := 18;
  numeroManuaisFINESTA := 6;
  numeroFunTB := 14;
  numeroCom := 16;
  numeroVAR := 6;
  numeroAYUDA:=4;
  numeroConversoes := 51;
  bordeSuperior := 0;
  bordeInferior := 4;
  seleccionMenu := 15;
  menuACTIVO := 0;
  limIC := 4 + numeroCom;
  limIV := 4 + numeroVAR;
  limIFB := 4 + numeroFunG;
  limIFTB := 4 + numeroFunTB;
  limIEsta := 4 + numeroEsta;
  limIPorcen := 4 + numeroPorcen;
  limIFinAdi := 4 + numeroFinAdi;
  limIExemplos := 4 + numeroExemplos;
  limIManuais := 4 + numeroManuais;
  limIManuaisFINESTA:= 4 + numeroManuaisFINESTA;
  limICONS := 4 + numeroConstantes;
  limICONS_U := 4 + numeroConstantesUsuario;
  limICONVESOES := 4 + numeroConversoes;
  limIEXPRESSSOES := 4 + numeroExpressoes;
  limIAYUDA := 4 + numeroAYUDA;
  limD := 30;
  limS := 15;
  //SM := 1008;
  SM:= 1008;
  arquivoCom := '';
{---------------------------Funciones Generales--------------------------------}
  SetLength(funcionesMENU_GERAIS, high(funcionesMENU_GERAIS) + 2);
  funcionesMENU_GERAIS[0] := '  ===== FUNCOES GERAIS =====  ';
  SetLength(funcionesMENU_GERAIS, high(funcionesMENU_GERAIS) + 2);
  funcionesMENU_GERAIS[1] := '';
  SetLength(funcionesMENU_GERAIS, high(funcionesMENU_GERAIS) + 2);
  funcionesMENU_GERAIS[2] := funcionesCompilador[0];
  SetLength(funcionesMENU_GERAIS, high(funcionesMENU_GERAIS) + 2);
  funcionesMENU_GERAIS[3] := funcionesCompilador[1];
  SetLength(funcionesMENU_GERAIS, high(funcionesMENU_GERAIS) + 2);
  funcionesMENU_GERAIS[4] := funcionesCompilador[2];
  SetLength(funcionesMENU_GERAIS, high(funcionesMENU_GERAIS) + 2);
  funcionesMENU_GERAIS[5] := funcionesCompilador[3];
  SetLength(funcionesMENU_GERAIS, high(funcionesMENU_GERAIS) + 2);
  funcionesMENU_GERAIS[6] := funcionesCompilador[4];
  SetLength(funcionesMENU_GERAIS, high(funcionesMENU_GERAIS) + 2);
  funcionesMENU_GERAIS[7] := funcionesCompilador[5];
  SetLength(funcionesMENU_GERAIS, high(funcionesMENU_GERAIS) + 2);
  funcionesMENU_GERAIS[8] := funcionesCompilador[6];
  SetLength(funcionesMENU_GERAIS, high(funcionesMENU_GERAIS) + 2);
  funcionesMENU_GERAIS[9] := funcionesCompilador[7];

{------------------------Funciones Estadisticas--------------------------------}
  SetLength(funcionesMENU_TB, high(funcionesMENU_TB) + 2);
  funcionesMENU_TB[0] := '  == FUNCOES ESTATISTICAS ==  ';
  SetLength(funcionesMENU_TB, high(funcionesMENU_TB) + 2);
  funcionesMENU_TB[1] := '';
  SetLength(funcionesMENU_TB, high(funcionesMENU_TB) + 2);
  funcionesMENU_TB[2] := funcionesCompilador[10];
  SetLength(funcionesMENU_TB, high(funcionesMENU_TB) + 2);
  funcionesMENU_TB[3] := funcionesCompilador[11];
  SetLength(funcionesMENU_TB, high(funcionesMENU_TB) + 2);
  funcionesMENU_TB[4] := funcionesCompilador[12];
  SetLength(funcionesMENU_TB, high(funcionesMENU_TB) + 2);
  funcionesMENU_TB[5] := funcionesCompilador[13];
  SetLength(funcionesMENU_TB, high(funcionesMENU_TB) + 2);
  funcionesMENU_TB[6] := funcionesCompilador[14];
  SetLength(funcionesMENU_TB, high(funcionesMENU_TB) + 2);
  funcionesMENU_TB[7] := funcionesCompilador[15];
  SetLength(funcionesMENU_TB, high(funcionesMENU_TB) + 2);
  funcionesMENU_TB[8] := funcionesCompilador[16];
  SetLength(funcionesMENU_TB, high(funcionesMENU_TB) + 2);
  funcionesMENU_TB[9] := funcionesCompilador[17];

{------------------------Registros Financeiras---------------------------------}
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[0] := '  == REGISTROS FINANCEIROS =  ';
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[1] := '';
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[2] := funcionesCompilador[21];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[3] := funcionesCompilador[22];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[4] := funcionesCompilador[23];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[5] := funcionesCompilador[24];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[6] := funcionesCompilador[25];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[7] := funcionesCompilador[26];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[8] := funcionesCompilador[27];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[9] := funcionesCompilador[28];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[10] := funcionesCompilador[29];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[11] := funcionesCompilador[30];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[12] := funcionesCompilador[31];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[13] := funcionesCompilador[32];
  SetLength(funcionesMENU_TBI, high(funcionesMENU_TBI) + 2);
  funcionesMENU_TBI[14] := funcionesCompilador[33];

{-------------------Funciones Financieras Adicionales--------------------------}
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[0] := '  === FUNCOES FINANCEIRAS ==  ';
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[1] := '';
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[2] := funcionesCompilador[36];
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[3] := funcionesCompilador[37];
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[4] := funcionesCompilador[38];
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[5] := funcionesCompilador[39];
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[6] := funcionesCompilador[40];
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[7] := funcionesCompilador[41];
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[8] := funcionesCompilador[42];
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[9] := funcionesCompilador[43];
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[10] := funcionesCompilador[44];
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[11] := funcionesCompilador[45];
  SetLength(funcionesMENU_THI, high(funcionesMENU_THI) + 2);
  funcionesMENU_THI[12] := funcionesCompilador[46];

{------------------------Funciones Porcentaje y Calendario---------------------}
  SetLength(funcionesMENU_TH, high(funcionesMENU_TH) + 2);
  funcionesMENU_TH[0] := '  ===== FUNCOES %/DATA =====  ';
  SetLength(funcionesMENU_TH, high(funcionesMENU_TH) + 2);
  funcionesMENU_TH[1] := '';
  SetLength(funcionesMENU_TH, high(funcionesMENU_TH) + 2);
  funcionesMENU_TH[2] := funcionesCompilador[50];
  SetLength(funcionesMENU_TH, high(funcionesMENU_TH) + 2);
  funcionesMENU_TH[3] := funcionesCompilador[51];
  SetLength(funcionesMENU_TH, high(funcionesMENU_TH) + 2);
  funcionesMENU_TH[4] := funcionesCompilador[52];
  SetLength(funcionesMENU_TH, high(funcionesMENU_TH) + 2);
  funcionesMENU_TH[5] := funcionesCompilador[53];
  SetLength(funcionesMENU_TH, high(funcionesMENU_TH) + 2);
  funcionesMENU_TH[6] := funcionesCompilador[54];
  SetLength(funcionesMENU_TH, high(funcionesMENU_TH) + 2);
  funcionesMENU_TH[7] := funcionesCompilador[55];
  SetLength(funcionesMENU_TH, high(funcionesMENU_TH) + 2);
  funcionesMENU_TH[8] := funcionesCompilador[56];
  SetLength(funcionesMENU_TH, high(funcionesMENU_TH) + 2);

{------------------------------Comandos----------------------------------------}
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[0] := '  ======== COMANDOS ========  ';
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[1] := '';
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[2] := comandosCompilador[0];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[3] := comandosCompilador[1];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[4] := comandosCompilador[2];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[5] := comandosCompilador[3];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[6] := comandosCompilador[4];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[7] := comandosCompilador[5];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[8] := comandosCompilador[6];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[9] := comandosCompilador[7];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[10] := comandosCompilador[8];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[11] := comandosCompilador[9];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[12] := comandosCompilador[10];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[13] := comandosCompilador[11];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[14] := comandosCompilador[12];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[15] := comandosCompilador[13];
  SetLength(comandosMENU, high(comandosMENU) + 2);
  comandosMENU[16] := comandosCompilador[14];

{--------------------------Exemplos--------------------------------------------}
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[0] := '  == EXEMPLOS INTERATIVOS ==  ';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[1] := '';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[2] := 'ENTRANDO NUMEROS';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[3] := 'DIGITACAO DE NUMEROS GRANDES';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[4] := 'NUMERO DE CASAS DECIMAIS';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[5] := 'SOMAR DOIS VALORES';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[6] := 'CALCULO DA RAIZ QUADRADA';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[7] := 'CALCULO DO LOGARITMO NATURAL';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[8] := 'CALCULO DO EXPONENCIAL';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[9] := 'CALCULO DA POTENCIA';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[10] := 'CALCULO DO INVERSO';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[11] := 'CALCULO DO FATORIAL';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[12] := 'PARTE INTEIRA DO VALOR';
  SetLength(exemplosMENU, high(exemplosMENU) + 2);
  exemplosMENU[13] := 'PARTE FRACIONARIA DO VALOR ';

{---------------------------Manuais--------------------------------------------}
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[0] := '  == EXEMPLOS ILUSTRATIVOS =  ';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[1] := '';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[2] := 'OPERACAO FINANVOX';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[3] := 'REGISTROS DA PILHA';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[4] := 'REGISTROS DA CALCULADORA';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[5] := 'ENTRANDO NUMEROS';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[6] := 'DIGITACAO DE NUMEROS GRANDES';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[7] := 'NUMERO DE CASAS DECIMAIS';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[8] := 'SOMAR DOIS VALORES';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[9] := 'CALCULO DA RAIZ QUADRADA';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[10] := 'CALCULO DO LOGARITMO NATURAL';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[11] := 'CALCULO DO EXPONENCIAL';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[12] := 'CALCULO DA POTENCIA';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[13] := 'CALCULO DO INVERSO';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[14] := 'CALCULO DO FATORIAL';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[15] := 'PARTE INTEIRA DO VALOR';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[16] := 'PARTE FRACIONARIA DO VALOR';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[17] := 'SETAS DO TECLADO';
  SetLength(manuaisMENU, high(manuaisMENU) + 2);
  manuaisMENU[18] := 'REGISTROS GERAIS FINANVOX';

{-----------------Exemplos Financeiros e Estatisticos--------------------------}
  SetLength(manuaisMENUFINESTA, high(manuaisMENUFINESTA) + 2);
  manuaisMENUFINESTA[0] := '  = EXEMPLOS CALC. FIN/EST =  ';
  SetLength(manuaisMENUFINESTA, high(manuaisMENUFINESTA) + 2);
  manuaisMENUFINESTA[1] := '';
  SetLength(manuaisMENUFINESTA, high(manuaisMENUFINESTA) + 2);
  manuaisMENUFINESTA[2] := 'REGISTROS FINANCEIROS';
  SetLength(manuaisMENUFINESTA, high(manuaisMENUFINESTA) + 2);
  manuaisMENUFINESTA[3] := 'REGISTROS FINANCEIROS AD.';
  SetLength(manuaisMENUFINESTA, high(manuaisMENUFINESTA) + 2);
  manuaisMENUFINESTA[4] := 'REGISTROS FINANCEIROS ESP.';
  SetLength(manuaisMENUFINESTA, high(manuaisMENUFINESTA) + 2);
  manuaisMENUFINESTA[5] := 'CALCULO n';
  SetLength(manuaisMENUFINESTA, high(manuaisMENUFINESTA) + 2);
  manuaisMENUFINESTA[6] := 'CALCULO i';
  {SetLength(manuaisMENUFINESTA, high(manuaisMENUFINESTA) + 2);
  manuaisMENUFINESTA[7] := 'CALCULO PV';
  SetLength(manuaisMENUFINESTA, high(manuaisMENUFINESTA) + 2);
  manuaisMENUFINESTA[8] := 'CALCULO PMT';
  SetLength(manuaisMENUFINESTA, high(manuaisMENUFINESTA) + 2);
  manuaisMENUFINESTA[9] := 'CALCULO FV';}
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CRIACAO DO MENU DE FUNCOES GERAIS CALCULADORA FINANVOX
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure menuFUNCIONES_GERAIS;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := limS;
  for i := bordeSuperior to bordeInferior do
  begin
    setasMenuIterativo(limD+16, j, BLUE, WHITE, funcionesMENU_GERAIS[i]);
    inc(j);
  end;
  setasMenuIterativo(limD+16, seleccionMenu, RED, WHITE,
    funcionesMENU_GERAIS[bordeSuperior]);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CRIACAO DO MENU DE FUNCOES ESTATISTICAS FINANVOX
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure menuFUNCIONES_TB;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := limS;
  for i := bordeSuperior to bordeInferior do
  begin
    setasMenuIterativo(limD+16, j, BLUE, WHITE, funcionesMENU_TB[i]);
    inc(j);
  end;
  setasMenuIterativo(limD+16, seleccionMenu, RED, WHITE,
    funcionesMENU_TB[bordeSuperior]);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CRIACAO DO MENU REGISTROS FINANCEIROS FINANVOX
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure menuFUNCIONES_TBI;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := limS;
  for i := bordeSuperior to bordeInferior do
  begin
    setasMenuIterativo(limD+16, j, BLUE, WHITE, funcionesMENU_TBI[i]);
    inc(j);
  end;
  setasMenuIterativo(limD+16, seleccionMenu, RED, WHITE,
    funcionesMENU_TBI[bordeSuperior]);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CRIACAO DO MENU DE FUNCOES FINANCEIRAS
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure menuFUNCIONES_THI;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := limS;
  for i := bordeSuperior to bordeInferior do
  begin
    setasMenuIterativo(limD+16, j, BLUE, WHITE, funcionesMENU_THI[i]);
    inc(j);
  end;
  setasMenuIterativo(limD+16, seleccionMenu, RED, WHITE,
    funcionesMENU_THI[bordeSuperior]);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CRIACAO DO MENU DE FUNCOES PORCENTAJE Y CALENDARIO FINANVOX
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure menuFUNCIONES_TH;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := limS;
  for i := bordeSuperior to bordeInferior do
  begin
    setasMenuIterativo(limD+16, j, BLUE, WHITE, funcionesMENU_TH[i]);
    inc(j);
  end;
  setasMenuIterativo(limD+16, seleccionMenu, RED, WHITE,
    funcionesMENU_TH[bordeSuperior]);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CRIACAO DO MENU DE COMANDOS
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure menuCOMANDOS;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := limS;
  for i := bordeSuperior to bordeInferior do
  begin
    setasMenuIterativo(limD+16, j, BLUE, WHITE, comandosMENU[i]);
    inc(j);
  end;
  setasMenuIterativo(limD+16, seleccionMenu, RED, WHITE,
    comandosMENU[bordeSuperior]);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CRIACAO DO MENU EXEMPLOS
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure menuEXEMPLOS;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := limS;
  for i := bordeSuperior to bordeInferior do
  begin
    setasMenuIterativo(limD+16, j, BLUE, WHITE, exemplosMENU[i]);
    inc(j);
  end;
  setasMenuIterativo(limD+16, seleccionMenu, RED, WHITE,
    exemplosMENU[bordeSuperior]);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CRIACAO DO MENU MANUAIS
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure menuManuais;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := limS;
  for i := bordeSuperior to bordeInferior do
  begin
    setasMenuIterativo(limD+16, j, BLUE, WHITE, manuaisMENU[i]);
    inc(j);
  end;
  setasMenuIterativo(limD+16, seleccionMenu, RED, WHITE,
    ManuaisMENU[bordeSuperior]);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CRIACAO DO MENU MANUAIS FINANCEIROS E ESTATISTICOS
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure menuManuaisFINESTA;
var
  i: integer;
  j: integer;
begin
  i := 0;
  j := limS;
  for i := bordeSuperior to bordeInferior do
  begin
    setasMenuIterativo(limD+16, j, BLUE, WHITE, manuaisMENUFINESTA[i]);
    inc(j);
  end;
  setasMenuIterativo(limD+16, seleccionMenu, RED, WHITE,
    ManuaisMENUFINESTA[bordeSuperior]);
end;
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE DO MENU
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
function imprimeMenu;
var
  caracter: char;
  salida: integer;
  op: char;
label RegresaExemplos;
begin
  salida := 0;
  fondoMENU;
  menuFUNCIONES_GERAIS;
  sintSom('HPfungen');
  repeat
      begin
          caracter := readkey;
          if caracter = #0 then begin
              caracter := readkey;
              if caracter = #80 then setaABAJO
              else
              if caracter = #72 then setaARRIBA
              else
              if caracter = #75 then setaIZQUIERDA
              else
              if caracter = #77 then setaDERECHA
              else
              if caracter = #60 then setaF2
              else
              if caracter = #61 then setaF3
              else
              if caracter = #62 then setaF4
              else
              if caracter = #63 then setaF5
              else
              if caracter = #64 then setaF6
              else
              if caracter = #65 then setaF7
              else
              RegresaExemplos:
              if caracter = #66 then setaF8
              else
              if caracter = #67 then setaF9
              else
              if caracter = #69 then setaF11
              else
              if caracter = #59 then setaAYUDA;
      end else begin
          if NOT(caracter in ['0'..'9', #08, '.', ',']) then begin
          if caracter=#27 then break;
          op:=insertaPARAMETROS;
          if  (op = 'u') or (op = 'U') or (op = #21) then begin
              DefineExemplo(op);
              if RetornoMenu = TRUE then begin
                  inicializaExemplos;
                  if  (op = 'u') then caracter:= #66;
                  if  (op = 'U') then caracter:= #67;
                  if  (op = #21) then caracter:= #69;
                  goto RegresaExemplos;
              end;
          end;
          if not( (op = 't') or                               //CHS
                  (op = 'e') or                               //E
                  (op = #0 ) or
                  (op = #20) or
                  (op = 's') or                               //STO
                  (op = 'r') or (op = 'R') or                 //RCL, LSTX
                  (op = #72) or                               //X<>Y
                  (op = #80) or                               //RP
                  (op = 'd') or                               //#D
                  (op = 'a') or (op = 'A') or (op = #1 ) or   //Apagado
                  (op = 'n') or (op = #14) or                 //Nmero de periodos n
                  (op = 'i') or (op = #9 ) or                 //Tasa de interes i
                  (op = 'p') or                               //Valor presente PV
                  (op = 'm') or                               //Valor Pago Periodico m
                  (op = 'v') or                               //Valor Fututo v
                  (op = 'k') or (op = #11) or                 //Fluxo de caixa inicial CFo, CFj,Nj
                  (op = 'u') or (op = 'U') or                 //Manuales y exemplos
                  (op = #10) or (op = #20)) then
                  sintSom('HPfuninserida');
                  imprimeMenu:=op;
                  salida := 1;
      end;
      end;
    end;
  until (caracter = #27) or (salida = 1); {ESCAPE}
  LimpiaMenu;
  textBackground(BLACK);
  if caracter = #27 then begin
      sintSom('HPRegresoCalc');
      if RetornoMenu=FALSE then sintSom('HPOperando');
  end;
  limpiaVariablesMenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE TECLA F2
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaF2;
begin
  fondoMENU;
  bordeSuperior := 0;
  bordeInferior := 4;
  SM := 990;
  menuACTIVO := abs(SM mod numeroMENUS);
  casemenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE TECLA F3
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaF3;
begin
  fondoMENU;
  bordeSuperior := 0;
  bordeInferior := 4;
  SM := 991;
  menuACTIVO := abs(SM mod numeroMENUS);
  casemenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE TECLA F4
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaF4;
begin
  fondoMENU;
  bordeSuperior := 0;
  bordeInferior := 4;
  SM := 992;
  menuACTIVO := abs(SM mod numeroMENUS);
  casemenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE TECLA F5
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaF5;
begin
  fondoMENU;
  bordeSuperior := 0;
  bordeInferior := 4;
  SM := 993;
  menuACTIVO := abs(SM mod numeroMENUS);
  casemenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE TECLA F6
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaF6;
begin
  fondoMENU;
  bordeSuperior := 0;
  bordeInferior := 4;
  SM := 994;
  menuACTIVO := abs(SM mod numeroMENUS);
  casemenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE TECLA F7
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaF7;
begin
  fondoMENU;
  bordeSuperior := 0;
  bordeInferior := 4;
  SM := 995;
  menuACTIVO := abs(SM mod numeroMENUS);
  casemenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE TECLA F8
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaF8;
begin
  fondoMENU;
  bordeSuperior := 0;
  bordeInferior := 4;
  SM := 996;
  menuACTIVO := abs(SM mod numeroMENUS);
  casemenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE TECLA F9
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaF9;
begin
  fondoMENU;
  bordeSuperior := 0;
  bordeInferior := 4;
  SM := 997;
  menuACTIVO := abs(SM mod numeroMENUS);
  casemenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE TECLA F11
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaF11;
begin
  fondoMENU;
  bordeSuperior := 0;
  bordeInferior := 4;
  SM := 998;
  menuACTIVO := abs(SM mod numeroMENUS);
  casemenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// TECLA F1, OPCOES DE AJUDA
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaAYUDA;
var
  i: integer;
  numeroCOMANDO, numeroComando2: integer;
  temp: integer;
begin
  numeroComando2 := comandoACTIVO(bordeSuperior);
  numeroCOMANDO := bordeSuperior;
  temp := menuACTIVO;
  menuACTIVO := menuACTIVOF(menuACTIVO);
  case menuACTIVO of
{----------------------Ayuda Funciones Generales-------------------------------}
    0:
      case numeroCOMANDO2 of
          2: sintSom('HPayudaPotencia');
          3: sintSom('HPayudaRaiz');
          4: sintSom('HPayudaInverso');
          5: sintSom('HPayudaExponencial');
          6: sintSom('HPayudaLN');
          7: sintSom('HPayudaFactorial');
          8: sintSom('HPayudaFRAC');
          9: sintSom('HPayudaINTG');
      end;
{----------------------Ayuda Funciones Estatisticas----------------------------}
    1:
      case numeroCOMANDO of
          2: sintSom('HpayudaSuma');
          3: sintSom('HpayudaSumaCorre');
          4: sintSom('HpayudaMedia');
          5: sintSom('HpayudaDesvio');
          6: sintSom('HpayudaMediaPon');
          7: sintSom('HpayudaEstimaX');
          8: sintSom('HpayudaEstimaY');
          9: sintSom('HpayudaCorrelacion');
      end;
{----------------------Ayuda Registros Financeiros-----------------------------}
    2:
      case numeroCOMANDO of
        2: sintSom('Hpayudan');
        3: sintSom('Hpayudai');
        4: sintSom('HpayudaPV');
        5: sintSom('HpayudaPMT');
        6: sintSom('HpayudaFV');
        7: sintSom('Hpayuda12X');
        8: sintSom('Hpayuda12i');
        9: sintSom('HpayudaCFo');
        10: sintSom('HpayudaCFj');
        11: sintSom('HpayudaNj');
        12: sintSom('HpayudaBEG');
        13: sintSom('HpayudaEND');
        14: sintSom('HPayudaPERIODOFRACC');
      end;
{---------------Ayuda Funciones Financeiras------------------------------------}
    3:
      case numeroCOMANDO of
        2: sintSom('HpayudaCN');
        3: sintSom('HpayudaCI');
        4: sintSom('HpayudaCPV');
        5: sintSom('HpayudaCPMT');
        6: sintSom('HpayudaCFV');
        7: sintSom('HpayudaAMORT');
        8: sintSom('HpayudaJS');
        9: sintSom('HpayudaNPV');
        10: sintSom('HpayudaDB');
        11: sintSom('HpayudaSL');
        12: sintSom('HpayudaSOYD');
      end;
{---------------Ayuda Funciones Porcentaje y Calendario------------------------}
    4:
      case numeroCOMANDO of
        2: sintSom('Hpayuda%');
        3: sintSom('Hpayuda%T');
        4: sintSom('Hpayudad%');
        5: sintSom('HpayudaDMA');
        6: sintSom('HpayudaMDA');
        7: sintSom('HpayudaDATE');
        8: sintSom('HpayudaDDYS');
      end;
{-------------------------------Comandos---------------------------------------}
    5:
      case numeroCOMANDO of
        2: sintSom('HPayudaCHS');
        3: sintSom('HPayudaEEX');
        4: sintSom('HPayudaSTO');
        5: sintSom('HPayudaRCL');
        6: sintSom('HPayudaXY');
        7: sintSom('HPayudaRP');
        8: sintSom('HPayudaXYZT');
        9: sintSom('HPayudaPilaPrimero');
        10: sintSom('HPayudaDecimais');
        11: sintSom('HPayudaBS');
        12: sintSom('HPayudaAR');
        13: sintSom('HPayudaARE');
        14: sintSom('HPayudaARF');
        15: sintSom('HPayudaLSTx');
        16: sintSom('HPAyudaTestarTeclado');
      end;
{--------------------------------Exemplos--------------------------------------}
    6:
      case numeroCOMANDO of
        2: sintSom('\COMANDOS\AYUDA\F29');
        3: sintSom('\COMANDOS\AYUDA\F30');
        4: sintSom('\COMANDOS\AYUDA\F31');
        5: sintSom('\COMANDOS\AYUDA\F32');
        6: sintSom('\COMANDOS\AYUDA\F33');
        7: sintSom('\COMANDOS\AYUDA\F54');
        8: sintSom('\COMANDOS\AYUDA\F55');
        9: sintSom('\COMANDOS\AYUDA\F56');
        10: sintSom('\COMANDOS\AYUDA\F57');
        11: sintSom('\COMANDOS\AYUDA\F58');
        12: sintSom('\COMANDOS\AYUDA\F60');
        13: sintSom('\COMANDOS\AYUDA\F61');
      end;
{---------------------------------Manuais--------------------------------------}
    7:
      case numeroCOMANDO of
        2: sintSom('\COMANDOS\AYUDA\F29');
        3: sintSom('\COMANDOS\AYUDA\F30');
        4: sintSom('\COMANDOS\AYUDA\F31');
        5: sintSom('\COMANDOS\AYUDA\F32');
        6: sintSom('\COMANDOS\AYUDA\F33');
        7: sintSom('\COMANDOS\AYUDA\F54');
        8: sintSom('\COMANDOS\AYUDA\F55');
        9: sintSom('\COMANDOS\AYUDA\F56');
        10: sintSom('\COMANDOS\AYUDA\F57');
        11: sintSom('\COMANDOS\AYUDA\F58');
        12: sintSom('\COMANDOS\AYUDA\F60');
        13: sintSom('\COMANDOS\AYUDA\F61');
      end;
    {8:
      if numeroComando > 1 then
        sintSoletra(constantesMenu_USUARIO[numeroComando * 2 - 3]);
    9:
      case numeroCOMANDO of
        0: sintSom('\COMANDOS\AYUDA\F122');
        2: sintSom('\COMANDOS\AYUDA\F71');
        3: sintSom('\COMANDOS\AYUDA\F72');
        4: sintSom('\COMANDOS\AYUDA\F73');
        5: sintSom('\COMANDOS\AYUDA\F74');
        6: sintSom('\COMANDOS\AYUDA\F75');
        7: sintSom('\COMANDOS\AYUDA\F76');
        8: sintSom('\COMANDOS\AYUDA\F77');
        9: sintSom('\COMANDOS\AYUDA\F78');
        10: sintSom('\COMANDOS\AYUDA\F79');
        11: sintSom('\COMANDOS\AYUDA\F80');
        12: sintSom('\COMANDOS\AYUDA\F81');
        13: sintSom('\COMANDOS\AYUDA\F82');
        14: sintSom('\COMANDOS\AYUDA\F83');
        15: sintSom('\COMANDOS\AYUDA\F84');
        16: sintSom('\COMANDOS\AYUDA\F85');
        17: sintSom('\COMANDOS\AYUDA\F86');
        18: sintSom('\COMANDOS\AYUDA\F87');
        19: sintSom('\COMANDOS\AYUDA\F88');
        20: sintSom('\COMANDOS\AYUDA\F89');
      end;
    10:
      if numeroComando > 1 then
        sintSoletra(ExpressoesMenu[numeroComando * 2 - 3]);}
  end;
  menuACTIVO := temp;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE SETA ESQUERDA
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaIZQUIERDA;
begin
  fondoMENU;
  bordeSuperior := 0;
  bordeInferior := 4;
  SM := SM - 1;
  menuACTIVO := abs(SM mod numeroMENUS);
  casemenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE SETA DIREITA
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaDERECHA;
begin
  fondoMENU;
  bordeSuperior := 0;
  bordeInferior := 4;
  SM := SM + 1;
  menuACTIVO := abs(SM mod numeroMENUS);
  casemenu;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE TECLA ABAIXO
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaABAJO;
var
  menu: integer;
  temp: integer;
begin
  temp := menuACTIVO;
  menuACTIVO := menuACTIVOF(menuACTIVO);
  case menuACTIVO of
    0:      //Funciones Generales
      begin
        if bordeInferior < limIFB then
        begin
          if bordeSuperior = 0 then
          begin
            inc(bordeSuperior);
            inc(bordeInferior);
          end;
          inc(bordeSuperior);
          inc(bordeInferior);
          fondoMenu;
          menuFUNCIONES_GERAIS;
        end;
      end;
    1:      //Funciones Estatsticas
      begin
        if bordeInferior < limIEsta then
        begin
          if bordeSuperior = 0 then
          begin
            inc(bordeSuperior);
            inc(bordeInferior);
          end;
          inc(bordeSuperior);
          inc(bordeInferior);
          fondoMenu;
          menuFUNCIONES_TB;
        end;
      end;
    2:     //Registros Financeiros
      begin
        if bordeInferior < limIFTB then
        begin
          if bordeSuperior = 0 then
          begin
            inc(bordeSuperior);
            inc(bordeInferior);
          end;
          inc(bordeSuperior);
          inc(bordeInferior);
          fondoMenu;
          menuFUNCIONES_TBI;
        end;
      end;
    3:     //Funciones Financieras
      begin
        if bordeInferior < limiFinAdi then
        begin
          if bordeSuperior = 0 then
          begin
            inc(bordeSuperior);
            inc(bordeInferior);
          end;
          inc(bordeSuperior);
          inc(bordeInferior);
          fondoMenu;
          menuFUNCIONES_THI;
        end;
      end;
    4:     //Funciones de porcentaje y calendario
      begin
        if bordeInferior < limIPorcen then
        begin
          if bordeSuperior = 0 then
          begin
            inc(bordeSuperior);
            inc(bordeInferior);
          end;
          inc(bordeSuperior);
          inc(bordeInferior);
          fondoMenu;
          menuFUNCIONES_TH;
        end;
      end;
    5:     //Comandos
      begin
        if bordeInferior < limIC then
        begin
          if bordeSuperior = 0 then
          begin
            inc(bordeSuperior);
            inc(bordeInferior);
          end;
          inc(bordeSuperior);
          inc(bordeInferior);
          fondoMenu;
          menuCOMANDOS;
        end;
      end;
    6:     //Exemplos Interativos
      begin
        if bordeInferior < limIExemplos then
        begin
          if bordeSuperior = 0 then
          begin
            inc(bordeSuperior);
            inc(bordeInferior);
          end;
          inc(bordeSuperior);
          inc(bordeInferior);
          fondoMenu;
          menuEXEMPLOS;
        end;
      end;
    7:     //Exemplos Ilustrativos
      begin
        if bordeInferior < limIManuais then
        begin
          if bordeSuperior = 0 then
          begin
            inc(bordeSuperior);
            inc(bordeInferior);
          end;
          inc(bordeSuperior);
          inc(bordeInferior);
          fondoMenu;
          menuMANUAIS;
        end;
      end;
    8:     //Exemplos Financeiros e Estatisticos Ilustrativos
      begin
        if bordeInferior < limIManuaisFINESTA then
        begin
          if bordeSuperior = 0 then
          begin
            inc(bordeSuperior);
            inc(bordeInferior);
          end;
          inc(bordeSuperior);
          inc(bordeInferior);
          fondoMenu;
          menuMANUAISFINESTA;
        end;
      end;
  end;
  menuACTIVO := temp;
  leeComando;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE SETA ARRIBA
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setaARRIBA;
begin
  if bordeSuperior = 2 then
  begin
    dec(bordeSuperior);
    dec(bordeInferior);
  end;
  if bordeSuperior > 0 then
  begin
    dec(bordeSuperior);
    dec(bordeInferior);
    fondoMenu;
    caseMENU2;
    leeComando;
  end;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE IMPRESSAO E FALA DO MENU
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure caseMENU;
var
  temp: integer;
begin
  temp := menuACTIVO;
  menuACTIVO := menuACTIVOF(menuACTIVO);
  case menuACTIVO of
    0:
      begin
        menuFUNCIONES_GERAIS;    //Funciones Generales
        sintSom('HPfungen');
      end;
    1:
      begin
        menuFUNCIONES_TB;        //Funciones Estatisticas
        sintSom('HPfunesta');
      end;
    2:
      begin
        menuFUNCIONES_TBI;       //Registros Financieras
        sintSom('HPRegfin');
      end;
    3:
      begin
        menuFUNCIONES_THI;       //Funciones Financieras
        sintSom('HPfunfin');
      end;
    4:
      begin
        menuFUNCIONES_TH;        //Funciones de Porcentaje y Calendario
        sintSom('HPfunporca');
      end;
    5:
      begin
        menuCOMANDOS;            //Comandos
        sintSom('HPComandos');
      end;
    6:
      begin                      //Exemplos FINANVOX
        menuEXEMPLOS;
        sintSom('HPfunexemplos');
      end;
    7:
      begin
        menuMANUAIS;              //Manuais FINANVOX
        sintSom('HPfunExemplosIlus');
      end;
    8:
      begin
        menuMANUAISFINESTA;     //Manuais Financeiros e Estatisticos
        sintSom('HPfunExemplosFINESTA');
      end;
  end;
  menuACTIVO := temp;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// CONTROLE IMPRESSAO DO MENU 2
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure caseMENU2;
var
  temp: integer;
begin
  temp := menuACTIVO;
  menuACTIVO := menuACTIVOF(menuACTIVO);
  case menuACTIVO of
    0: menuFUNCIONES_GERAIS;
    1: menuFUNCIONES_TB;
    2: menuFUNCIONES_TBI;
    3: menuFUNCIONES_THI;
    4: menuFUNCIONES_TH;
    5: menuCOMANDOS;
    6: menuEXEMPLOS;
    7: menuMANUAIS;
    8: menuMANUAISFINESTA;
  end;
  menuACTIVO := temp;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// IMPRESAO LINHAS DO MENU
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure setasMenuIterativo(posicionX: integer; posicionY: integer;
  colorBackground: byte; colorText: byte; texto: string);
begin
  gotoxy(posicionX, posicionY);
  textColor(colorText);
  textBackground(colorBackground);
  writeln(texto);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// IMPRESSAO QUADRO PRINCIPAL DO MENU
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure fondoMENU;
var
  i: integer;
begin
  for i := limS - 4 to limS + 9 do
  begin
    textBackground(BLACK);
    gotoxy(40, i);
    writeln('|');
  end;
  textBackground(RED);
  gotoxy(limD +14, limS - 2);
  writeln(' FINANVOX  v.1.0 ');
  textBackground(blue);
  for i := limS - 1 to limS + 5 do
  begin
    gotoxy(limD +14, i);
    writeln('                                  ');
  end;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// LEITURA DE COMANDO, FUNCOES ETC
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
procedure leeCOMANDO;
var
  i: integer;
  numeroCOMANDO, numeroComando2: integer;
  temp: integer;
begin
  temp := menuACTIVO;
  numeroComando2 := comandoACTIVO(bordeSuperior);
  numeroCOMANDO := bordeSuperior;
  menuACTIVO := menuACTIVOF(menuACTIVO);
  case menuACTIVO of
    0:  case numeroCOMANDO2 of
          0: sintSom('HPfungen');
          2: sintSom('HPelevado');
          3: sintSom('HPraiz');
          4: sintSom('HPinverso');
          5: sintSom('HPexponencial');
          6: sintSom('HPlogaritmo');
          7: sintSom('HPfactorial');
          8: sintSom('HPPartefracc');
          9: sintSom('HPparteint');
          10: sintSom('HPRND');
        end;
    1:  case numeroCOMANDO of
          0: sintSom('HPfunesta');
          2: sintSom('HPsumatoria');
          3: sintSom('HPsumatoriaCorre');
          4: sintSom('HPmedia');
          5: sintSom('HPdesviopa');
          6: sintSom('HPmediapon');
          7: sintSom('HPestimax');
          8: sintSom('HPestimay');
          9: sintSom('HPcorrelacion');
        end;
    2:  case numeroCOMANDO of
          0: sintSom('HPRegfin');
          2: sintSom('HPn');
          3: sintSom('HPi');
          4: sintSom('HPpv');
          5: sintSom('HPpmt');
          6: sintSom('HPfv');
          7: sintSom('HPn12');
          8: sintSom('HPi12');
          9: sintSom('HPCFo');
          10: sintSom('HPCFj');
          11: sintSom('HPNj');
          12: sintSom('HPBEG');
          13: sintSom('HPEND');
          14: sintSom('HPPERIODOFRACC');
        end;
    3:  case numeroCOMANDO of
          0: sintSom('HPFunFin');
          2: sintSom('HPnCalculo');
          3: sintSom('HPiCalculo');
          4: sintSom('HPpvCalculo');
          5: sintSom('HPpmtCalculo');
          6: sintSom('HPfvCalculo');
          7: sintSom('HPAmort');
          8: sintSom('HPintsimple');
          9: sintSom('HPNPV');
          10: sintSom('HPDB');
          11: sintSom('HPSL');
          12: sintSom('HPSOYD');
        end;
    4:  case numeroCOMANDO of
          0: sintSom('HPfunporca');
          2: sintSom('HPporcentaje');
          3: sintSom('HPtotporcentaje');
          4: sintSom('HPdifporcentaje');
          5: sintSom('HPDMY');
          6: sintSom('HPMDY');
          7: sintSom('HPDATE');
          8: sintSom('HPDDYS');
        end;
    5:  case numeroCOMANDO of
          0: sintSom('HPComandos');
          2: sintSom('HPCHS');
          3: sintSom('HPEEX');
          4: sintSom('HPSTO');
          5: sintSom('HPrecupera');
          6: sintSom('HPcambiaxy');
          7: sintSom('HProtapila');
          8: sintSom('HPXYZT');
          9: sintSom('HPPilaprimero');
          10: sintSom('HPdecimais');
          11: sintSom('HPBS');
          12: sintSom('HPCleartodo');
          13: sintSom('HPClearEsta');
          14: sintSom('HPClearFin');
          15: sintSom('HPLSTX');
          16: sintSom('HPF2TestarTeclado');
        end;
    6:  case numeroCOMANDO of
          0: sintSom('HPfunExemplos');
          2: sintSom('HPexemplo12');
          3: sintSom('HPexemplo10');
          4: sintSom('HPexemplo11');
          5: sintSom('HPexemplo1');
          6: sintSom('HPexemplo2');
          7: sintSom('HPexemplo3');
          8: sintSom('HPexemplo4');
          9: sintSom('HPexemplo5');
          10: sintSom('HPexemplo6');
          11: sintSom('HPexemplo7');
          12: sintSom('HPexemplo8');
          13: sintSom('HPexemplo9');
        end;
    7:  case numeroCOMANDO of
          0: sintSom('HPfunExemplosIlus');
          2: sintSom('HPexemplo13');
          3: sintSom('HPexemplo14');
          4: sintSom('HPexemplo18');
          5: sintSom('HPexemplo12');
          6: sintSom('HPexemplo10');
          7: sintSom('HPexemplo11');
          8: sintSom('HPexemplo1');
          9: sintSom('HPexemplo2');
          10: sintSom('HPexemplo3');
          11: sintSom('HPexemplo4');
          12: sintSom('HPexemplo5');
          13: sintSom('HPexemplo6');
          14: sintSom('HPexemplo7');
          15: sintSom('HPexemplo8');
          16: sintSom('HPexemplo9');
          17: sintSom('HPexemplo19');
          18: sintSom('HPexemplo20');
        end;
    8:  case numeroCOMANDO of
          0: sintSom('HPfunExemplosFINESTA');
          2: sintSom('HPRegfin');
          3: sintSom('HPRegfinAD');
          4: sintSom('HPRegfinES');
          5: sintSom('HPnCalculo');
          6: sintSom('HPiCalculo');
          7: sintSom('HPpvCalculo');
          8: sintSom('HPpmtCalculo');
          9: sintSom('HPfvCalculo');
        end;

    {7:
      case numeroCOMANDO of
        0: sintSom('\COMANDOS\MENU\F68');
        2: sintSom('\COMANDOS\CONSTANTES\PI');
        3: sintSom('\COMANDOS\CONSTANTES\NE');
        4: sintSom('\COMANDOS\CONSTANTES\C1');
        5: sintSom('\COMANDOS\CONSTANTES\C2');
        6: sintSom('\COMANDOS\CONSTANTES\C3');
        7: sintSom('\COMANDOS\CONSTANTES\C4');
        8: sintSom('\COMANDOS\CONSTANTES\C5');
        9: sintSom('\COMANDOS\CONSTANTES\C6');
        10: sintSom('\COMANDOS\CONSTANTES\C7');
      end;
    8:
      begin
        case numeroCOMANDO of
          0: sintSom('\COMANDOS\MENU\F69');
        end;
        if numeroComando > 0 then
          sintSoletra(constantesMenu_USUARIO[numeroComando * 2 - 4]);
      end;
    9:
      case numeroCOMANDO of
        0: sintSom('\COMANDOS\MENU\F122');
        2: sintSom('\COMANDOS\MENU\F71');
        3: sintSom('\COMANDOS\MENU\F72');
        4: sintSom('\COMANDOS\MENU\F73');
        5: sintSom('\COMANDOS\MENU\F74');
        6: sintSom('\COMANDOS\MENU\F75');
        7: sintSom('\COMANDOS\MENU\F76');
        8: sintSom('\COMANDOS\MENU\F77');
        9: sintSom('\COMANDOS\MENU\F78');
        10: sintSom('\COMANDOS\MENU\F79');
      end;
    10:
      begin
        case numeroCOMANDO of
          0: sintSom('\COMANDOS\MENU\F123');
        end;
        if numeroComando > 0 then
          sintSoletra(expressoesMenu[numeroComando * 2 - 4]);
      end;    }
  end;
  menuACTIVO := temp;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// FUNCAO PARA ORGANIZAR O NUMERO DE CADA MENU NO MENU PRINCIPAL
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
function menuACTIVOF(menu: integer): integer;
begin
  if menu = 0 then
    menuACTIVOF := 0
  else if menu = 1 then
    menuACTIVOF := 1
  else if menu = 2 then
    menuACTIVOF := 2
  else if menu = 3 then
    menuACTIVOF := 3
  else if menu = 4 then
    menuACTIVOF := 4
  else if menu = 5 then
    menuACTIVOF := 5
  else if menu = 6 then
    menuACTIVOF := 6
  else if menu = 7 then
    menuACTIVOF := 7
  else if menu = 8 then
    menuACTIVOF := 8
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// FUNCAO PARA ORGANIZAR O NUMERO DE CADA MENU COMANDOS
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
function comandoACTIVO(menu: integer): integer;
begin
    case menu of
        2: comandoACTIVO := 2;
        3: comandoACTIVO := 3;
        4: comandoACTIVO := 4;
        5: comandoACTIVO := 5;
        6: comandoACTIVO := 6;
        7: comandoACTIVO := 7;
        8: comandoACTIVO := 8;
        9: comandoACTIVO := 9;
        10: comandoACTIVO := 10;
        11: comandoACTIVO := 11;
        12: comandoACTIVO := 12;
        13: comandoACTIVO := 13;
        14: comandoACTIVO := 14;
        15: comandoACTIVO := 15;
        16: comandoACTIVO := 16;
        17: comandoACTIVO := 17;
        18: comandoACTIVO := 18;
        19: comandoACTIVO := 19;
    end;
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
// INSERE PARAMETROS DOS COMANDO E MENU DE FORMA INTERATIVA COM O USUARIO
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
function insertaParametros: char;
label
  ignora1;
label
  ignora2;
label
  ignora3;
label
  ignora4;
label
  ignora5;
label
  ignora6;
label
  ignora7;
label
  ignora8;
var
  i: integer;
  j: integer;
  numeroCOMANDO: integer;
  numeroComando2: integer;
  temp: integer;
  salida: integer;
  f: integer;
  textoSalida: string;
  a: string;
  b: string;
  c: string;
  d: string;
  ext: string;

begin
  SXA := 0;
  SYA := 0;
  som := '1';
  SND := 0;
  AC := 0;
  linea := '';
  temp := menuACTIVO;
  numeroCOMANDO := bordeSuperior;
  NumeroExemplo := numeroCOMANDO;
  numeroComando2 := comandoACTIVO(bordeSuperior);
  menuACTIVO := menuACTIVOF(menuACTIVO);
  case menuACTIVO of
{-------------------------Funciones Generales----------------------------------}
    0:  begin
            case numeroCOMANDO2 of
                2: insertaparametros:=#5;     //Elevado
                3: insertaparametros:='X';
                4: insertaparametros:='x';
                5: insertaparametros:='E';
                6: insertaparametros:=#24;    //LN
                7: insertaparametros:='f';
                8: insertaparametros:='G';
                9: insertaparametros:='g';
                10: insertaparametros:='t';
            end;
        end;
{--------------------------Funciones Estatisticas------------------------------}
    1:  begin
            case numeroCOMANDO of
                2: insertaparametros:='z';
                3: insertaparametros:='Z';
                4: insertaparametros:='q';
                5: insertaparametros:=#17;    //s
                6: insertaparametros:='Q';
                7: insertaparametros:='w';
                8: insertaparametros:='W';
                9: insertaparametros:=#23;    //r
            end;
        end;
{--------------------------Registros Financeiros-------------------------------}
    2:  begin
            case numeroCOMANDO of
                2: insertaparametros:='n';
                3: insertaparametros:='i';
                4: insertaparametros:='p';
                5: insertaparametros:='m';
                6: insertaparametros:='v';
                7: insertaparametros:=#14;   //12x
                8: insertaparametros:=#9;    //12/
                9: insertaparametros:='k';
                10: insertaparametros:='k';
                11: insertaparametros:=#11;    //Nj
                12: insertaparametros:=#10;   //BEG
                13: insertaparametros:=#10;   //END

          end;
        end;
{-----------------------Funciones Financeiras----------------------------------}
    3:  begin
            case numeroCOMANDO of
                2: insertaparametros:='N';
                3: insertaparametros:='I';
                4: insertaparametros:='P';
                5: insertaparametros:='M';
                6: insertaparametros:='V';
                7: insertaparametros:='J';
                8: insertaparametros:='j';
                9: insertaparametros:='K';
                10: insertaparametros:='l';
                11: insertaparametros:='L';
                12: insertaparametros:=#12;
            end;
        end;
{-----------------------Funciones de Porcentaje y Calendario-------------------}
    4:  begin
            case numeroCOMANDO of
                2: insertaparametros:='%';
                3: insertaParametros:='Y';
                4: insertaParametros:='y';
                5: insertaParametros:='D';
                6: insertaParametros:=#4;
                7: insertaParametros:='H';
                8: insertaParametros:='h';
            end;
        end;
{-------------------------------Comandos---------------------------------------}
    5:  begin
            case numeroCOMANDO of
                2: insertaparametros:='t';
                3: insertaParametros:='e';
                4: insertaParametros:='s';
                5: insertaParametros:='r';
                6: insertaParametros:=#0;
                7: insertaParametros:=#0;
                8: insertaParametros:=#0;
                9: insertaParametros:=#0;
                10: insertaParametros:='d';
                11: insertaparametros:=#08;
                12: insertaParametros:='a';
                13: insertaParametros:='A';
                14: insertaParametros:=#1;
                15: insertaParametros:='R';
                16: insertaParametros:=#20;
            end;
        end;
{----------------------------Exemplos FINANVOX---------------------------------}
    6:
      begin
        case numeroCOMANDO of
          2: insertaParametros:='u';
          3: insertaParametros:='u';
          4: insertaParametros:='u';
          5: insertaParametros:='u';
          6: insertaParametros:='u';
          7: insertaParametros:='u';
          8: insertaParametros:='u';
          9: insertaParametros:='u';
          10: insertaParametros:='u';
          11: insertaParametros:='u';
          12: insertaParametros:='u';
          13: insertaParametros:='u';
          14: insertaParametros:='u';
          15: insertaParametros:='u';
          16: insertaParametros:='u';
          17: insertaParametros:='u';
          18: insertaParametros:='u';
          19: insertaParametros:='u';
          20: insertaParametros:='u';
        end;
      end;
{------------------------------Manuais FINANVOX--------------------------------}
    7:
      begin
        case numeroCOMANDO of
          2: insertaParametros:='U';
          3: insertaParametros:='U';
          4: insertaParametros:='U';
          5: insertaParametros:='U';
          6: insertaParametros:='U';
          7: insertaParametros:='U';
          8: insertaParametros:='U';
          9: insertaParametros:='U';
          10: insertaParametros:='U';
          11: insertaParametros:='U';
          12: insertaParametros:='U';
          13: insertaParametros:='U';
          14: insertaParametros:='U';
          15: insertaParametros:='U';
          16: insertaParametros:='U';
          17: insertaParametros:='U';
          18: insertaParametros:='U';
          19: insertaParametros:='U';
          20: insertaParametros:='U';
          21: insertaParametros:='U';
          22: insertaParametros:='U';
          23: insertaParametros:='U';
          24: insertaParametros:='U';
        end;
      end;
    8:
      begin
        case numeroCOMANDO of
          2: insertaParametros:=#21;
          3: insertaParametros:=#21;
          4: insertaParametros:=#21;
          5: insertaParametros:=#21;
          6: insertaParametros:=#21;
          7: insertaParametros:=#21;
          8: insertaParametros:=#21;
          9: insertaParametros:=#21;
          10: insertaParametros:=#21;
          11: insertaParametros:=#21;
          12: insertaParametros:=#21;
          13: insertaParametros:=#21;
          14: insertaParametros:=#21;
          15: insertaParametros:=#21;
          16: insertaParametros:=#21;
          17: insertaParametros:=#21;
          18: insertaParametros:=#21;
          19: insertaParametros:=#21;
          20: insertaParametros:=#21;
        end;
      end;
  end;
  menuACTIVO := temp;
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// INSERE EXEMPLO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{procedure inserirExemplo(numero:integer);
var i: integer;
    exemplo: array of String;
    arquivo: TextFile;
begin
  i := 0;
  AssignFile(arquivo, dirSomEdivox +
    '\COMANDOS\EXEMPLOS\EXEMPLO'+intToStr(numero-1)+'.txt');
  Reset(arquivo);
  while not Eof(arquivo) do
  begin
    SetLength(exemplo, high(exemplo) + 2);
    ReadLn(arquivo, exemplo[i]);
    insereProxLinha(exemplo[i], FALSE);
    inc(i);
  end;
  CloseFile(arquivo);
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// DEFINE MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{procedure menuPregunta;
var
  caracter: char;
  salida: integer;
begin
  salida := 0;
  cursorX := 2;
  repeat
    begin
      caracter := readKey;
      if caracter = #8 then
        apaga
      else if caracter = #0 then
      begin
        caracter := readkey;
        if (caracter = #75) and (cursorX > 2) then
        begin
          sintCarac(linea[cursorX - 2]);
          dec(cursorX);
          GotoXY(cursorX, 23);
        end
        else if (caracter = #77) and (cursorX <= length(linea) + 1) then
        begin
          sintCarac(linea[cursorX - 1]);
          inc(cursorX);
          GotoXY(cursorX, 23);
        end
        else if (caracter = #59) then
          sintSom(som);
      end
      else if caracter = #27 then
      begin
        salida := 1;
        linea := '';
      end
      else if caracter = #13 then
      begin
        salida := 1;
      end
      else if (length(linea) <= 70) then
      begin
        sintCarac(caracter);
        escribe(caracter);
      end;
    end;
  until salida = 1;
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{procedure escribe(texto: string);
begin
  TextColor(white);
  TextBackground(red);
  GotoXY(2, 23);
  if cursorX >= 67 then
    exit;
  insert(texto, linea, cursorX - 1);
  GotoXY(cursorX, 23);
  inc(cursorX);
  limpaLinha;
  Write(linea);
  GotoXY(cursorX, 23);
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{procedure apaga;
begin
  TextColor(white);
  TextBackground(red);
  GotoXY(2, 23);
  if cursorX <= 2 then
    exit;
  dec(cursorX);
  delete(linea, cursorX - 1, 1);
  sintSom('\COMANDOS\PALABRAS\P13');
  limpaLinha;
  Write(linea);
  GotoXY(cursorX, 23);
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{procedure limpaLinha;
begin
  TextBackground(red);
  GotoXY(2, 23);
  Write('                                                                 ');
  GotoXY(2, 23);
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{procedure pregunta(texto: string);
begin
  TextColor(white);
  TextBackground(red);
  GotoXY(2, 22);
  Write(texto);
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{procedure limpaParametros;
begin
  TextBackground(black);
  GotoXY(1, 22);
  Write('                                                                                                    ');
  GotoXY(1, 23);
  Write('                                                                                                    ');
  TextBackground(red);
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO -  PERGUNTA CON VARIAS OPCOES
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{function menuPreguntaDecide(a, b, c, d: string): integer;
var
  salida: integer;
  caracter: string;
begin
  repeat
    begin
      caracter := readKey;
      if (caracter = a) or (caracter = b) or (caracter = #13) then
      begin
        escribe(caracter);
        menuPreguntaDecide := 1;
        salida := 1;
      end
      else if (caracter = c) or (caracter = d) or (caracter = #27) then
      begin
        escribe(caracter);
        menuPreguntaDecide := 0;
        salida := 1;
      end
      else if caracter = #0 then
      begin
        caracter := readKey;
        if (caracter = #59) then
          sintSom(som);
      end;
    end;
  until salida = 1;
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO - PERGUNTA COM VARIAS OPCOES
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{function menuPreguntaDecide2(a, b, c, d, e, f: string): integer;
var
  salida: integer;
  caracter: string;
begin
  repeat
    begin
      caracter := readKey;
      if (caracter = a) or (caracter = b) or (caracter = #13) then
      begin
        escribe(caracter);
        menuPreguntaDecide2 := 1;
        salida := 1;
      end
      else if (caracter = c) or (caracter = d) or (caracter = #27) then
      begin
        escribe(caracter);
        menuPreguntaDecide2 := 0;
        salida := 1;
      end
      else if (caracter = e) or (caracter = f) then
      begin
        escribe(caracter);
        menuPreguntaDecide2 := 2;
        salida := 1;
      end
      else if caracter = #0 then
      begin
        caracter := readKey;
        if (caracter = #59) then
          sintSom(som);
      end;
    end;
  until salida = 1;
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// INSERE PARAMETROS DA FUNCAO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{procedure inserirParametros(a: integer);
var
  j: integer;
  textoSalida: string;
begin
  limpaParametros;
  pregunta('Introduza o parmetro da funo:');
  sintSom('\COMANDOS\PARAMETROS\P39');
  som := '\COMANDOS\PARAMETROS\P39';
  menuPregunta;
  textoSalida := textoSalida + linea;
  linea := '';
  limpaParametros;
  pregunta('Funo inserida!!!');
  sintSom('\COMANDOS\PARAMETROS\P84');
  linea := funcionesCompilador[a] + '(' + textoSalida + ')';
  for j := 1 to length(linea) do
  begin
    insereLetra(linea[j]);
  end;
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// INSERE PARAMETROS DA FUNCAO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{procedure inserirParametrosConvesion(a, b: string; c: integer);
var
  j: integer;
  textoSalida: string;
begin
  limpaParametros;
  pregunta('Introduza o valor em ' + a + ':');
  sintSom('\COMANDOS\PARAMETROS\' + b);
  som := '\COMANDOS\PARAMETROS\' + b;
  menuPregunta;
  textoSalida := textoSalida + linea;
  linea := '';
  limpaParametros;
  pregunta('Comando Inserido!!!');
  sintSom('\COMANDOS\PARAMETROS\P4');
  linea := funcionesCompilador[c] + '(' + textoSalida + ')';
  for j := 1 to length(linea) do
  begin
    insereLetra(linea[j]);
  end;
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{function menuARQUIVOX(a: string): string;
var
  carga: array of string;
  arquivo: textfile;
  i: integer;
  cursorX: integer;
  cursorY: integer;
  salida: integer;
  NL: integer;
  caracter: string;
begin
  salida := 0;
  cursorX := 1;
  cursorY := 1;
  SetLength(carga, 10);
  i := 1;
  AssignFile(arquivo, a + '.txt');
  Reset(arquivo);
  while not Eof(arquivo) do
  begin
    SetLength(carga, high(carga) + 2);
    ReadLn(arquivo, carga[i]);
    inc(i);
  end;
  CloseFile(arquivo);
  NL := i;
  i := 1;
  TextColor(white);
  TextBackground(blue);
  GotoXY(1, 18);
  Write('                                                      ');
  GotoXY(cursorX, 18);
  Write(carga[cursorY]);
  repeat
    begin
      caracter := readKey;
      if caracter = #0 then
      begin
        caracter := readkey;
        if caracter = #80 then
        begin
          cursorX := 1;
          if cursorY >= NL then
          begin
            sintSom('\COMANDOS\PALABRAS\P14');
          end
          else
          begin
            inc(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #72 then
        begin
          if cursorY = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P15');
          end
          else
          begin
            cursorX := 1;
            dec(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #75 then
        begin
          if cursorX = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P16');
          end
          else
          begin
            dec(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #77 then
        begin
          if cursorX > length(carga[cursorY]) then
          begin
            sintSom('\COMANDOS\PALABRAS\P17');
          end
          else
          begin
            inc(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #63 then
        begin
          cursorX := cursorX + 5;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #64 then
        begin
          cursorX := cursorX + 10;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #62 then
        begin
          cursorX := cursorX - 5;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #61 then
        begin
          cursorX := cursorX - 10;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #60 then
        begin
          sintSom('\COMANDOS\PARAMETROS\P98');
          sintetiza(intToStr(cursorX));
          sintSom('\COMANDOS\PARAMETROS\P99');
          sintetiza(intToStr(cursorY));
        end;
      end;
      if caracter = #27 then
      begin
        salida := 1;
        menuARQUIVOX := '';
        SXA := 0;
      end
      else if caracter = #13 then
      begin
        menuARQUIVOX := intToStr(cursorX);
        salida := 1;
        if cursorX < SXA then
        begin
          sintSom('\COMANDOS\PARAMETROS\P91');
          salida := 0;
        end
        else
          SXA := (cursorX);
      end;
    end;
  until salida = 1;
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{function menuARQUIVOY(a: string): string;
var
  carga: array of string;
  arquivo: textfile;
  i: integer;
  cursorX: integer;
  cursorY: integer;
  salida: integer;
  NL: integer;
  caracter: string;
begin
  salida := 0;
  cursorX := 1;
  cursorY := 1;
  SetLength(carga, 10);
  i := 1;
  AssignFile(arquivo, a + '.txt');
  Reset(arquivo);
  while not Eof(arquivo) do
  begin
    SetLength(carga, high(carga) + 2);
    ReadLn(arquivo, carga[i]);
    inc(i);
  end;
  CloseFile(arquivo);
  NL := i;
  i := 1;
  TextColor(white);
  TextBackground(blue);
  GotoXY(1, 18);
  Write('                                                      ');
  GotoXY(cursorX, 18);
  Write(carga[cursorY]);
  repeat
    begin
      caracter := readKey;
      if caracter = #0 then
      begin
        caracter := readkey;
        if caracter = #80 then
        begin
          cursorX := 1;
          if cursorY >= NL then
          begin
            sintSom('\COMANDOS\PALABRAS\P14');
          end
          else
          begin
            inc(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #72 then
        begin
          if cursorY = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P15');
          end
          else
          begin
            cursorX := 1;
            dec(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #75 then
        begin
          if cursorX = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P16');
          end
          else
          begin
            dec(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #77 then
        begin
          if cursorX > length(carga[cursorY]) then
          begin
            sintSom('\COMANDOS\PALABRAS\P17');
          end
          else
          begin
            inc(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #63 then
        begin
          cursorX := cursorX + 5;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #64 then
        begin
          cursorX := cursorX + 10;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #62 then
        begin
          cursorX := cursorX - 5;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #61 then
        begin
          cursorX := cursorX - 10;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #60 then
        begin
          sintSom('\COMANDOS\PARAMETROS\P98');
          sintetiza(intToStr(cursorX));
          sintSom('\COMANDOS\PARAMETROS\P99');
          sintetiza(intToStr(cursorY));
        end;
      end;
      if caracter = #27 then
      begin
        salida := 1;
        menuARQUIVOY := '';
        SYA := 0;
      end
      else if caracter = #13 then
      begin
        menuARQUIVOY := intToStr(cursorY);
        salida := 1;
        if cursorY < SYA then
        begin
          sintSom('\COMANDOS\PARAMETROS\P91');
          salida := 0;
        end
        else
        begin
          if (SYA <> 0) and (SYA <> cursorY) then
            SND := 1;
          SYA := (cursorY);
        end;
      end;
    end;
  until salida = 1;
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{function menuARQUIVOZ(a: string): string;
var
  carga: array of string;
  arquivo: textfile;
  i: integer;
  cursorX: integer;
  cursorY: integer;
  salida: integer;
  NL: integer;
  caracter: string;
begin
  salida := 0;
  cursorX := 1;
  cursorY := 1;
  SetLength(carga, 10);
  i := 1;
  AssignFile(arquivo, a + '.txt');
  reset(arquivo);
  while not Eof(arquivo) do
  begin
    SetLength(carga, high(carga) + 2);
    ReadLn(arquivo, carga[i]);
    inc(i);
  end;
  CloseFile(arquivo);
  NL := i;
  i := 1;
  TextColor(white);
  TextBackground(blue);
  GotoXY(1, 18);
  Write('                                                      ');
  GotoXY(cursorX, 18);
  Write(carga[cursorY]);
  repeat
    begin
      caracter := readKey;
      if caracter = #0 then
      begin
        caracter := readkey;
        if caracter = #80 then
        begin
          cursorX := 1;
          if cursorY >= NL then
          begin
            sintSom('\COMANDOS\PALABRAS\P14');
          end
          else
          begin
            inc(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #72 then
        begin
          if cursorY = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P15');
          end
          else
          begin
            cursorX := 1;
            dec(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #75 then
        begin
          if cursorX = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P16');
          end
          else
          begin
            dec(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #77 then
        begin
          if cursorX > length(carga[cursorY]) then
          begin
            sintSom('\COMANDOS\PALABRAS\P17');
          end
          else
          begin
            inc(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #63 then
        begin
          cursorX := cursorX + 5;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #64 then
        begin
          cursorX := cursorX + 10;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #62 then
        begin
          cursorX := cursorX - 5;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #61 then
        begin
          cursorX := cursorX - 10;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #60 then
        begin
          sintSom('\COMANDOS\PARAMETROS\P98');
          sintetiza(intToStr(cursorX));
          sintSom('\COMANDOS\PARAMETROS\P99');
          sintetiza(intToStr(cursorY));
        end;
      end;
      if caracter = #27 then
      begin
        salida := 1;
        menuARQUIVOZ := '';
        SYA := 0;
        SXA := 0;
      end
      else if caracter = #13 then
      begin
        menuARQUIVOZ := intToStr(cursorX) + ',' + intToStr(cursorY);
        salida := 1;
      end;
    end;
  until salida = 1;
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{function menuARQUIVOXP(a: string): string;
var
  carga: array of string;
  arquivo: textfile;
  i: integer;
  cursorX: integer;
  cursorY: integer;
  salida: integer;
  NL: integer;
  a1: integer;
  b: integer;
  caracter: string;
begin
  salida := 0;
  cursorX := 1;
  cursorY := 1;
  SetLength(carga, 10);
  i := 1;
  AssignFile(arquivo, a + '.csv');
  Reset(arquivo);
  while not Eof(arquivo) do
  begin
    SetLength(carga, high(carga) + 2);
    ReadLn(arquivo, carga[i]);
    inc(i);
  end;
  CloseFile(arquivo);
  NL := i;
  i := 1;
  TextColor(white);
  TextBackground(blue);
  GotoXY(1, 18);
  Write('                                                      ');
  GotoXY(cursorX, 18);
  Write(carga[cursorY]);
  repeat
    begin
      caracter := readKey;
      if caracter = #0 then
      begin
        caracter := readkey;
        if caracter = #80 then
        begin
          cursorX := 1;
          if cursorY >= NL then
          begin
            sintSom('\COMANDOS\PALABRAS\P14');
          end
          else
          begin
            inc(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #72 then
        begin
          if cursorY = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P15');
          end
          else
          begin
            cursorX := 1;
            dec(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #75 then
        begin
          if cursorX = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P16');
          end
          else
          begin
            dec(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #77 then
        begin
          if cursorX > length(carga[cursorY]) then
          begin
            sintSom('\COMANDOS\PALABRAS\P17');
          end
          else
          begin
            inc(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #63 then
        begin
          cursorX := cursorX + 5;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #64 then
        begin
          cursorX := cursorX + 10;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #62 then
        begin
          cursorX := cursorX - 5;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #61 then
        begin
          cursorX := cursorX - 10;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #60 then
        begin
          sintSom('\COMANDOS\PARAMETROS\P98');
          sintetiza(intToStr(cursorX));
          sintSom('\COMANDOS\PARAMETROS\P99');
          sintetiza(intToStr(cursorY));

        end;
      end;
      if caracter = #27 then
      begin
        salida := 1;
        menuARQUIVOXP := '';
        SXA := 0;
      end
      else if caracter = #13 then
      begin
        b := 1;
        for a1 := 1 to cursorX - 1 do
        begin
          if carga[cursorY, a1] = ';' then
            inc(b);
        end;
        menuARQUIVOXP := intToStr(b);
        salida := 1;
      end;
    end;
  until salida = 1;
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{function menuARQUIVOYP(a: string): string;
var
  carga: array of string;
  arquivo: textfile;
  i: integer;
  cursorX: integer;
  cursorY: integer;
  salida: integer;
  NL: integer;
  caracter: string;
begin
  salida := 0;
  cursorX := 1;
  cursorY := 1;
  SetLength(carga, 10);
  i := 1;
  AssignFile(arquivo, a + '.csv');
  Reset(arquivo);
  while not Eof(arquivo) do
  begin
    SetLength(carga, high(carga) + 2);
    ReadLn(arquivo, carga[i]);
    inc(i);
  end;
  CloseFile(arquivo);
  NL := i;
  i := 1;
  TextColor(white);
  TextBackground(blue);
  GotoXY(1, 18);
  Write('                                                      ');
  GotoXY(cursorX, 18);
  Write(carga[cursorY]);
  repeat
    begin
      caracter := readKey;
      if caracter = #0 then
      begin
        caracter := readkey;
        if caracter = #80 then
        begin
          cursorX := 1;
          if cursorY >= NL then
          begin
            sintSom('\COMANDOS\PALABRAS\P14');
          end
          else
          begin
            inc(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #72 then
        begin
          if cursorY = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P15');
          end
          else
          begin
            cursorX := 1;
            dec(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #75 then
        begin
          if cursorX = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P16');
          end
          else
          begin
            dec(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #77 then
        begin
          if cursorX > length(carga[cursorY]) then
          begin
            sintSom('\COMANDOS\PALABRAS\P17');
          end
          else
          begin
            inc(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #63 then
        begin
          cursorX := cursorX + 5;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #64 then
        begin
          cursorX := cursorX + 10;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #62 then
        begin
          cursorX := cursorX - 5;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #61 then
        begin
          cursorX := cursorX - 10;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #60 then
        begin
          sintSom('\COMANDOS\PARAMETROS\P98');
          sintetiza(intToStr(cursorX));
          sintSom('\COMANDOS\PARAMETROS\P99');
          sintetiza(intToStr(cursorY));
        end;
      end;
      if caracter = #27 then
      begin
        salida := 1;
        menuARQUIVOYP := '';
        SYA := 0;
      end
      else if caracter = #13 then
      begin
        menuARQUIVOYP := intToStr(cursorY);
        salida := 1;
        if cursorY < SYA then
        begin
          sintSom('\COMANDOS\PARAMETROS\P91');
          salida := 0;
        end
        else
        begin
          if (SYA <> 0) and (SYA <> cursorY) then
            SND := 1;
          SYA := (cursorY);
        end;
      end;
    end;
  until salida = 1;
end;

{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}
// PROCEDIMENTO DE CONTROLE DO MENU INTERATIVO
{------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------------}

{function menuARQUIVOZP(a: string): string;
var
  carga: array of string;
  arquivo: textfile;
  i: integer;
  cursorX: integer;
  cursorY: integer;
  salida: integer;
  NL: integer;
  a1: integer;
  b: integer;
  caracter: string;
begin
  salida := 0;
  cursorX := 1;
  cursorY := 1;
  SetLength(carga, 10);
  i := 1;
  AssignFile(arquivo, a + '.csv');
  reset(arquivo);
  while not Eof(arquivo) do
  begin
    SetLength(carga, high(carga) + 2);
    ReadLn(arquivo, carga[i]);
    inc(i);
  end;
  CloseFile(arquivo);
  NL := i;
  i := 1;
  TextColor(white);
  TextBackground(blue);
  GotoXY(1, 18);
  Write('                                                      ');
  GotoXY(cursorX, 18);
  Write(carga[cursorY]);
  repeat
    begin
      caracter := readKey;
      if caracter = #0 then
      begin
        caracter := readkey;
        if caracter = #80 then
        begin
          cursorX := 1;
          if cursorY >= NL then
          begin
            sintSom('\COMANDOS\PALABRAS\P14');
          end
          else
          begin
            inc(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #72 then
        begin
          if cursorY = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P15');
          end
          else
          begin
            cursorX := 1;
            dec(cursorY);
            GotoXY(1, 18);
            Write('                                                      ');
            GotoXY(1, 18);
            Write(carga[cursorY]);
            GotoXY(1, 18);
            sintetiza(carga[cursorY]);
          end;
        end
        else if caracter = #75 then
        begin
          if cursorX = 1 then
          begin
            sintSom('\COMANDOS\PALABRAS\P16');
          end
          else
          begin
            dec(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #77 then
        begin
          if cursorX > length(carga[cursorY]) then
          begin
            sintSom('\COMANDOS\PALABRAS\P17');
          end
          else
          begin
            inc(cursorX);
            GotoXY(cursorX, 18);
            sintCarac(carga[cursorY, cursorX]);
          end;
        end
        else if caracter = #63 then
        begin
          cursorX := cursorX + 5;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #64 then
        begin
          cursorX := cursorX + 10;
          if cursorX > length(carga[cursorY]) then
          begin
            cursorX := length(carga[cursorY]);
            sintSom('\COMANDOS\PALABRAS\P17');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #62 then
        begin
          cursorX := cursorX - 5;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #61 then
        begin
          cursorX := cursorX - 10;
          if cursorX < 1 then
          begin
            cursorX := 1;
            sintSom('\COMANDOS\PALABRAS\P16');
          end;
          GotoXY(cursorX, 18);
          sintCarac(carga[cursorY, cursorX]);
        end
        else if caracter = #60 then
        begin
          sintSom('\COMANDOS\PARAMETROS\P98');
          sintetiza(intToStr(cursorX));
          sintSom('\COMANDOS\PARAMETROS\P99');
          sintetiza(intToStr(cursorY));
        end;
      end;
      if caracter = #27 then
      begin
        salida := 1;
        menuARQUIVOZP := '';
        SYA := 0;
        SXA := 0;
      end
      else if caracter = #13 then
      begin
        b := 1;
        for a1 := 1 to cursorX - 1 do
        begin
          if carga[cursorY, a1] = ';' then
            inc(b);
        end;
        menuARQUIVOZP := intToStr(b) + ',' + intToStr(cursorY);
        salida := 1;
      end;
    end;
  until salida = 1;
end;}

end.

