unit HP12Creproduce;

interface

uses  dvWin,
      dvCrt,
      sysUtils,
      dvlenum,
      HP12Cedarch,
      HP12Cvariables,
      HP12Cinicializa;

procedure FalaNumeroReal (numero: real);
procedure PilaReal (numero: real);
procedure PilaRealpequena (numero: real);
procedure Mensajes(c: string);
procedure ReproduceDigitado(c: string);
procedure MensajesMeses(mes: real);
procedure Errores(error: integer);
procedure FuncionesTeclado;




implementation
{------------------------------------------------------------------------------}


procedure falaNumeroReal (numero: real);
var
    s, exponente, exponente1, tamanoCadena, CadenaValor, exponente1R: string;
    l: int64;
    i{,nDecimais}, tamano: integer;
    nExponente, nExponente1, NumeroExp: real;
    podeFalar: boolean;

label Valor28Etiqueta;
begin
    exponente:='';
    exponente1:='';

    sintSom ('HPIGUAL');

    if numero < 0 then
    begin
            sintSom ('HPMENOS');
            numero := -numero;
    end;

    //if (numero>9.999999999e14) or (numero<0.00001) then begin
      if (numero>9.999999999e14) or (numero<0.0001) AND (numero>0) or
        (numero<-9.999999999e14) or (numero>-0.0001) AND (numero<0)then begin
         s:= FloatToStr(numero);
         tamano:=Length(s);
         for i:=1 to tamano do begin
              if s[i]=',' then s[i]:='.';
              if s[i]='E' then break;
              exponente:=exponente+s[i];
         end;
         val(exponente,nExponente,cod);
         for i:=i+1 to tamano do begin
              exponente1:=exponente1+s[i];
         end;
         val(exponente1,nExponente1,cod);
         pilarealpequena(nExponente);
         sintSom('HPEEX');
         pilarealpequena(nExponente1);
         exit;
    end;


    l := trunc (numero+0.000000000001);

    if (numero > 2000000000) and (numero<9.999999999e14) then begin
        //sintsoletra (intToStr (l))
        CadenaValor:= FloatToStr(numero);
        NumeroExp:=length(Cadenavalor);
        Valor28Exp:=NumeroExp-1;
        exponente1R:= FloatToStr(NumeroExp-1);
        CadenaValor:= CadenaValor[1]+','+CadenaValor[2]+CadenaValor[3];
        numero:= STRToFloat(CadenaValor);
        //Valor28:=aux^.valor;
        //numero:=valor28;
        pilarealpequena(numero);
        sintSom('HPEEX');
        pilarealpequena(valor28exp);
        exit;
    end else
        falaNumeroConv (numeroParaString (l), MASCULINO);


    if numero - trunc (numero) <> 0 then begin
       { if numero - trunc (numero) < 0.001 then begin
            tamanoCadena:=FLOATTOSTR(numero);
            ndecimais:= Length(tamanoCadena)-3;
        end; }
            str (numero:18:ndecimais, s);
            podeFalar := false;
            for i := 1 to length (s) do
                begin
                    if s[i] = '.' then
                        begin
                            sintSoletra ('.');  {virgula}
                            podeFalar := true;
                        end
                    else
                        if podeFalar then
                             falaNumeroConv (numeroParaString (ord(s[i]) and $f), MASCULINO);
                end;
        end;
end;

{------------------------------------------------------------------------------}

procedure pilaReal (numero: real);
var
    s, exponente, exponente1, tamanoCadena, CadenaValor, exponente1R: string;
    l: int64;
    i{nDecimais}, tamano : integer;
    nExponente, nExponente1, NumeroExp : real;
    podeFalar: boolean;

begin

    if nDecimais = 0 then begin
      if frac(numero)>0.5 then begin
          numero:= INT(numero)+1;
      end;
    end;

     if (numero>9.999999999e14) or (numero<0.0001) AND (numero>0) or
     (numero<-9.999999999e14) or (numero>-0.0001) AND (numero<0)then begin
         s:= FloatToStr(numero);
         tamano:=Length(s);
         for i:=1 to tamano do begin
              if s[i]=',' then s[i]:='.';
              if s[i]='E' then break;
              exponente:=exponente+s[i];
         end;
         val(exponente,nExponente,cod);
         for i:=i+1 to tamano do begin
              exponente1:=exponente1+s[i];
         end;
         val(exponente1,nExponente1,cod);
         pilarealpequena(nExponente);
         sintSom('HPEEX');
         pilarealpequena(nExponente1);
         exit;
    end;

    if numero < 0 then
        begin
            sintSom ('HPMENOS');
            numero := -numero;
        end;

    l := trunc (numero+0.000000000001);

    {if (l>2000000000) then
        sintsoletra (intToStr (l))
    else
        falaNumeroConv (numeroParaString (l), MASCULINO);  }

    if (numero > 2000000000) and (numero<9.999999999e14) then begin
        //sintsoletra (intToStr (l))
        CadenaValor:= FloatToStr(numero);
        NumeroExp:=length(Cadenavalor);
        Valor28Exp:=NumeroExp-1;
        exponente1R:= FloatToStr(NumeroExp-1);
        CadenaValor:= CadenaValor[1]+','+CadenaValor[2]+CadenaValor[3];
        numero:= STRToFloat(CadenaValor);
        //Valor28:=aux^.valor;
        //numero:=valor28;
        pilarealpequena(numero);
        sintSom('HPEEX');
        pilarealpequena(valor28exp);
        exit;
    end else
        falaNumeroConv (numeroParaString (l), MASCULINO);

    if numero - trunc (numero) <> 0 then begin
        if numero - trunc (numero) < 0.001 then begin
            tamanoCadena:=FLOATTOSTR(numero);
            ndecimais:= Length(tamanoCadena)-2;
        end;
            str (numero:18:ndecimais, s);
            podeFalar := false;
            for i := 1 to length (s) do
                begin
                    if s[i] = '.' then
                        begin
                            sintSoletra ('.');  {virgula}
                            podeFalar := true;
                        end
                    else
                        if podeFalar then
                             falaNumeroConv (numeroParaString (ord(s[i]) and $f), MASCULINO);
                end;
        end;
end;

{------------------------------------------------------------------------------}

procedure pilaRealpequena (numero: real);
var
    s, exponente, exponente1: string;
    l: int64;
    i{nDecimais}, tamano: integer;
    nExponente, nExponente1: real;
    podeFalar: boolean;

begin

    if nDecimais = 0 then begin
      if frac(numero)>0.5 then begin
          numero:= INT(numero)+1;
      end;
    end;

    {if numero > 9.999999999e14 then begin
         s:= FloatToStr(numero);
         tamano:=Length(s);
         for i:=1 to tamano do begin
              if s[i]=',' then s[i]:='.';
              if s[i]='E' then break;
              exponente:=exponente+s[i];
         end;
         val(exponente,nExponente,cod);
         for i:=i+1 to tamano do begin
              exponente1:=exponente1+s[i];
         end;
         val(exponente1,nExponente1,cod);
         FalanumeroReal(nExponente);
         sintSom('HPEEX');
         pilareal(nExponente1);
         exit;
    end; }



    if numero < 0 then
        begin
            sintSom ('HPMENOS');
            numero := -numero;
        end;

    l := trunc (numero+0.000000000001);

    if l > 2000000000 then
        sintsoletra (intToStr (l))
    else
        falaNumeroConv (numeroParaString (l), MASCULINO);
    if numero - trunc (numero) <> 0 then
        begin
            str (numero:18:ndecimais, s);
            podeFalar := false;
            for i := 1 to length (s) do
                begin
                    if s[i] = '.' then
                        begin
                            sintSoletra ('.');  {virgula}
                            podeFalar := true;
                        end
                    else
                        if podeFalar then
                             falaNumeroConv (numeroParaString (ord(s[i]) and $f), MASCULINO);
                end;
        end;
end;



{------------------------------------------------------------------------------}
procedure mensajes (c: string);
begin
{-----------------------------4 Basicas----------------------------------------}
                          if  (c='/') then
                          begin
                                write(c);
                                sintSom ('HPdivide');
                          end;
                          if  (c='*') then
                          begin
                                write(c);
                                sintSom ('HPvezes');
                          end;
                          if  (c='-') then
                          begin
                                write(c);
                                sintSom ('HPmenos1');
                          end;
                          if  (c='+') then
                          begin
                                write(c);
                                sintSom ('HPmas');
                          end;
                          if  (c='t') then
                          begin
                                sintSom ('HPCHS');
                          end;
{--------------------------Funciones Generales---------------------------------}
                          if  (c='x') then
                          begin
                                write('1/x');
                                sintSom ('HPinverso');
                          end;
                          if  (c='X') then
                          begin
                                write('Sqrt');
                                sintSom ('HPraiz');
                          end;
                          if  (c=#24) then
                          begin
                                write('LN');
                                sintSom ('HPlogaritmo');
                          end;
                          if  (c='f') then
                          begin
                                write('n!');
                                sintSom ('HPfactorial');
                          end;
                          if  (c='g') then
                          begin
                                write('INTG');
                                sintSom ('HPparteint');
                          end;
                          if  (c='G') then
                          begin
                                write('FRAC');
                                sintSom ('HPpartefracc');
                          end;
                          if  (c='e') then
                          begin
                                textColor (Red);
                                write('E');
                                textColor (WHITE);
                          end;
                          if  (c='E') then
                          begin
                                write('e^x');
                                sintSom ('HPexponencial');
                          end;
                          if  (c=#5) then
                          begin
                                write('y^x');
                                sintSom ('HPelevado');
                          end;
{-----------------------------Porcentagem--------------------------------------}
                          if  (c='%') then
                          begin
                                write(c);
                                sintSom ('HPporcentaje');
                          end;
                          if  (c='y') then
                          begin
                                write('D%');
                                sintSom ('HPdifporcentaje');
                          end;
                          if  (c='Y') then
                          begin
                                write('%T');
                                sintSom ('HPtotporcentaje');
                          end;
{----------------------------Estatisticas--------------------------------------}
                          if  (c='z') then
                          begin
                                write('Z+ = ');
                                sintSom ('HPsumatoria');
                          end;
                          if  (c='Z') then
                          begin
                                write('Z-');
                                sintSom ('HPsumatoriaCorre');
                          end;
                          if  (c=#26) then
                          begin
                                write('Z-');
                                sintSom ('HPsumatoriaCorre');
                          end;
                          if  (c='q') then
                          begin
                                write('Media');
                                sintSom ('HPmedia');
                          end;
                          if  (c='Q') then
                          begin
                                write('Xw');
                                sintSom ('HPmediapon');
                          end;
                          if  (c=#17) then
                          begin
                                write('S');
                                sintSom ('HPdesviopa');
                          end;
                          if  (c='w') then
                          begin
                                write('ELx');
                                sintSom ('HPEstimax');
                          end;
                          if  (c='W') then
                          begin
                                write('ELy');
                                sintSom ('HPEstimay');
                          end;
                          if  (c=#23) then
                          begin
                                write('r');
                                sintSom ('HPcorrelacion');
                          end;
{-------------------------------Financeiras------------------------------------}
                          if  (c='n') or (c='N')then
                          begin

                                if c='n' then begin
                                    write('n');
                                    sintSom ('HPn');
                                end;
                                if c='N' then begin
                                    write('CALCULO n');
                                    sintSom ('HPnCalculo');
                                end;
                          end;
                          if  (c=#14) then
                          begin
                                write('n12X');
                                sintSom ('HPn12');
                          end;
                          if  (c='i') or (c='I') then
                          begin
                                if c='i' then begin
                                    write('i');
                                    sintSom ('HPi');
                                end;
                                if c='I' then begin
                                    write('CALCULO i');
                                    sintSom ('HPiCalculo');
                                end;
                          end;
                          if  (c=#9) then
                          begin
                                write('i12/');
                                sintSom ('HPi12');
                          end;
                          if  (c='p') or (c='P')then
                          begin
                                if c='p' then begin
                                    write('PV');
                                    sintSom ('HPpv');
                                end;
                                if c='P' then begin
                                    write('CALCULO PV');
                                    sintSom ('HPpvCalculo');
                                end;
                          end;
                          if  (c='m') or (c='M')then
                          begin
                                if c='m' then begin
                                    write('PMT');
                                    sintSom ('HPpmt');
                                end;
                                if c='M' then begin
                                    write('CALCULO PMT');
                                    sintSom ('HPpmtCalculo');
                                end;

                          end;
                          if  (c='v') or (c='V')then
                          begin
                                if c='v' then begin
                                    write('FV');
                                    sintSom ('HPfv');
                                end;
                                if c='V' then begin
                                    write('CALCULO FV');
                                    sintSom ('HPfvCalculo');
                                end;
                          end;
                          if  (c='k') then
                          begin
                                if vecesCfo > 1 then begin
                                write('CFj');
                                sintSom ('HPCFj');
                                end
                                else begin
                                write('CFo');
                                sintSom ('HPCFo');
                                end;
                          end;
                          if  (c='K') then
                          begin
                                write('NPV');
                                sintSom ('HPNPV');
                          end;
                          if  (c=#11) then
                          begin
                                write('Nj');
                                sintSom ('HPNj');
                          end;
                          if  (c='l') then
                          begin
                                write('DB');
                                sintSom ('HPDB');
                          end;
                          if  (c='L') then
                          begin
                                write('SL');
                                sintSom ('HPSL');
                          end;
                          if  (c=#12) then
                          begin
                                write('SOYD');
                                sintSom ('HPSOYD');
                          end;
                          if  (c='j') then
                          begin
                                write('JUROS SIMPLES');
                                sintSom ('HPintsimple');
                          end;
                          if  (c='J') then
                          begin
                                write('AMORTIZAO');
                                sintSom ('HPAmort');
                          end;
{--------------------------------Apaga-----------------------------------------}
                          if  (c='a') then
                          begin
                                write('APAGA R.DADOS');
                                sintSom ('HPcleartodo');
                          end;
                          if  (c='A') then
                          begin
                                write('APAGA R.ESTATISTICOS');
                                sintSom ('HPclearesta');
                          end;
                          if  (c=#1) then
                          begin
                                write('APAGA R.FINANCEIROS');
                                sintSom ('HPclearfin');
                          end;
                          if  (c='r') then
                          begin
                                write('RCL+');
                                sintSom ('HPrecupera');
                          end;
                          if  (c='R') then
                          begin
                                write('LSTX');
                                sintSom ('HPLSTX');
                          end;
                          if  (c='s') then
                          begin
                                write('STO+');
                                sintSom ('HPSTO');
                          end;
                          if  (c='d') then
                          begin
                                write('#DECIMAIS = ');
                                sintSom ('HPdecimais');
                          end;
                          if  (c='D') then
                          begin
                                write('D.MY');
                                sintSom ('HPDMY');
                          end;
                          if  (c=#4) then
                          begin
                                write('M.DY');
                                sintSom ('HPMDY');
                          end;
                          if  (c='h') then
                          begin
                                write('DDYS');
                                sintSom ('HPDDYS');
                          end;
                          if  (c='H') then
                          begin
                                write('DATE');
                                sintSom ('HPDATE');
                          end;
end;
{------------------------------------------------------------------------------}
procedure mensajesMeses (mes: real);
begin
                          if  (mes=1) then
                          begin
                                sintSom ('HPmesEnero');
                          end;
                          if  (mes=2) then
                          begin
                                sintSom ('HPmesFebrero');
                          end;
                          if  (mes=3) then
                          begin
                                sintSom ('HPmesMarzo');
                          end;
                          if  (mes=4) then
                          begin
                                sintSom ('HPmesAbril');
                          end;
                          if  (mes=5) then
                          begin
                                sintSom ('HPmesMayo');
                          end;
                          if  (mes=6) then
                          begin
                                sintSom ('HPmesJunio');
                          end;
                          if  (mes=7) then
                          begin
                                sintSom ('HPmesJulio');
                          end;
                          if  (mes=8) then
                          begin
                                sintSom ('HPmesAgosto');
                          end;
                          if  (mes=9) then
                          begin
                                sintSom ('HPmesSeptiembre');
                          end;
                          if  (mes=10) then
                          begin
                                sintSom ('HPmesOctubre');
                          end;
                          if  (mes=11) then
                          begin
                                sintSom ('HPmesNoviembre');
                          end;
                          if  (mes=12) then
                          begin
                                sintSom ('HPmesDiciembre');
                          end;

end;
{------------------------------------------------------------------------------}
procedure Errores(error: integer);
var i: integer;
begin
      case error of
      0:  begin
            write('ERRO 0. MATEMATICAS.');
            sintSom('HPerror0');
            writeln;
            exit;
          end;
      2:  begin
            write('ERRO 2. ESTATISTICAS.');
            sintSom('HPerror2');
            writeln;
            exit;
          end;
      5:  begin
            write('ERRO 5. JUROS COMPOSTOS.');
            sintSom('HPerror5');
            for i:=1 to LTarray do begin
              memoriafi[i]:=0;
            end;
            writeln;
            exit;
          end;
      6:  begin
            write('Erro 6. REGISTROS DE ARMAZENAMENTO.');
            sintSom('HPerror6');
            writeln;
            exit;
          end;
      8:  begin
            write('ERRO 8. CALENDARIO.');
            sintSom('HPerror8');
            writeln;
            exit;
          end;
      else
      end;
end;
{------------------------------------------------------------------------------}
procedure FuncionesTeclado;

var c: char;
    dondey, contador: integer;

label Regresa;
label Regresa1;

begin
          contador:=0;
          inicializaExemplos;
          sintSom ('HPF2TestarTeclado');
          delay(100);
          sintSom ('HPF2TestarTeclado1');
          repeat
          Regresa:
          c:=readkey;
          Regresa1:
          dondey:=wherey;
          if (c='<') then begin
              sintSom ('HPTECLAINV');
              goto regresa;
          end;
          if (c<>#20) then begin
                          if ( c = #0 )then begin
                              c:=readkey;
                              if ( c in [#59..#67] )then begin        //F1,F3-F9
                                  SintCarac('F');
                                  if c=#59 then begin
                                      write('F1');
                                      SintCarac('1');
                                  end;
                                  if c=#60 then begin
                                      write('F2');
                                      SintCarac('2');
                                  end;
                                  if c=#61 then begin
                                      write('F3');
                                      SintCarac('3');
                                  end;
                                  if c=#62 then begin
                                      write('F4');
                                      SintCarac('4');
                                  end;
                                  if c=#63 then begin
                                      write('F5');
                                      SintCarac('5');
                                  end;
                                  if c=#64 then begin
                                      write('F6');
                                      SintCarac('6');
                                  end;
                                  if c=#65 then begin
                                      write('F7');
                                      SintCarac('7');
                                  end;
                                  if c=#66 then begin
                                      write('F8');
                                      SintCarac('8');
                                  end;
                                  if c=#67 then begin
                                      write('F9');
                                      SintCarac('9');
                                  end;
                                  delay(100);
                                  sintSom ('HPfuncion');
                                  gotoxy(26,dondey);
                                  write('Tecla de Ajuda');
                                  gotoxy(60,dondey);
                                  writeln('Ajuda');
                                  delay(100);
                                  sintSom ('HPF1-F9');
                              end else
                              if ( c = #77 )then begin       // Flecha derecha
                                  write('Seta para a direita');
                                  gotoxy(26,dondey);
                                  write('Primer Registro da Pilha');
                                  gotoxy(60,dondey);
                                  writeln('Comando');
                                  sintSom ('HPSetaD');
                                  sintSom ('HPfuncion');
                                  delay(100);
                                  sintSom('HPPilaPrimero');
                              end else
                              if ( c = #75 )then begin       // Flecha izquierda
                                  write('Seta para a esquerda');
                                  gotoxy(26,dondey);
                                  write('Registros da Pilha');
                                  gotoxy(60,dondey);
                                  writeln('Comando');
                                  sintSom ('HPSetaE');
                                  sintSom ('HPfuncion');
                                  delay(100);
                                  sintSom('HPXYZT');
                              end else
                              if ( c = #80 )then begin       // Flecha para abajo
                                  write('Seta para baixo');
                                  gotoxy(26,dondey);
                                  write('Rolagem da Pila');
                                  gotoxy(60,dondey);
                                  writeln('Comando');
                                  sintSom ('HPSetaB');
                                  sintSom ('HPfuncion');
                                  delay(100);
                                  sintSom('HPROTAPILA');
                              end else
                              if ( c =#72)then begin        //Flecha para arriba
                                  write('Seta para cima');
                                  gotoxy(26,dondey);
                                  write('Troca X por Y');
                                  gotoxy(60,dondey);
                                  writeln('Comando');
                                  sintSom ('HPSetaC');
                                  sintSom ('HPfuncion');
                                  delay(100);
                                  sintSom('HPCAMBIAXY');
                              end else
                              if ( c = #73 )then begin       // PGUP
                                  writeln('PGUP');
                                  gotoxy(26,dondey);
                                  writeln('Tipo de periodo');
                                  gotoxy(60,dondey);
                                  writeln('Reg. Financeiros');
                                  sintSom ('HPSetaPGUP');
                                  sintSom ('HPfuncion');
                                  delay(100);
                                  sintSom ('HPPGUP');
                              end else begin
                              sintSom ('HPTECLAINV');
                              end;
                          end else
                          if (c = #$08) then begin
                              writeln('BACK SPACE');
                              gotoxy(26,dondey);
                              writeln('Apagado');
                              gotoxy(60,dondey);
                              writeln('Comando');
                              sintSom ('HPBACKSPACE');
                              sintSom ('HPfuncion');
                              delay(100);
                              sintSom('HPBORRADO');
                          end else
                          if (c = ENTER) then begin
                              writeln('ENTER');
                              gotoxy(26,dondey);
                              writeln('ENTER');
                              gotoxy(60,dondey);
                              writeln('Comando');
                              sintSom('HPENTER');
                          end else
                          if (c= #$1b) then begin // cuando presiona ESC
                              sintSom('HPESC');
                              c:=#20;
                              goto regresa1;
                          end else
{------------------------Ingreso de Nmeros------------------------------------}
                          if c in ['0'..'9', '.'] then begin
                              writeln(c);
                              gotoxy(26,dondey);
                              write('Numero');
                              gotoxy(60,dondey);
                              writeln('Numero');
                              sintCarac (c);
                          end else
{-----------------------------4 Basicas----------------------------------------}
                          if  (c='/') then begin
                              writeln(c);
                              gotoxy(26,dondey);
                              write('Diviso');
                              gotoxy(60,dondey);
                              writeln('Op. Basicas');
                              sintCarac ('/');
                              sintSom ('HPfuncion');
                              sintSom ('HPdividir');
                              //sintSom ('HPdivide');
                          end else
                          if  (c='*') then begin
                              writeln(c);
                              gotoxy(26,dondey);
                              write('Multiplicao');
                              gotoxy(60,dondey);
                              writeln('Op. Basicas');
                              sintCarac ('*');
                              sintSom ('HPfuncion');
                              sintSom ('HPmultiplicar');
                              //sintSom ('HPvezes');
                          end else
                          if  (c='-') then begin
                              writeln(c);
                              gotoxy(26,dondey);
                              write('Subtrao');
                              gotoxy(60,dondey);
                              writeln('Op. Basicas');
                              sintCarac ('-');
                              sintSom ('HPfuncion');
                              sintSom ('HPrestar');
                              //sintSom ('HPmenos1');
                          end else
                          if  (c='+') then
                          begin
                              writeln(c);
                              gotoxy(26,dondey);
                              write('Soma');
                              gotoxy(60,dondey);
                              writeln('Op. Basicas');
                              sintCarac ('+');
                              sintSom ('HPfuncion');
                              sintSom ('HPSumar');
                              //sintSom ('HPmas');
                          end else
                          if  (c='t') then
                          begin
                              writeln('T');
                              gotoxy(26,dondey);
                              write('Troca o sinal');
                              gotoxy(60,dondey);
                              writeln('Comando');
                              sintCarac ('t');
                              sintSom ('HPfuncion');
                              sintSom ('HPCHS');
                          end else
{--------------------------Funciones Generales---------------------------------}
                          if  (c='x') then
                          begin
                              writeln('X');
                              gotoxy(26,dondey);
                              writeln('Inverso 1/x');
                              gotoxy(60,dondey);
                              writeln('Fun. Gerais');
                              sintCarac ('x');
                              sintSom ('HPfuncion');
                              sintSom ('HPinverso');
                          end else
                          if  (c='X') then
                          begin
                              writeln('SHIFT + X');
                              gotoxy(26,dondey);
                              writeln('Raiz Quadrada SQRT');
                              gotoxy(60,dondey);
                              writeln('Fun. Gerais');
                              sintSom ('HPSHIFT');
                              sintCarac ('x');
                              sintSom ('HPfuncion');
                              sintSom ('HPraiz');
                          end else
                          if  (c=#24) then
                          begin
                              writeln('CTRL + X');
                              gotoxy(26,dondey);
                              writeln('Logaritmo Natural LN');
                              gotoxy(60,dondey);
                              writeln('Fun. Gerais');
                              sintSom ('HPControl');
                              sintCarac ('x');
                              sintSom ('HPfuncion');
                              sintSom ('HPlogaritmo');
                          end else
                          if  (c='f') then
                          begin
                              writeln('F');
                              gotoxy(26,dondey);
                              writeln('Fatorial n!');
                              gotoxy(60,dondey);
                              writeln('Fun. Gerais');
                              sintCarac ('f');
                              sintSom ('HPfuncion');
                              sintSom ('HPfactorial');
                          end else
                          if  (c=#6) then
                          begin
                              writeln('CTRL  + F');
                              gotoxy(26,dondey);
                              writeln('Menu Calculadora');
                              gotoxy(60,dondey);
                              writeln('Menu');
                              sintSom ('HPControl');
                              sintCarac ('f');
                              sintSom ('HPfuncion');
                              sintSom ('HPfungen');
                          end else
                          if  (c='g') then
                          begin
                              writeln('G');
                              gotoxy(26,dondey);
                              writeln('Parte inteira INTG');
                              gotoxy(60,dondey);
                              writeln('Fun. Gerais');
                              sintCarac ('g');
                              sintSom ('HPfuncion');
                              sintSom ('HPparteint');
                          end else
                          if  (c='G') then
                          begin
                              writeln('SHIFT + G');
                              gotoxy(26,dondey);
                              writeln('Parte Fraccionaria FRAC');
                              gotoxy(60,dondey);
                              writeln('Fun. Gerais');
                              sintSom ('HPSHIFT');
                              sintCarac ('g');
                              sintSom ('HPfuncion');
                              sintSom ('HPpartefracc');
                          end else
                          if  (c='e') then
                          begin
                              writeln('E');
                              gotoxy(26,dondey);
                              write('Expoente ');
                              textColor (Red);
                              write('E');
                              textColor (WHITE);
                              gotoxy(60,dondey);
                              writeln('Comando');
                              sintCarac ('e');
                              sintSom ('HPfuncion');
                              sintSom('HPEEX');

                          end else
                          if  (c='E') then
                          begin
                              writeln('SHIFT + E');
                              gotoxy(26,dondey);
                              writeln('Exponencial e^x');
                              gotoxy(60,dondey);
                              writeln('Fun. Gerais');
                              sintSom ('HPSHIFT');
                              sintCarac ('e');
                              sintSom ('HPfuncion');
                              sintSom ('HPexponencial');
                          end else
                          if  (c=#5) then
                          begin
                              writeln('CTRL + E');
                              gotoxy(26,dondey);
                              writeln('Potencia y^x');
                              gotoxy(60,dondey);
                              writeln('Fun. Gerais');
                              sintSom ('HPControl');
                              sintCarac ('e');
                              sintSom ('HPfuncion');
                              sintSom ('HPelevado');
                          end else
{-----------------------------Porcentagem--------------------------------------}
                          if  (c='%') then
                          begin
                              writeln(c);
                              gotoxy(26,dondey);
                              writeln('Porcentagem');
                              gotoxy(60,dondey);
                              writeln('Fun. Porcentagem');
                              sintCarac ('%');
                              sintSom ('HPfuncion');
                              sintSom ('HPporcentaje');
                          end else
                          if  (c='y') then
                          begin
                              writeln('Y');
                              gotoxy(26,dondey);
                              writeln('Diferena Porcentual D%');
                              gotoxy(60,dondey);
                              writeln('Fun. Porcentagem');
                              sintCarac ('y');
                              sintSom ('HPfuncion');
                              sintSom ('HPdifporcentaje');
                          end else
                          if  (c='Y') then
                          begin
                              writeln('SHIFT + Y');
                              gotoxy(26,dondey);
                              writeln('Porcentagem do Total %T');
                              gotoxy(60,dondey);
                              writeln('Fun. Porcentagem');
                              sintSom ('HPSHIFT');
                              sintCarac ('y');
                              sintSom ('HPfuncion');
                              sintSom ('HPtotporcentaje');
                          end else
{----------------------------Estatisticas--------------------------------------}
                          if  (c='z') then
                          begin
                              writeln('Z');
                              gotoxy(26,dondey);
                              writeln('Acumulao Estatsticas Z+');
                              gotoxy(60,dondey);
                              writeln('Fun. Estatisticas');
                              sintCarac ('z');
                              sintSom ('HPfuncion');
                              sintSom ('HPsumatoria');
                          end else
                          if  (c='Z') then
                          begin
                              writeln('SHIFT + Z');
                              gotoxy(26,dondey);
                              writeln('Correo Estatsticas Z-');
                              gotoxy(60,dondey);
                              writeln('Fun. Estatisticas');
                              sintSom ('HPSHIFT');
                              sintCarac ('z');
                              sintSom ('HPfuncion');
                              sintSom ('HPsumatoriaCorre');
                          end else
                          if  (c=#26) then
                          begin
                              writeln('CTRL + Z');
                              gotoxy(26,dondey);
                              writeln('Correo Estatsticas Z-');
                              gotoxy(60,dondey);
                              writeln('Fun. Estatisticas');
                              sintSom ('HPControl');
                              sintCarac ('z');
                              sintSom ('HPfuncion');
                              sintSom ('HPsumatoriaCorre');
                          end else
                          if  (c='q') then
                          begin
                              writeln('Q');
                              gotoxy(26,dondey);
                              writeln('Media Aritmetica ');
                              gotoxy(60,dondey);
                              writeln('Fun. Estatisticas');
                              sintCarac ('q');
                              sintSom ('HPfuncion');
                              sintSom ('HPmedia');
                          end else
                          if  (c='Q') then
                          begin
                              writeln('SHIFT + Q');
                              gotoxy(26,dondey);
                              writeln('Media Ponderada Xw');
                              gotoxy(60,dondey);
                              writeln('Fun. Estatisticas');
                              sintSom ('HPSHIFT');
                              sintCarac ('q');
                              sintSom ('HPfuncion');
                              sintSom ('HPmediapon');
                          end else
                          if  (c=#17) then
                          begin
                              writeln('CTRL + Q');
                              gotoxy(26,dondey);
                              writeln('Desvio PadroS');
                              gotoxy(60,dondey);
                              writeln('Fun. Estatisticas');
                              sintSom ('HPControl');
                              sintCarac ('q');
                              sintSom ('HPfuncion');
                              sintSom ('HPdesviopa');
                          end else
                          if  (c='w') then
                          begin
                              writeln('W');
                              gotoxy(26,dondey);
                              writeln('EstimaolineardeX');
                              gotoxy(60,dondey);
                              writeln('Fun. Estatisticas');
                              sintCarac ('w');
                              sintSom ('HPfuncion');
                              sintSom ('HPEstimax');
                          end else
                          if  (c='W') then
                          begin
                              writeln('SHIFT + W');
                              gotoxy(26,dondey);
                              writeln('EstimaolineardeY');
                              gotoxy(60,dondey);
                              writeln('Fun. Estatisticas');
                              sintSom ('HPSHIFT');
                              sintCarac ('w');
                              sintSom ('HPfuncion');
                              sintSom ('HPEstimay');
                          end else
                          if  (c=#23) then
                          begin
                              writeln('CTRL + W');
                              gotoxy(26,dondey);
                              writeln('Coeficientedecorrelao');
                              gotoxy(60,dondey);
                              writeln('Fun. Estatisticas');
                              sintSom ('HPControl');
                              sintCarac ('w');
                              sintSom ('HPfuncion');
                              sintSom ('HPcorrelacion');
                          end else
{-------------------------------Financeiras------------------------------------}
                          if  (c='n') or (c='N')then
                          begin
                                if c='n' then begin
                                    writeln('N');
                                    gotoxy(26,dondey);
                                    writeln('Numero de perodos');
                                    gotoxy(60,dondey);
                                    writeln('Reg. Financeiros');
                                    sintCarac (c);
                                    delay(100);
                                    sintSom('HPfuncion');
                                    delay(100);
                                    sintSom('HPArmazena');
                                    sintSom ('HPn');
                                end;
                                if c='N' then begin
                                    writeln('SHIFT + N');
                                    gotoxy(26,dondey);
                                    writeln('Clculo Numero de perodos');
                                    gotoxy(60,dondey);
                                    writeln('Fun. Financeiras');
                                    sintSom('HPShift');
                                    sintCarac ('n');
                                    delay(100);
                                    sintSom('HPfuncion');
                                    delay(100);
                                    sintSom ('HPnCalculo');
                                end;
                          end else
                          if  (c=#14) then
                          begin
                                writeln('CTRL + N');
                                gotoxy(26,dondey);
                                writeln('Numero de perodos 12 vezes');
                                gotoxy(60,dondey);
                                writeln('Reg. Financeiros');
                                sintSom('HPControl');
                                sintCarac ('n');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom('HPArmazena');
                                sintSom ('HPn12');
                          end else
                          if  (c='i') or (c='I') then
                          begin
                                if c='i' then begin
                                    writeln('I');
                                    gotoxy(26,dondey);
                                    writeln('Taxa de Juros');
                                    gotoxy(60,dondey);
                                    writeln('Reg. Financeiros');
                                    sintCarac (c);
                                    delay(100);
                                    sintSom('HPfuncion');
                                    delay(100);
                                    sintSom('HPArmazena');
                                    sintSom ('HPi');
                                end;
                                if c='I' then begin
                                    writeln('SHIFT + I');
                                    gotoxy(26,dondey);
                                    writeln('Calculo Taxa de Juros');
                                    gotoxy(60,dondey);
                                    writeln('Fun. Financeiras');
                                    sintSom('HPShift');
                                    sintCarac ('i');
                                    delay(100);
                                    sintSom('HPfuncion');
                                    delay(100);
                                    sintSom ('HPiCalculo');
                                end;
                          end else
                          if  (c=#9) then begin
                              writeln('CTRL + I');
                              gotoxy(26,dondey);
                              writeln('Taxa de Juros dividido 12');
                              gotoxy(60,dondey);
                              writeln('Reg. Financeiros');
                              sintSom('HPControl');
                              sintCarac ('i');
                              delay(100);
                              sintSom('HPfuncion');
                              delay(100);
                              sintSom('HPArmazena');
                              sintSom ('HPi12');
                          end else
                          if  (c='p') or (c='P')then
                          begin
                                if c='p' then begin
                                    writeln('P');
                                    gotoxy(26,dondey);
                                    writeln('Valor Presente');
                                    gotoxy(60,dondey);
                                    writeln('Reg. Financeiros');
                                    sintCarac ('p');
                                    delay(100);
                                    sintSom('HPfuncion');
                                    delay(100);
                                    sintSom('HPArmazena');
                                    sintSom ('HPpv');
                                end;
                                if c='P' then begin
                                    writeln('SHIFT + B');
                                    gotoxy(26,dondey);
                                    writeln('Calculo Valor Presente');
                                    gotoxy(60,dondey);
                                    writeln('Fun. Financeiras');
                                    sintSom('HPShift');
                                    sintCarac ('p');
                                    delay(100);
                                    sintSom('HPfuncion');
                                    delay(100);
                                    sintSom ('HPpvCalculo');
                                end;
                          end else
                          if  (c='m') or (c='M')then
                          begin
                                if c='m' then begin
                                    writeln('M');
                                    gotoxy(26,dondey);
                                    writeln('Pagamento Periodico');
                                    gotoxy(60,dondey);
                                    writeln('Reg. Financeiros');
                                    sintCarac ('m');
                                    delay(100);
                                    sintSom('HPfuncion');
                                    delay(100);
                                    sintSom('HPArmazena');
                                    sintSom ('HPpmt');
                                end;
                                if c='M' then begin
                                    writeln('SHIFT + M');
                                    gotoxy(26,dondey);
                                    writeln('Calculo Pagamento Periodico');
                                    gotoxy(60,dondey);
                                    writeln('Fun. Financeiras');
                                    sintSom('HPShift');
                                    sintCarac ('m');
                                    delay(100);
                                    sintSom('HPfuncion');
                                    delay(100);
                                    sintSom ('HPpmtCalculo');
                                end;
                          end else
                          if ( c = #10)then begin       // BEG, END
                                writeln('CTRL + M');
                                gotoxy(26,dondey);
                                writeln('Modo de Pagamento BEG/END');
                                gotoxy(60,dondey);
                                writeln('Reg. Financeiros');
                                sintSom('HPControl');
                                sintCarac ('m');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom('HPArmazena');
                                sintSom ('HPBEGEND');
                          end else
                          if  (c='v') or (c='V')then
                          begin
                                if c='v' then begin
                                    writeln('V');
                                    gotoxy(26,dondey);
                                    writeln('Valor Futuro');
                                    gotoxy(60,dondey);
                                    writeln('Reg. Financeiros');
                                    sintCarac ('v');
                                    delay(100);
                                    sintSom('HPfuncion');
                                    delay(100);
                                    sintSom('HPArmazena');
                                    sintSom ('HPfv');
                                end;
                                if c='V' then begin
                                    writeln('SHIFT + V');
                                    gotoxy(26,dondey);
                                    writeln('Calculo Valor Futuro');
                                    gotoxy(60,dondey);
                                    writeln('Fun. Financeiras');
                                    sintSom('HPShift');
                                    sintCarac ('v');
                                    delay(100);
                                    sintSom('HPfuncion');
                                    delay(100);
                                    sintSom ('HPfvCalculo');
                                end;
                          end else
                          if  (c='k') then
                          begin
                                writeln('K');
                                gotoxy(26,dondey);
                                writeln('Fluxo de Caixa Cfo/Cfj');
                                gotoxy(60,dondey);
                                writeln('Reg. Financeiros');
                                sintCarac ('k');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom('HPArmazena');
                                sintSom ('HPCFj');
                          end else
                          if  (c='K') then
                          begin
                                writeln('SHIFT + K');
                                gotoxy(26,dondey);
                                writeln('Valor Presente Liquido');
                                gotoxy(60,dondey);
                                writeln('Fun. Financeiras');
                                sintSom('HPShift');
                                sintCarac ('k');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPNPV');
                          end else
                          if  (c=#11) then
                          begin
                                writeln('CTRL + K');
                                gotoxy(26,dondey);
                                writeln('Fluxo de Caixa Repetido Nj');
                                gotoxy(60,dondey);
                                writeln('Reg. Financeiros');
                                sintSom('HPControl');
                                sintCarac ('k');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPNj');
                          end else
                          if  (c='l') then
                          begin
                                writeln('L');
                                gotoxy(26,dondey);
                                writeln('Dep. Saldos Decrescentes DB');
                                gotoxy(60,dondey);
                                writeln('Fun. Financeiras');
                                sintCarac ('l');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPDB');
                          end else
                          if  (c='L') then
                          begin
                                writeln('SHIFT + L');
                                gotoxy(26,dondey);
                                writeln('Dep. linear SL');
                                gotoxy(60,dondey);
                                writeln('Fun. Financeiras');
                                sintSom('HPShift');
                                sintCarac ('l');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPSL');
                          end else
                          if  (c=#12) then
                          begin
                                writeln('CTRL + L');
                                gotoxy(26,dondey);
                                writeln('Dep. Soma Digitos Anos SOYD');
                                gotoxy(60,dondey);
                                writeln('Fun. Financeiras');
                                sintSom('HPControl');
                                sintCarac ('l');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPSOYD');
                          end else
                          if  (c='j') then
                          begin
                                writeln('J');
                                gotoxy(26,dondey);
                                writeln('Juros Simples');
                                gotoxy(60,dondey);
                                writeln('Fun. Financeiras');
                                sintCarac ('j');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPintsimple');
                          end else
                          if  (c='J') then
                          begin
                                writeln('SHIFT + J');
                                gotoxy(26,dondey);
                                writeln('Amortizao');
                                gotoxy(60,dondey);
                                writeln('Fun. Financeiras');
                                sintSom('HPShift');
                                sintCarac ('j');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPAmort');
                          end else
{--------------------------------Apaga-----------------------------------------}
                          if  (c='a') then
                          begin
                                writeln('A');
                                gotoxy(26,dondey);
                                writeln('Apaga Registro Dados Geral');
                                gotoxy(60,dondey);
                                writeln('Comando');
                                sintCarac ('a');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPcleartodo');
                          end else
                          if  (c='A') then
                          begin
                                writeln('SHIFT + A');
                                gotoxy(26,dondey);
                                writeln('Apaga Registros Estatisticos');
                                gotoxy(60,dondey);
                                writeln('Comando');
                                sintSom('HPShift');
                                sintCarac ('a');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPclearesta');
                          end else
                          if  (c=#1) then
                          begin
                                writeln('CTRL + A');
                                gotoxy(26,dondey);
                                writeln('Apaga Registros Financeiros');
                                gotoxy(60,dondey);
                                writeln('Comando');
                                sintSom('HPControl');
                                sintCarac ('a');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPclearfin');
                          end else
                          if  (c='r') then
                          begin
                                writeln('R');
                                gotoxy(26,dondey);
                                writeln('Recuperao de Dados RCL+');
                                gotoxy(60,dondey);
                                writeln('Comando');
                                sintCarac ('r');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPrecupera');
                          end else
                          if  (c='R') then
                          begin
                                writeln('SHIFT + R');
                                gotoxy(26,dondey);
                                writeln('Recupera o ltimo nmero LSTX');
                                gotoxy(60,dondey);
                                writeln('Comando');
                                sintSom('HPShift');
                                sintCarac ('r');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPLSTX');
                          end else
                          if  (c='s') then
                          begin
                                writeln('S');
                                gotoxy(26,dondey);
                                writeln('Armazenamento de Dados STO+');
                                gotoxy(60,dondey);
                                writeln('Comando');
                                sintCarac ('s');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPSTO');
                          end else
                          if  (c='d') then
                          begin
                                writeln('D');
                                gotoxy(26,dondey);
                                writeln('Configuraes decimais');
                                gotoxy(60,dondey);
                                writeln('Comando');
                                sintCarac ('d');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPdecimais');
                          end else
                          if  (c='D') then
                          begin
                                writeln('SHIFT + D');
                                gotoxy(26,dondey);
                                writeln('Formato de Data D.MY');
                                gotoxy(60,dondey);
                                writeln('Fun. Data');
                                sintSom('HPShift');
                                sintCarac ('d');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPDMY');
                          end else
                          if  (c=#4) then
                          begin
                                writeln('CTRL + D');
                                gotoxy(26,dondey);
                                writeln('Formato de Data M.DY');
                                gotoxy(60,dondey);
                                writeln('Fun. Data');
                                sintSom('HPControl');
                                sintCarac ('d');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPMDY');
                          end else
                          if  (c='h') then
                          begin
                                writeln('H');
                                gotoxy(26,dondey);
                                writeln('Nmero de das entre Datas');
                                gotoxy(60,dondey);
                                writeln('Fun. Data');
                                sintCarac ('h');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPDDYS');
                          end else
                          if  (c='H') then
                          begin
                                writeln('SHIFT + H');
                                gotoxy(26,dondey);
                                writeln('Datas Futuras/Passadas');
                                gotoxy(60,dondey);
                                writeln('Fun.Data');
                                sintSom('HPShift');
                                sintCarac ('h');
                                delay(100);
                                sintSom('HPfuncion');
                                delay(100);
                                sintSom ('HPDATE');
                          end else begin
                              sintSom ('HPTECLAINV');
                              contador:=contador-1;
                          end;
              contador:=contador+1;
              if contador=13 then begin
                  inicializaExemplos;
                  contador:=0;
              end;
          end;
          until c=#20;

end;
{------------------------------------------------------------------------------}
procedure ReproduceDigitado (c: string);
begin
{-----------------------------Numeros------------------------------------------}
                          if NumeroGeneral= TRUE then begin
                              val(c,v1,cod);
                              pilaReal (v1);
                          end;
{-----------------------------4 Basicas----------------------------------------}
                          if  (c='/') then sintSom ('HPdivide');
                          if  (c='*') then sintSom ('HPvezes');
                          if  (c='-') then sintSom ('HPmenos1');
                          if  (c='+') then sintSom ('HPmas');
                          if  (c='t') then sintSom ('HPCHS');
{--------------------------Funciones Generales---------------------------------}
                          if  (c='x') then sintSom ('HPinverso');
                          if  (c='X') then sintSom ('HPraiz');
                          if  (c=#24) then sintSom ('HPlogaritmo');
                          if  (c='f') then sintSom ('HPfactorial');
                          if  (c='g') then sintSom ('HPparteint');
                          if  (c='G') then sintSom ('HPpartefracc');
                          if  (c='e') then sintSom('HPEEX');
                          if  (c='E') then sintSom ('HPexponencial');
                          if  (c=#5) then sintSom ('HPelevado');
{-----------------------------Porcentagem--------------------------------------}
                          if  (c='%') then sintSom ('HPporcentaje');
                          if  (c='y') then sintSom ('HPdifporcentaje');
                          if  (c='Y') then sintSom ('HPtotporcentaje');
{----------------------------Estatisticas--------------------------------------}
                          if  (c='z') then sintSom ('HPsumatoria');
                          if  (c='Z') then sintSom ('HPsumatoriaCorre');
                          if  (c=#26) then sintSom ('HPsumatoriaCorre');
                          if  (c='q') then sintSom ('HPmedia');
                          if  (c='Q') then sintSom ('HPmediapon');
                          if  (c=#17) then sintSom ('HPdesviopa');
                          if  (c='w') then sintSom ('HPEstimax');
                          if  (c='W') then sintSom ('HPEstimay');
                          if  (c=#23) then sintSom ('HPcorrelacion');
{-------------------------------Financeiras------------------------------------}
                          if  (c='n') then sintSom ('HPn');
                          if  (c='N') then sintSom ('HPnCalculo');
                          if  (c=#14) then sintSom ('HPn12');
                          if  (c='i') then sintSom ('HPi');
                          if  (c='I') then sintSom ('HPiCalculo');
                          if  (c=#9)  then sintSom ('HPi12');
                          if  (c='p') then sintSom ('HPpv');
                          if  (c='P') then sintSom ('HPpvCalculo');
                          if  (c='m') then sintSom ('HPpmt');
                          if  (c='M') then sintSom ('HPpmtCalculo');
                          if  (c='v') then sintSom ('HPfv');
                          if  (c='V') then sintSom ('HPfvCalculo');
                          if  (c='k') then
                          begin
                                if vecesCfo > 1 then begin
                                sintSom ('HPCFj');
                                end
                                else begin
                                sintSom ('HPCFo');
                                end;
                          end;
                          if  (c='K') then sintSom ('HPNPV');
                          if  (c=#11) then sintSom ('HPNj');
                          if  (c='l') then sintSom ('HPDB');
                          if  (c='L') then sintSom ('HPSL');
                          if  (c=#12) then sintSom ('HPSOYD');
                          if  (c='j') then sintSom ('HPintsimple');
                          if  (c='J') then sintSom ('HPAmort');
{--------------------------------Apaga-----------------------------------------}
                          if  (c='a') then sintSom ('HPcleartodo');
                          if  (c='A') then sintSom ('HPclearesta');
                          if  (c=#1)  then sintSom ('HPclearfin');
                          if  (c='r') then sintSom ('HPrecupera');
                          if  (c='R') then sintSom ('HPLSTX');
                          if  (c='s') then sintSom ('HPSTO');
                          if  (c='d') then sintSom ('HPdecimais');
                          if  (c='D') then sintSom ('HPDMY');
                          if  (c=#4)  then sintSom ('HPMDY');
                          if  (c='h') then sintSom ('HPDDYS');
                          if  (c='H') then sintSom ('HPDATE');
                          if  (c='') then sintSom ('HPnada');
end;
{------------------------------------------------------------------------------}




end.
